// This file is generated by TypeBuilder_cpp.template.

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#include "content/browser/devtools/protocol/preload.h"

#include "content/browser/devtools/protocol/protocol.h"

#include "third_party/inspector_protocol/crdtp/cbor.h"
#include "third_party/inspector_protocol/crdtp/find_by_first.h"
#include "third_party/inspector_protocol/crdtp/span.h"

namespace content {
namespace protocol {
namespace Preload {

using crdtp::DeserializerState;
using crdtp::ProtocolTypeTraits;

// ------------- Enum values from types.

const char Metainfo::domainName[] = "Preload";
const char Metainfo::commandPrefix[] = "Preload.";
const char Metainfo::version[] = "1.3";

namespace SpeculationActionEnum {
const char Prefetch[] = "Prefetch";
const char Prerender[] = "Prerender";
} // namespace SpeculationActionEnum


namespace SpeculationTargetHintEnum {
const char Blank[] = "Blank";
const char Self[] = "Self";
} // namespace SpeculationTargetHintEnum


CRDTP_BEGIN_DESERIALIZER(PreloadingAttemptKey)
    CRDTP_DESERIALIZE_FIELD("action", m_action),
    CRDTP_DESERIALIZE_FIELD("loaderId", m_loaderId),
    CRDTP_DESERIALIZE_FIELD_OPT("targetHint", m_targetHint),
    CRDTP_DESERIALIZE_FIELD("url", m_url),
CRDTP_END_DESERIALIZER()

CRDTP_BEGIN_SERIALIZER(PreloadingAttemptKey)
    CRDTP_SERIALIZE_FIELD("loaderId", m_loaderId);
    CRDTP_SERIALIZE_FIELD("action", m_action);
    CRDTP_SERIALIZE_FIELD("url", m_url);
    CRDTP_SERIALIZE_FIELD("targetHint", m_targetHint);
CRDTP_END_SERIALIZER();


namespace PrerenderFinalStatusEnum {
const char Activated[] = "Activated";
const char Destroyed[] = "Destroyed";
const char LowEndDevice[] = "LowEndDevice";
const char InvalidSchemeRedirect[] = "InvalidSchemeRedirect";
const char InvalidSchemeNavigation[] = "InvalidSchemeNavigation";
const char InProgressNavigation[] = "InProgressNavigation";
const char NavigationRequestBlockedByCsp[] = "NavigationRequestBlockedByCsp";
const char MainFrameNavigation[] = "MainFrameNavigation";
const char MojoBinderPolicy[] = "MojoBinderPolicy";
const char RendererProcessCrashed[] = "RendererProcessCrashed";
const char RendererProcessKilled[] = "RendererProcessKilled";
const char Download[] = "Download";
const char TriggerDestroyed[] = "TriggerDestroyed";
const char NavigationNotCommitted[] = "NavigationNotCommitted";
const char NavigationBadHttpStatus[] = "NavigationBadHttpStatus";
const char ClientCertRequested[] = "ClientCertRequested";
const char NavigationRequestNetworkError[] = "NavigationRequestNetworkError";
const char MaxNumOfRunningPrerendersExceeded[] = "MaxNumOfRunningPrerendersExceeded";
const char CancelAllHostsForTesting[] = "CancelAllHostsForTesting";
const char DidFailLoad[] = "DidFailLoad";
const char Stop[] = "Stop";
const char SslCertificateError[] = "SslCertificateError";
const char LoginAuthRequested[] = "LoginAuthRequested";
const char UaChangeRequiresReload[] = "UaChangeRequiresReload";
const char BlockedByClient[] = "BlockedByClient";
const char AudioOutputDeviceRequested[] = "AudioOutputDeviceRequested";
const char MixedContent[] = "MixedContent";
const char TriggerBackgrounded[] = "TriggerBackgrounded";
const char MemoryLimitExceeded[] = "MemoryLimitExceeded";
const char FailToGetMemoryUsage[] = "FailToGetMemoryUsage";
const char DataSaverEnabled[] = "DataSaverEnabled";
const char HasEffectiveUrl[] = "HasEffectiveUrl";
const char ActivatedBeforeStarted[] = "ActivatedBeforeStarted";
const char InactivePageRestriction[] = "InactivePageRestriction";
const char StartFailed[] = "StartFailed";
const char TimeoutBackgrounded[] = "TimeoutBackgrounded";
const char CrossSiteRedirectInInitialNavigation[] = "CrossSiteRedirectInInitialNavigation";
const char CrossSiteNavigationInInitialNavigation[] = "CrossSiteNavigationInInitialNavigation";
const char SameSiteCrossOriginRedirectNotOptInInInitialNavigation[] = "SameSiteCrossOriginRedirectNotOptInInInitialNavigation";
const char SameSiteCrossOriginNavigationNotOptInInInitialNavigation[] = "SameSiteCrossOriginNavigationNotOptInInInitialNavigation";
const char ActivationNavigationParameterMismatch[] = "ActivationNavigationParameterMismatch";
const char ActivatedInBackground[] = "ActivatedInBackground";
const char EmbedderHostDisallowed[] = "EmbedderHostDisallowed";
const char ActivationNavigationDestroyedBeforeSuccess[] = "ActivationNavigationDestroyedBeforeSuccess";
const char TabClosedByUserGesture[] = "TabClosedByUserGesture";
const char TabClosedWithoutUserGesture[] = "TabClosedWithoutUserGesture";
const char PrimaryMainFrameRendererProcessCrashed[] = "PrimaryMainFrameRendererProcessCrashed";
const char PrimaryMainFrameRendererProcessKilled[] = "PrimaryMainFrameRendererProcessKilled";
const char ActivationFramePolicyNotCompatible[] = "ActivationFramePolicyNotCompatible";
const char PreloadingDisabled[] = "PreloadingDisabled";
const char BatterySaverEnabled[] = "BatterySaverEnabled";
const char ActivatedDuringMainFrameNavigation[] = "ActivatedDuringMainFrameNavigation";
const char PreloadingUnsupportedByWebContents[] = "PreloadingUnsupportedByWebContents";
const char CrossSiteRedirectInMainFrameNavigation[] = "CrossSiteRedirectInMainFrameNavigation";
const char CrossSiteNavigationInMainFrameNavigation[] = "CrossSiteNavigationInMainFrameNavigation";
const char SameSiteCrossOriginRedirectNotOptInInMainFrameNavigation[] = "SameSiteCrossOriginRedirectNotOptInInMainFrameNavigation";
const char SameSiteCrossOriginNavigationNotOptInInMainFrameNavigation[] = "SameSiteCrossOriginNavigationNotOptInInMainFrameNavigation";
const char MemoryPressureOnTrigger[] = "MemoryPressureOnTrigger";
const char MemoryPressureAfterTriggered[] = "MemoryPressureAfterTriggered";
const char PrerenderingDisabledByDevTools[] = "PrerenderingDisabledByDevTools";
const char ResourceLoadBlockedByClient[] = "ResourceLoadBlockedByClient";
const char SpeculationRuleRemoved[] = "SpeculationRuleRemoved";
const char ActivatedWithAuxiliaryBrowsingContexts[] = "ActivatedWithAuxiliaryBrowsingContexts";
} // namespace PrerenderFinalStatusEnum


namespace PreloadingStatusEnum {
const char Pending[] = "Pending";
const char Running[] = "Running";
const char Ready[] = "Ready";
const char Success[] = "Success";
const char Failure[] = "Failure";
const char NotSupported[] = "NotSupported";
} // namespace PreloadingStatusEnum


namespace PrefetchStatusEnum {
const char PrefetchAllowed[] = "PrefetchAllowed";
const char PrefetchFailedIneligibleRedirect[] = "PrefetchFailedIneligibleRedirect";
const char PrefetchFailedInvalidRedirect[] = "PrefetchFailedInvalidRedirect";
const char PrefetchFailedMIMENotSupported[] = "PrefetchFailedMIMENotSupported";
const char PrefetchFailedNetError[] = "PrefetchFailedNetError";
const char PrefetchFailedNon2XX[] = "PrefetchFailedNon2XX";
const char PrefetchFailedPerPageLimitExceeded[] = "PrefetchFailedPerPageLimitExceeded";
const char PrefetchEvicted[] = "PrefetchEvicted";
const char PrefetchHeldback[] = "PrefetchHeldback";
const char PrefetchIneligibleRetryAfter[] = "PrefetchIneligibleRetryAfter";
const char PrefetchIsPrivacyDecoy[] = "PrefetchIsPrivacyDecoy";
const char PrefetchIsStale[] = "PrefetchIsStale";
const char PrefetchNotEligibleBrowserContextOffTheRecord[] = "PrefetchNotEligibleBrowserContextOffTheRecord";
const char PrefetchNotEligibleDataSaverEnabled[] = "PrefetchNotEligibleDataSaverEnabled";
const char PrefetchNotEligibleExistingProxy[] = "PrefetchNotEligibleExistingProxy";
const char PrefetchNotEligibleHostIsNonUnique[] = "PrefetchNotEligibleHostIsNonUnique";
const char PrefetchNotEligibleNonDefaultStoragePartition[] = "PrefetchNotEligibleNonDefaultStoragePartition";
const char PrefetchNotEligibleSameSiteCrossOriginPrefetchRequiredProxy[] = "PrefetchNotEligibleSameSiteCrossOriginPrefetchRequiredProxy";
const char PrefetchNotEligibleSchemeIsNotHttps[] = "PrefetchNotEligibleSchemeIsNotHttps";
const char PrefetchNotEligibleUserHasCookies[] = "PrefetchNotEligibleUserHasCookies";
const char PrefetchNotEligibleUserHasServiceWorker[] = "PrefetchNotEligibleUserHasServiceWorker";
const char PrefetchNotEligibleBatterySaverEnabled[] = "PrefetchNotEligibleBatterySaverEnabled";
const char PrefetchNotEligiblePreloadingDisabled[] = "PrefetchNotEligiblePreloadingDisabled";
const char PrefetchNotFinishedInTime[] = "PrefetchNotFinishedInTime";
const char PrefetchNotStarted[] = "PrefetchNotStarted";
const char PrefetchNotUsedCookiesChanged[] = "PrefetchNotUsedCookiesChanged";
const char PrefetchProxyNotAvailable[] = "PrefetchProxyNotAvailable";
const char PrefetchResponseUsed[] = "PrefetchResponseUsed";
const char PrefetchSuccessfulButNotUsed[] = "PrefetchSuccessfulButNotUsed";
const char PrefetchNotUsedProbeFailed[] = "PrefetchNotUsedProbeFailed";
} // namespace PrefetchStatusEnum


// ------------- Enum values from params.


// ------------- Frontend notifications.

void Frontend::PrerenderAttemptCompleted(std::unique_ptr<protocol::Preload::PreloadingAttemptKey> key, const String& initiatingFrameId, const String& prerenderingUrl, const String& finalStatus, Maybe<String> disallowedApiMethod)
{
    if (!frontend_channel_)
        return;
    crdtp::ObjectSerializer serializer;
    serializer.AddField(crdtp::MakeSpan("key"), key);
    serializer.AddField(crdtp::MakeSpan("initiatingFrameId"), initiatingFrameId);
    serializer.AddField(crdtp::MakeSpan("prerenderingUrl"), prerenderingUrl);
    serializer.AddField(crdtp::MakeSpan("finalStatus"), finalStatus);
    serializer.AddField(crdtp::MakeSpan("disallowedApiMethod"), disallowedApiMethod);
    frontend_channel_->SendProtocolNotification(crdtp::CreateNotification("Preload.prerenderAttemptCompleted", serializer.Finish()));
}

void Frontend::PreloadEnabledStateUpdated(bool disabledByPreference, bool disabledByDataSaver, bool disabledByBatterySaver, bool disabledByHoldbackPrefetchSpeculationRules, bool disabledByHoldbackPrerenderSpeculationRules)
{
    if (!frontend_channel_)
        return;
    crdtp::ObjectSerializer serializer;
    serializer.AddField(crdtp::MakeSpan("disabledByPreference"), disabledByPreference);
    serializer.AddField(crdtp::MakeSpan("disabledByDataSaver"), disabledByDataSaver);
    serializer.AddField(crdtp::MakeSpan("disabledByBatterySaver"), disabledByBatterySaver);
    serializer.AddField(crdtp::MakeSpan("disabledByHoldbackPrefetchSpeculationRules"), disabledByHoldbackPrefetchSpeculationRules);
    serializer.AddField(crdtp::MakeSpan("disabledByHoldbackPrerenderSpeculationRules"), disabledByHoldbackPrerenderSpeculationRules);
    frontend_channel_->SendProtocolNotification(crdtp::CreateNotification("Preload.preloadEnabledStateUpdated", serializer.Finish()));
}

void Frontend::PrefetchStatusUpdated(std::unique_ptr<protocol::Preload::PreloadingAttemptKey> key, const String& initiatingFrameId, const String& prefetchUrl, const String& status, const String& prefetchStatus, const String& requestId)
{
    if (!frontend_channel_)
        return;
    crdtp::ObjectSerializer serializer;
    serializer.AddField(crdtp::MakeSpan("key"), key);
    serializer.AddField(crdtp::MakeSpan("initiatingFrameId"), initiatingFrameId);
    serializer.AddField(crdtp::MakeSpan("prefetchUrl"), prefetchUrl);
    serializer.AddField(crdtp::MakeSpan("status"), status);
    serializer.AddField(crdtp::MakeSpan("prefetchStatus"), prefetchStatus);
    serializer.AddField(crdtp::MakeSpan("requestId"), requestId);
    frontend_channel_->SendProtocolNotification(crdtp::CreateNotification("Preload.prefetchStatusUpdated", serializer.Finish()));
}

void Frontend::PrerenderStatusUpdated(std::unique_ptr<protocol::Preload::PreloadingAttemptKey> key, const String& status, Maybe<String> prerenderStatus, Maybe<String> disallowedMojoInterface)
{
    if (!frontend_channel_)
        return;
    crdtp::ObjectSerializer serializer;
    serializer.AddField(crdtp::MakeSpan("key"), key);
    serializer.AddField(crdtp::MakeSpan("status"), status);
    serializer.AddField(crdtp::MakeSpan("prerenderStatus"), prerenderStatus);
    serializer.AddField(crdtp::MakeSpan("disallowedMojoInterface"), disallowedMojoInterface);
    frontend_channel_->SendProtocolNotification(crdtp::CreateNotification("Preload.prerenderStatusUpdated", serializer.Finish()));
}

void Frontend::flush()
{
    frontend_channel_->FlushProtocolNotifications();
}

void Frontend::sendRawNotification(std::unique_ptr<Serializable> notification)
{
    frontend_channel_->SendProtocolNotification(std::move(notification));
}

// --------------------- Dispatcher.

class DomainDispatcherImpl : public protocol::DomainDispatcher {
public:
    DomainDispatcherImpl(FrontendChannel* frontendChannel, Backend* backend)
        : DomainDispatcher(frontendChannel)
        , m_backend(backend) {}
    ~DomainDispatcherImpl() override { }

    using CallHandler = void (DomainDispatcherImpl::*)(const crdtp::Dispatchable& dispatchable);

    std::function<void(const crdtp::Dispatchable&)> Dispatch(crdtp::span<uint8_t> command_name) override;

    void enable(const crdtp::Dispatchable& dispatchable);
    void disable(const crdtp::Dispatchable& dispatchable);
 protected:
    Backend* m_backend;
};

namespace {
// This helper method with a static map of command methods (instance methods
// of DomainDispatcherImpl declared just above) by their name is used immediately below,
// in the DomainDispatcherImpl::Dispatch method.
DomainDispatcherImpl::CallHandler CommandByName(crdtp::span<uint8_t> command_name) {
  static auto* commands = [](){
    auto* commands = new std::vector<std::pair<crdtp::span<uint8_t>,
                              DomainDispatcherImpl::CallHandler>>{
    {
          crdtp::SpanFrom("disable"),
          &DomainDispatcherImpl::disable
    },
    {
          crdtp::SpanFrom("enable"),
          &DomainDispatcherImpl::enable
    },
    };
    return commands;
  }();
  return crdtp::FindByFirst<DomainDispatcherImpl::CallHandler>(*commands, command_name, nullptr);
}
}  // namespace

std::function<void(const crdtp::Dispatchable&)> DomainDispatcherImpl::Dispatch(crdtp::span<uint8_t> command_name) {
  CallHandler handler = CommandByName(command_name);
  if (!handler) return nullptr;

  return [this, handler](const crdtp::Dispatchable& dispatchable) {
    (this->*handler)(dispatchable);
  };
}


namespace {


}  // namespace

void DomainDispatcherImpl::enable(const crdtp::Dispatchable& dispatchable)
{
    // Prepare input parameters.

    std::unique_ptr<DomainDispatcher::WeakPtr> weak = weakPtr();
    DispatchResponse response = m_backend->Enable();
    if (response.IsFallThrough()) {
        channel()->FallThrough(dispatchable.CallId(), crdtp::SpanFrom("Preload.enable"), dispatchable.Serialized());
        return;
    }
    if (weak->get())
        weak->get()->sendResponse(dispatchable.CallId(), response);
    return;
}

namespace {


}  // namespace

void DomainDispatcherImpl::disable(const crdtp::Dispatchable& dispatchable)
{
    // Prepare input parameters.

    std::unique_ptr<DomainDispatcher::WeakPtr> weak = weakPtr();
    DispatchResponse response = m_backend->Disable();
    if (response.IsFallThrough()) {
        channel()->FallThrough(dispatchable.CallId(), crdtp::SpanFrom("Preload.disable"), dispatchable.Serialized());
        return;
    }
    if (weak->get())
        weak->get()->sendResponse(dispatchable.CallId(), response);
    return;
}

namespace {
// This helper method (with a static map of redirects) is used from Dispatcher::wire
// immediately below.
const std::vector<std::pair<crdtp::span<uint8_t>, crdtp::span<uint8_t>>>& SortedRedirects() {
  static auto* redirects = [](){
    auto* redirects = new std::vector<std::pair<crdtp::span<uint8_t>, crdtp::span<uint8_t>>>{
    };
    return redirects;
  }();
  return *redirects;
}
}  // namespace

// static
void Dispatcher::wire(UberDispatcher* uber, Backend* backend)
{
    auto dispatcher = std::make_unique<DomainDispatcherImpl>(uber->channel(), backend);
    uber->WireBackend(crdtp::SpanFrom("Preload"), SortedRedirects(), std::move(dispatcher));
}

} // Preload
} // namespace content
} // namespace protocol
