// content/services/auction_worklet/public/mojom/bidder_worklet.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_SERVICES_AUCTION_WORKLET_PUBLIC_MOJOM_BIDDER_WORKLET_MOJOM_H_
#define CONTENT_SERVICES_AUCTION_WORKLET_PUBLIC_MOJOM_BIDDER_WORKLET_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "third_party/abseil-cpp/absl/types/optional.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "content/services/auction_worklet/public/mojom/bidder_worklet.mojom-shared.h"
#include "content/services/auction_worklet/public/mojom/bidder_worklet.mojom-forward.h"
#include "content/services/auction_worklet/public/mojom/private_aggregation_request.mojom-forward.h"
#include "content/services/auction_worklet/public/mojom/reject_reason.mojom-forward.h"
#include "mojo/public/mojom/base/time.mojom.h"
#include "services/network/public/mojom/url_loader_factory.mojom-forward.h"
#include "third_party/blink/public/mojom/devtools/devtools_agent.mojom-forward.h"
#include "third_party/blink/public/mojom/interest_group/ad_display_size.mojom.h"
#include "third_party/blink/public/mojom/interest_group/interest_group_types.mojom.h"
#include "url/mojom/origin.mojom.h"
#include "url/mojom/url.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "content/common/content_export.h"




namespace auction_worklet::mojom {

class GenerateBidClientProxy;

template <typename ImplRefTraits>
class GenerateBidClientStub;

class GenerateBidClientRequestValidator;
class GenerateBidClientResponseValidator;


class CONTENT_EXPORT GenerateBidClient
    : public GenerateBidClientInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = GenerateBidClientInterfaceBase;
  using Proxy_ = GenerateBidClientProxy;

  template <typename ImplRefTraits>
  using Stub_ = GenerateBidClientStub<ImplRefTraits>;

  using RequestValidator_ = GenerateBidClientRequestValidator;
  using ResponseValidator_ = GenerateBidClientResponseValidator;
  enum MethodMinVersions : uint32_t {
    kOnBiddingSignalsReceivedMinVersion = 0,
    kOnGenerateBidCompleteMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct OnBiddingSignalsReceived_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct OnGenerateBidComplete_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~GenerateBidClient() = default;


  using OnBiddingSignalsReceivedCallback = base::OnceCallback<void()>;
  
  virtual void OnBiddingSignalsReceived(const base::flat_map<std::string, double>& priority_vector, ::base::TimeDelta trusted_signals_fetch_latency, OnBiddingSignalsReceivedCallback callback) = 0;

  
  virtual void OnGenerateBidComplete(BidderWorkletBidPtr bid, BidderWorkletKAnonEnforcedBidPtr kanon_bid, uint32_t bidding_signals_data_version, bool has_bidding_signals_data_version, const absl::optional<::GURL>& debug_loss_report_url, const absl::optional<::GURL>& debug_win_report_url, double set_priority, bool has_set_priority, base::flat_map<std::string, PrioritySignalsDoublePtr> update_priority_signals_overrides, std::vector<::auction_worklet::mojom::PrivateAggregationRequestPtr> pa_requests, std::vector<::auction_worklet::mojom::PrivateAggregationRequestPtr> non_kanon_pa_requests, ::base::TimeDelta bidding_latency, GenerateBidDependencyLatenciesPtr generate_bid_dependency_latencies, ::auction_worklet::mojom::RejectReason reject_reason, const std::vector<std::string>& errors) = 0;
};

class GenerateBidFinalizerProxy;

template <typename ImplRefTraits>
class GenerateBidFinalizerStub;

class GenerateBidFinalizerRequestValidator;


class CONTENT_EXPORT GenerateBidFinalizer
    : public GenerateBidFinalizerInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = GenerateBidFinalizerInterfaceBase;
  using Proxy_ = GenerateBidFinalizerProxy;

  template <typename ImplRefTraits>
  using Stub_ = GenerateBidFinalizerStub<ImplRefTraits>;

  using RequestValidator_ = GenerateBidFinalizerRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kFinishGenerateBidMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct FinishGenerateBid_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~GenerateBidFinalizer() = default;

  
  virtual void FinishGenerateBid(const absl::optional<std::string>& auction_signals_json, const absl::optional<std::string>& per_buyer_signals_json, absl::optional<::base::TimeDelta> per_buyer_timeout, const absl::optional<::blink::AdCurrency>& expected_buyer_currency, const absl::optional<::GURL>& direct_from_seller_per_buyer_signals, const absl::optional<std::string>& direct_from_seller_per_buyer_signals_header_ad_slot, const absl::optional<::GURL>& direct_from_seller_auction_signals, const absl::optional<std::string>& direct_from_seller_auction_signals_header_ad_slot) = 0;
};

class BidderWorkletProxy;

template <typename ImplRefTraits>
class BidderWorkletStub;

class BidderWorkletRequestValidator;
class BidderWorkletResponseValidator;


class CONTENT_EXPORT BidderWorklet
    : public BidderWorkletInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = true;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = BidderWorkletInterfaceBase;
  using Proxy_ = BidderWorkletProxy;

  template <typename ImplRefTraits>
  using Stub_ = BidderWorkletStub<ImplRefTraits>;

  using RequestValidator_ = BidderWorkletRequestValidator;
  using ResponseValidator_ = BidderWorkletResponseValidator;
  enum MethodMinVersions : uint32_t {
    kBeginGenerateBidMinVersion = 0,
    kSendPendingSignalsRequestsMinVersion = 0,
    kReportWinMinVersion = 0,
    kConnectDevToolsAgentMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct BeginGenerateBid_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct SendPendingSignalsRequests_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct ReportWin_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct ConnectDevToolsAgent_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~BidderWorklet() = default;

  
  virtual void BeginGenerateBid(BidderWorkletNonSharedParamsPtr bidder_worklet_non_shared_params, KAnonymityBidMode kanon_mode, const ::url::Origin& interest_group_join_origin, const absl::optional<::GURL>& direct_from_seller_per_buyer_signals, const absl::optional<::GURL>& direct_from_seller_auction_signals, const ::url::Origin& browser_signal_seller_origin, const absl::optional<::url::Origin>& browser_signal_top_level_seller_origin, ::base::TimeDelta browser_signal_recency, BiddingBrowserSignalsPtr bidding_browser_signals, ::base::Time auction_start_time, const absl::optional<::blink::AdSize>& requested_ad_size, uint64_t trace_id, ::mojo::PendingAssociatedRemote<GenerateBidClient> generate_bid_client, ::mojo::PendingAssociatedReceiver<GenerateBidFinalizer> bid_finalizer) = 0;

  
  virtual void SendPendingSignalsRequests() = 0;


  using ReportWinCallback = base::OnceCallback<void(const absl::optional<::GURL>&, const base::flat_map<std::string, ::GURL>&, const base::flat_map<std::string, std::string>&, std::vector<::auction_worklet::mojom::PrivateAggregationRequestPtr>, ::base::TimeDelta, const std::vector<std::string>&)>;
  
  virtual void ReportWin(bool is_for_additional_bid, ReportingIdField reporting_id_field, const std::string& reporting_id, const absl::optional<std::string>& auction_signals_json, const absl::optional<std::string>& per_buyer_signals_json, const absl::optional<::GURL>& direct_from_seller_per_buyer_signals, const absl::optional<std::string>& direct_from_seller_per_buyer_signals_header_ad_slot, const absl::optional<::GURL>& direct_from_seller_auction_signals, const absl::optional<std::string>& direct_from_seller_auction_signals_header_ad_slot, const std::string& seller_signals_json, KAnonymityBidMode kanon_mode, bool bid_is_kanon, const ::GURL& browser_signal_render_url, double browser_signal_bid, const absl::optional<::blink::AdCurrency>& browser_signal_bid_currency, double browser_signal_highest_scoring_other_bid, const absl::optional<::blink::AdCurrency>& browser_signal_highest_scoring_other_bid_currency, bool browser_signal_made_highest_scoring_other_bid, absl::optional<double> browser_signal_ad_cost, absl::optional<uint16_t> browser_signal_modeling_signals, uint8_t browser_signal_join_count, uint8_t browser_signal_recency, const ::url::Origin& browser_signal_seller_origin, const absl::optional<::url::Origin>& browser_signal_top_level_seller_origin, absl::optional<uint32_t> bidding_signals_data_version, uint64_t trace_id, ReportWinCallback callback) = 0;

  
  virtual void ConnectDevToolsAgent(::mojo::PendingAssociatedReceiver<::blink::mojom::DevToolsAgent> agent) = 0;
};



class CONTENT_EXPORT GenerateBidClientProxy
    : public GenerateBidClient {
 public:
  using InterfaceType = GenerateBidClient;

  explicit GenerateBidClientProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void OnBiddingSignalsReceived(const base::flat_map<std::string, double>& priority_vector, ::base::TimeDelta trusted_signals_fetch_latency, OnBiddingSignalsReceivedCallback callback) final;
  
  void OnGenerateBidComplete(BidderWorkletBidPtr bid, BidderWorkletKAnonEnforcedBidPtr kanon_bid, uint32_t bidding_signals_data_version, bool has_bidding_signals_data_version, const absl::optional<::GURL>& debug_loss_report_url, const absl::optional<::GURL>& debug_win_report_url, double set_priority, bool has_set_priority, base::flat_map<std::string, PrioritySignalsDoublePtr> update_priority_signals_overrides, std::vector<::auction_worklet::mojom::PrivateAggregationRequestPtr> pa_requests, std::vector<::auction_worklet::mojom::PrivateAggregationRequestPtr> non_kanon_pa_requests, ::base::TimeDelta bidding_latency, GenerateBidDependencyLatenciesPtr generate_bid_dependency_latencies, ::auction_worklet::mojom::RejectReason reject_reason, const std::vector<std::string>& errors) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class CONTENT_EXPORT GenerateBidFinalizerProxy
    : public GenerateBidFinalizer {
 public:
  using InterfaceType = GenerateBidFinalizer;

  explicit GenerateBidFinalizerProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void FinishGenerateBid(const absl::optional<std::string>& auction_signals_json, const absl::optional<std::string>& per_buyer_signals_json, absl::optional<::base::TimeDelta> per_buyer_timeout, const absl::optional<::blink::AdCurrency>& expected_buyer_currency, const absl::optional<::GURL>& direct_from_seller_per_buyer_signals, const absl::optional<std::string>& direct_from_seller_per_buyer_signals_header_ad_slot, const absl::optional<::GURL>& direct_from_seller_auction_signals, const absl::optional<std::string>& direct_from_seller_auction_signals_header_ad_slot) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class CONTENT_EXPORT BidderWorkletProxy
    : public BidderWorklet {
 public:
  using InterfaceType = BidderWorklet;

  explicit BidderWorkletProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void BeginGenerateBid(BidderWorkletNonSharedParamsPtr bidder_worklet_non_shared_params, KAnonymityBidMode kanon_mode, const ::url::Origin& interest_group_join_origin, const absl::optional<::GURL>& direct_from_seller_per_buyer_signals, const absl::optional<::GURL>& direct_from_seller_auction_signals, const ::url::Origin& browser_signal_seller_origin, const absl::optional<::url::Origin>& browser_signal_top_level_seller_origin, ::base::TimeDelta browser_signal_recency, BiddingBrowserSignalsPtr bidding_browser_signals, ::base::Time auction_start_time, const absl::optional<::blink::AdSize>& requested_ad_size, uint64_t trace_id, ::mojo::PendingAssociatedRemote<GenerateBidClient> generate_bid_client, ::mojo::PendingAssociatedReceiver<GenerateBidFinalizer> bid_finalizer) final;
  
  void SendPendingSignalsRequests() final;
  
  void ReportWin(bool is_for_additional_bid, ReportingIdField reporting_id_field, const std::string& reporting_id, const absl::optional<std::string>& auction_signals_json, const absl::optional<std::string>& per_buyer_signals_json, const absl::optional<::GURL>& direct_from_seller_per_buyer_signals, const absl::optional<std::string>& direct_from_seller_per_buyer_signals_header_ad_slot, const absl::optional<::GURL>& direct_from_seller_auction_signals, const absl::optional<std::string>& direct_from_seller_auction_signals_header_ad_slot, const std::string& seller_signals_json, KAnonymityBidMode kanon_mode, bool bid_is_kanon, const ::GURL& browser_signal_render_url, double browser_signal_bid, const absl::optional<::blink::AdCurrency>& browser_signal_bid_currency, double browser_signal_highest_scoring_other_bid, const absl::optional<::blink::AdCurrency>& browser_signal_highest_scoring_other_bid_currency, bool browser_signal_made_highest_scoring_other_bid, absl::optional<double> browser_signal_ad_cost, absl::optional<uint16_t> browser_signal_modeling_signals, uint8_t browser_signal_join_count, uint8_t browser_signal_recency, const ::url::Origin& browser_signal_seller_origin, const absl::optional<::url::Origin>& browser_signal_top_level_seller_origin, absl::optional<uint32_t> bidding_signals_data_version, uint64_t trace_id, ReportWinCallback callback) final;
  
  void ConnectDevToolsAgent(::mojo::PendingAssociatedReceiver<::blink::mojom::DevToolsAgent> agent) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class CONTENT_EXPORT GenerateBidClientStubDispatch {
 public:
  static bool Accept(GenerateBidClient* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      GenerateBidClient* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<GenerateBidClient>>
class GenerateBidClientStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  GenerateBidClientStub() = default;
  ~GenerateBidClientStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return GenerateBidClientStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return GenerateBidClientStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class CONTENT_EXPORT GenerateBidFinalizerStubDispatch {
 public:
  static bool Accept(GenerateBidFinalizer* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      GenerateBidFinalizer* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<GenerateBidFinalizer>>
class GenerateBidFinalizerStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  GenerateBidFinalizerStub() = default;
  ~GenerateBidFinalizerStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return GenerateBidFinalizerStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return GenerateBidFinalizerStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class CONTENT_EXPORT BidderWorkletStubDispatch {
 public:
  static bool Accept(BidderWorklet* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      BidderWorklet* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<BidderWorklet>>
class BidderWorkletStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  BidderWorkletStub() = default;
  ~BidderWorkletStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return BidderWorkletStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return BidderWorkletStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class CONTENT_EXPORT GenerateBidClientRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class CONTENT_EXPORT GenerateBidFinalizerRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class CONTENT_EXPORT BidderWorkletRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class CONTENT_EXPORT GenerateBidClientResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class CONTENT_EXPORT BidderWorkletResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};






class CONTENT_EXPORT KAnonKey {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<KAnonKey, T>::value>;
  using DataView = KAnonKeyDataView;
  using Data_ = internal::KAnonKey_Data;

  template <typename... Args>
  static KAnonKeyPtr New(Args&&... args) {
    return KAnonKeyPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static KAnonKeyPtr From(const U& u) {
    return mojo::TypeConverter<KAnonKeyPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, KAnonKey>::Convert(*this);
  }


  KAnonKey();

  explicit KAnonKey(
      const std::string& data);


  ~KAnonKey();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = KAnonKeyPtr>
  KAnonKeyPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, KAnonKey::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, KAnonKey::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, KAnonKey::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        KAnonKey::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        KAnonKey::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::KAnonKey_UnserializedMessageContext<
            UserType, KAnonKey::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<KAnonKey::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return KAnonKey::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::KAnonKey_UnserializedMessageContext<
            UserType, KAnonKey::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<KAnonKey::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::string data;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, KAnonKey::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, KAnonKey::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, KAnonKey::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, KAnonKey::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}








class CONTENT_EXPORT BidderWorklerKAnonBidSameAsNonEnforced {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<BidderWorklerKAnonBidSameAsNonEnforced, T>::value>;
  using DataView = BidderWorklerKAnonBidSameAsNonEnforcedDataView;
  using Data_ = internal::BidderWorklerKAnonBidSameAsNonEnforced_Data;

  template <typename... Args>
  static BidderWorklerKAnonBidSameAsNonEnforcedPtr New(Args&&... args) {
    return BidderWorklerKAnonBidSameAsNonEnforcedPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static BidderWorklerKAnonBidSameAsNonEnforcedPtr From(const U& u) {
    return mojo::TypeConverter<BidderWorklerKAnonBidSameAsNonEnforcedPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, BidderWorklerKAnonBidSameAsNonEnforced>::Convert(*this);
  }


  BidderWorklerKAnonBidSameAsNonEnforced();


  ~BidderWorklerKAnonBidSameAsNonEnforced();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = BidderWorklerKAnonBidSameAsNonEnforcedPtr>
  BidderWorklerKAnonBidSameAsNonEnforcedPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, BidderWorklerKAnonBidSameAsNonEnforced::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, BidderWorklerKAnonBidSameAsNonEnforced::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, BidderWorklerKAnonBidSameAsNonEnforced::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        BidderWorklerKAnonBidSameAsNonEnforced::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        BidderWorklerKAnonBidSameAsNonEnforced::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::BidderWorklerKAnonBidSameAsNonEnforced_UnserializedMessageContext<
            UserType, BidderWorklerKAnonBidSameAsNonEnforced::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<BidderWorklerKAnonBidSameAsNonEnforced::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return BidderWorklerKAnonBidSameAsNonEnforced::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::BidderWorklerKAnonBidSameAsNonEnforced_UnserializedMessageContext<
            UserType, BidderWorklerKAnonBidSameAsNonEnforced::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<BidderWorklerKAnonBidSameAsNonEnforced::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }


  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, BidderWorklerKAnonBidSameAsNonEnforced::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, BidderWorklerKAnonBidSameAsNonEnforced::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, BidderWorklerKAnonBidSameAsNonEnforced::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, BidderWorklerKAnonBidSameAsNonEnforced::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class CONTENT_EXPORT PrioritySignalsDouble {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<PrioritySignalsDouble, T>::value>;
  using DataView = PrioritySignalsDoubleDataView;
  using Data_ = internal::PrioritySignalsDouble_Data;

  template <typename... Args>
  static PrioritySignalsDoublePtr New(Args&&... args) {
    return PrioritySignalsDoublePtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static PrioritySignalsDoublePtr From(const U& u) {
    return mojo::TypeConverter<PrioritySignalsDoublePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, PrioritySignalsDouble>::Convert(*this);
  }


  PrioritySignalsDouble();

  explicit PrioritySignalsDouble(
      double value);


  ~PrioritySignalsDouble();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = PrioritySignalsDoublePtr>
  PrioritySignalsDoublePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, PrioritySignalsDouble::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, PrioritySignalsDouble::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, PrioritySignalsDouble::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        PrioritySignalsDouble::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        PrioritySignalsDouble::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::PrioritySignalsDouble_UnserializedMessageContext<
            UserType, PrioritySignalsDouble::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<PrioritySignalsDouble::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return PrioritySignalsDouble::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::PrioritySignalsDouble_UnserializedMessageContext<
            UserType, PrioritySignalsDouble::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<PrioritySignalsDouble::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  double value;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, PrioritySignalsDouble::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, PrioritySignalsDouble::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, PrioritySignalsDouble::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, PrioritySignalsDouble::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class CONTENT_EXPORT BidderWorkletKAnonEnforcedBid {
 public:
  using DataView = BidderWorkletKAnonEnforcedBidDataView;
  using Data_ = internal::BidderWorkletKAnonEnforcedBid_Data;
  using Tag = Data_::BidderWorkletKAnonEnforcedBid_Tag;

  template <typename... Args>
  static BidderWorkletKAnonEnforcedBidPtr New(Args&&... args) {
    static_assert(
        sizeof...(args) < 0,
        "Do not use Union::New(); to create a union of a given subtype, use "
        "New<SubType>(), not New() followed by set_<sub_type>(). To represent "
        "an empty union, mark the field or parameter as nullable in the mojom "
        "definition.");
    return nullptr;
  }
  // Construct an instance holding |same_as_non_enforced|.
  static BidderWorkletKAnonEnforcedBidPtr
  NewSameAsNonEnforced(
      BidderWorklerKAnonBidSameAsNonEnforcedPtr same_as_non_enforced) {
    auto result = BidderWorkletKAnonEnforcedBidPtr(absl::in_place);
    result->set_same_as_non_enforced(std::move(same_as_non_enforced));
    return result;
  }
  // Construct an instance holding |bid|.
  static BidderWorkletKAnonEnforcedBidPtr
  NewBid(
      BidderWorkletBidPtr bid) {
    auto result = BidderWorkletKAnonEnforcedBidPtr(absl::in_place);
    result->set_bid(std::move(bid));
    return result;
  }

  template <typename U>
  static BidderWorkletKAnonEnforcedBidPtr From(const U& u) {
    return mojo::TypeConverter<BidderWorkletKAnonEnforcedBidPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, BidderWorkletKAnonEnforcedBid>::Convert(*this);
  }

  BidderWorkletKAnonEnforcedBid();
  ~BidderWorkletKAnonEnforcedBid();
  // Delete the copy constructor and copy assignment operators because `data_`
  // contains raw pointers that must not be copied.
  BidderWorkletKAnonEnforcedBid(const BidderWorkletKAnonEnforcedBid& other) = delete;
  BidderWorkletKAnonEnforcedBid& operator=(const BidderWorkletKAnonEnforcedBid& other) = delete;

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename UnionPtrType = BidderWorkletKAnonEnforcedBidPtr>
  BidderWorkletKAnonEnforcedBidPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, BidderWorkletKAnonEnforcedBid>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename T,
            typename std::enable_if<std::is_same<
                T, BidderWorkletKAnonEnforcedBid>::value>::type* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  Tag which() const {
    return tag_;
  }


  
  bool is_same_as_non_enforced() const { return tag_ == Tag::kSameAsNonEnforced; }

  
  BidderWorklerKAnonBidSameAsNonEnforcedPtr& get_same_as_non_enforced() const {
    CHECK(tag_ == Tag::kSameAsNonEnforced);
    return *(data_.same_as_non_enforced);
  }

  
  void set_same_as_non_enforced(
      BidderWorklerKAnonBidSameAsNonEnforcedPtr same_as_non_enforced);
  
  bool is_bid() const { return tag_ == Tag::kBid; }

  
  BidderWorkletBidPtr& get_bid() const {
    CHECK(tag_ == Tag::kBid);
    return *(data_.bid);
  }

  
  void set_bid(
      BidderWorkletBidPtr bid);

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        BidderWorkletKAnonEnforcedBid::DataView>(input);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    return mojo::internal::DeserializeImpl<BidderWorkletKAnonEnforcedBid::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

 private:
  union Union_ {
    Union_() = default;
    ~Union_() = default;
    BidderWorklerKAnonBidSameAsNonEnforcedPtr* same_as_non_enforced;
    BidderWorkletBidPtr* bid;
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  void DestroyActive();
  Tag tag_;
  Union_ data_;
};





class CONTENT_EXPORT PreviousWin {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<PreviousWin, T>::value>;
  using DataView = PreviousWinDataView;
  using Data_ = internal::PreviousWin_Data;

  template <typename... Args>
  static PreviousWinPtr New(Args&&... args) {
    return PreviousWinPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static PreviousWinPtr From(const U& u) {
    return mojo::TypeConverter<PreviousWinPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, PreviousWin>::Convert(*this);
  }


  PreviousWin();

  PreviousWin(
      ::base::Time time,
      const std::string& ad_json);


  ~PreviousWin();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = PreviousWinPtr>
  PreviousWinPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, PreviousWin::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, PreviousWin::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, PreviousWin::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        PreviousWin::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        PreviousWin::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::PreviousWin_UnserializedMessageContext<
            UserType, PreviousWin::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<PreviousWin::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return PreviousWin::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::PreviousWin_UnserializedMessageContext<
            UserType, PreviousWin::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<PreviousWin::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::base::Time time;
  
  std::string ad_json;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, PreviousWin::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, PreviousWin::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, PreviousWin::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, PreviousWin::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class CONTENT_EXPORT BidderWorkletNonSharedParams {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<BidderWorkletNonSharedParams, T>::value>;
  using DataView = BidderWorkletNonSharedParamsDataView;
  using Data_ = internal::BidderWorkletNonSharedParams_Data;

  template <typename... Args>
  static BidderWorkletNonSharedParamsPtr New(Args&&... args) {
    return BidderWorkletNonSharedParamsPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static BidderWorkletNonSharedParamsPtr From(const U& u) {
    return mojo::TypeConverter<BidderWorkletNonSharedParamsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, BidderWorkletNonSharedParams>::Convert(*this);
  }


  BidderWorkletNonSharedParams();

  BidderWorkletNonSharedParams(
      const std::string& name,
      bool enable_bidding_signals_prioritization,
      const absl::optional<base::flat_map<std::string, double>>& priority_vector,
      ::blink::mojom::InterestGroup::ExecutionMode execution_mode,
      const absl::optional<::GURL>& update_url,
      absl::optional<std::vector<std::string>> trusted_bidding_signals_keys,
      const absl::optional<std::string>& user_bidding_signals,
      absl::optional<std::vector<::blink::InterestGroup::Ad>> ads,
      absl::optional<std::vector<::blink::InterestGroup::Ad>> ad_components,
      base::flat_map<KAnonKeyPtr, bool> kanon_keys);

BidderWorkletNonSharedParams(const BidderWorkletNonSharedParams&) = delete;
BidderWorkletNonSharedParams& operator=(const BidderWorkletNonSharedParams&) = delete;

  ~BidderWorkletNonSharedParams();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = BidderWorkletNonSharedParamsPtr>
  BidderWorkletNonSharedParamsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, BidderWorkletNonSharedParams::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, BidderWorkletNonSharedParams::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, BidderWorkletNonSharedParams::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        BidderWorkletNonSharedParams::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        BidderWorkletNonSharedParams::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::BidderWorkletNonSharedParams_UnserializedMessageContext<
            UserType, BidderWorkletNonSharedParams::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<BidderWorkletNonSharedParams::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return BidderWorkletNonSharedParams::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::BidderWorkletNonSharedParams_UnserializedMessageContext<
            UserType, BidderWorkletNonSharedParams::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<BidderWorkletNonSharedParams::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::string name;
  
  bool enable_bidding_signals_prioritization;
  
  absl::optional<base::flat_map<std::string, double>> priority_vector;
  
  ::blink::mojom::InterestGroup::ExecutionMode execution_mode;
  
  absl::optional<::GURL> update_url;
  
  absl::optional<std::vector<std::string>> trusted_bidding_signals_keys;
  
  absl::optional<std::string> user_bidding_signals;
  
  absl::optional<std::vector<::blink::InterestGroup::Ad>> ads;
  
  absl::optional<std::vector<::blink::InterestGroup::Ad>> ad_components;
  
  base::flat_map<KAnonKeyPtr, bool> kanon_keys;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, BidderWorkletNonSharedParams::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, BidderWorkletNonSharedParams::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, BidderWorkletNonSharedParams::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, BidderWorkletNonSharedParams::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class CONTENT_EXPORT BiddingBrowserSignals {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<BiddingBrowserSignals, T>::value>;
  using DataView = BiddingBrowserSignalsDataView;
  using Data_ = internal::BiddingBrowserSignals_Data;

  template <typename... Args>
  static BiddingBrowserSignalsPtr New(Args&&... args) {
    return BiddingBrowserSignalsPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static BiddingBrowserSignalsPtr From(const U& u) {
    return mojo::TypeConverter<BiddingBrowserSignalsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, BiddingBrowserSignals>::Convert(*this);
  }


  BiddingBrowserSignals();

  BiddingBrowserSignals(
      int32_t join_count,
      int32_t bid_count,
      std::vector<PreviousWinPtr> prev_wins);

BiddingBrowserSignals(const BiddingBrowserSignals&) = delete;
BiddingBrowserSignals& operator=(const BiddingBrowserSignals&) = delete;

  ~BiddingBrowserSignals();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = BiddingBrowserSignalsPtr>
  BiddingBrowserSignalsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, BiddingBrowserSignals::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, BiddingBrowserSignals::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, BiddingBrowserSignals::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        BiddingBrowserSignals::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        BiddingBrowserSignals::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::BiddingBrowserSignals_UnserializedMessageContext<
            UserType, BiddingBrowserSignals::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<BiddingBrowserSignals::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return BiddingBrowserSignals::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::BiddingBrowserSignals_UnserializedMessageContext<
            UserType, BiddingBrowserSignals::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<BiddingBrowserSignals::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  int32_t join_count;
  
  int32_t bid_count;
  
  std::vector<PreviousWinPtr> prev_wins;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, BiddingBrowserSignals::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, BiddingBrowserSignals::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, BiddingBrowserSignals::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, BiddingBrowserSignals::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class CONTENT_EXPORT BidderWorkletBid {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<BidderWorkletBid, T>::value>;
  using DataView = BidderWorkletBidDataView;
  using Data_ = internal::BidderWorkletBid_Data;

  template <typename... Args>
  static BidderWorkletBidPtr New(Args&&... args) {
    return BidderWorkletBidPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static BidderWorkletBidPtr From(const U& u) {
    return mojo::TypeConverter<BidderWorkletBidPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, BidderWorkletBid>::Convert(*this);
  }


  BidderWorkletBid();

  BidderWorkletBid(
      const std::string& ad,
      double bid,
      const absl::optional<::blink::AdCurrency>& bid_currency,
      absl::optional<double> ad_cost,
      const ::blink::AdDescriptor& ad_descriptor,
      absl::optional<std::vector<::blink::AdDescriptor>> ad_component_descriptors,
      absl::optional<uint16_t> modeling_signals,
      ::base::TimeDelta bid_duration);


  ~BidderWorkletBid();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = BidderWorkletBidPtr>
  BidderWorkletBidPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, BidderWorkletBid::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, BidderWorkletBid::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, BidderWorkletBid::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        BidderWorkletBid::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        BidderWorkletBid::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::BidderWorkletBid_UnserializedMessageContext<
            UserType, BidderWorkletBid::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<BidderWorkletBid::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return BidderWorkletBid::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::BidderWorkletBid_UnserializedMessageContext<
            UserType, BidderWorkletBid::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<BidderWorkletBid::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::string ad;
  
  double bid;
  
  absl::optional<::blink::AdCurrency> bid_currency;
  
  absl::optional<double> ad_cost;
  
  ::blink::AdDescriptor ad_descriptor;
  
  absl::optional<std::vector<::blink::AdDescriptor>> ad_component_descriptors;
  
  absl::optional<uint16_t> modeling_signals;
  
  ::base::TimeDelta bid_duration;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, BidderWorkletBid::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, BidderWorkletBid::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, BidderWorkletBid::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, BidderWorkletBid::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}







class CONTENT_EXPORT GenerateBidDependencyLatencies {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<GenerateBidDependencyLatencies, T>::value>;
  using DataView = GenerateBidDependencyLatenciesDataView;
  using Data_ = internal::GenerateBidDependencyLatencies_Data;

  template <typename... Args>
  static GenerateBidDependencyLatenciesPtr New(Args&&... args) {
    return GenerateBidDependencyLatenciesPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static GenerateBidDependencyLatenciesPtr From(const U& u) {
    return mojo::TypeConverter<GenerateBidDependencyLatenciesPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, GenerateBidDependencyLatencies>::Convert(*this);
  }


  GenerateBidDependencyLatencies();

  GenerateBidDependencyLatencies(
      absl::optional<::base::TimeDelta> code_ready_latency,
      absl::optional<::base::TimeDelta> config_promises_latency,
      absl::optional<::base::TimeDelta> direct_from_seller_signals_latency,
      absl::optional<::base::TimeDelta> trusted_bidding_signals_latency);


  ~GenerateBidDependencyLatencies();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = GenerateBidDependencyLatenciesPtr>
  GenerateBidDependencyLatenciesPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, GenerateBidDependencyLatencies::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, GenerateBidDependencyLatencies::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, GenerateBidDependencyLatencies::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        GenerateBidDependencyLatencies::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        GenerateBidDependencyLatencies::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::GenerateBidDependencyLatencies_UnserializedMessageContext<
            UserType, GenerateBidDependencyLatencies::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<GenerateBidDependencyLatencies::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return GenerateBidDependencyLatencies::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::GenerateBidDependencyLatencies_UnserializedMessageContext<
            UserType, GenerateBidDependencyLatencies::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<GenerateBidDependencyLatencies::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  absl::optional<::base::TimeDelta> code_ready_latency;
  
  absl::optional<::base::TimeDelta> config_promises_latency;
  
  absl::optional<::base::TimeDelta> direct_from_seller_signals_latency;
  
  absl::optional<::base::TimeDelta> trusted_bidding_signals_latency;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, GenerateBidDependencyLatencies::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, GenerateBidDependencyLatencies::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, GenerateBidDependencyLatencies::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, GenerateBidDependencyLatencies::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename UnionPtrType>
BidderWorkletKAnonEnforcedBidPtr BidderWorkletKAnonEnforcedBid::Clone() const {
  switch (tag_) {
    case Tag::kSameAsNonEnforced:
      return NewSameAsNonEnforced(
          mojo::Clone(*data_.same_as_non_enforced));
    case Tag::kBid:
      return NewBid(
          mojo::Clone(*data_.bid));
  }
  return nullptr;
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, BidderWorkletKAnonEnforcedBid>::value>::type*>
bool BidderWorkletKAnonEnforcedBid::Equals(const T& other) const {
  if (tag_ != other.which())
    return false;

  switch (tag_) {
    case Tag::kSameAsNonEnforced:
      return mojo::Equals(*(data_.same_as_non_enforced), *(other.data_.same_as_non_enforced));
    case Tag::kBid:
      return mojo::Equals(*(data_.bid), *(other.data_.bid));
  }

  return false;
}
template <typename StructPtrType>
PreviousWinPtr PreviousWin::Clone() const {
  return New(
      mojo::Clone(time),
      mojo::Clone(ad_json)
  );
}

template <typename T, PreviousWin::EnableIfSame<T>*>
bool PreviousWin::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->time, other_struct.time))
    return false;
  if (!mojo::Equals(this->ad_json, other_struct.ad_json))
    return false;
  return true;
}

template <typename T, PreviousWin::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.time < rhs.time)
    return true;
  if (rhs.time < lhs.time)
    return false;
  if (lhs.ad_json < rhs.ad_json)
    return true;
  if (rhs.ad_json < lhs.ad_json)
    return false;
  return false;
}
template <typename StructPtrType>
KAnonKeyPtr KAnonKey::Clone() const {
  return New(
      mojo::Clone(data)
  );
}

template <typename T, KAnonKey::EnableIfSame<T>*>
bool KAnonKey::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->data, other_struct.data))
    return false;
  return true;
}

template <typename T, KAnonKey::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.data < rhs.data)
    return true;
  if (rhs.data < lhs.data)
    return false;
  return false;
}
template <typename StructPtrType>
BidderWorkletNonSharedParamsPtr BidderWorkletNonSharedParams::Clone() const {
  return New(
      mojo::Clone(name),
      mojo::Clone(enable_bidding_signals_prioritization),
      mojo::Clone(priority_vector),
      mojo::Clone(execution_mode),
      mojo::Clone(update_url),
      mojo::Clone(trusted_bidding_signals_keys),
      mojo::Clone(user_bidding_signals),
      mojo::Clone(ads),
      mojo::Clone(ad_components),
      mojo::Clone(kanon_keys)
  );
}

template <typename T, BidderWorkletNonSharedParams::EnableIfSame<T>*>
bool BidderWorkletNonSharedParams::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->name, other_struct.name))
    return false;
  if (!mojo::Equals(this->enable_bidding_signals_prioritization, other_struct.enable_bidding_signals_prioritization))
    return false;
  if (!mojo::Equals(this->priority_vector, other_struct.priority_vector))
    return false;
  if (!mojo::Equals(this->execution_mode, other_struct.execution_mode))
    return false;
  if (!mojo::Equals(this->update_url, other_struct.update_url))
    return false;
  if (!mojo::Equals(this->trusted_bidding_signals_keys, other_struct.trusted_bidding_signals_keys))
    return false;
  if (!mojo::Equals(this->user_bidding_signals, other_struct.user_bidding_signals))
    return false;
  if (!mojo::Equals(this->ads, other_struct.ads))
    return false;
  if (!mojo::Equals(this->ad_components, other_struct.ad_components))
    return false;
  if (!mojo::Equals(this->kanon_keys, other_struct.kanon_keys))
    return false;
  return true;
}

template <typename T, BidderWorkletNonSharedParams::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.name < rhs.name)
    return true;
  if (rhs.name < lhs.name)
    return false;
  if (lhs.enable_bidding_signals_prioritization < rhs.enable_bidding_signals_prioritization)
    return true;
  if (rhs.enable_bidding_signals_prioritization < lhs.enable_bidding_signals_prioritization)
    return false;
  if (lhs.priority_vector < rhs.priority_vector)
    return true;
  if (rhs.priority_vector < lhs.priority_vector)
    return false;
  if (lhs.execution_mode < rhs.execution_mode)
    return true;
  if (rhs.execution_mode < lhs.execution_mode)
    return false;
  if (lhs.update_url < rhs.update_url)
    return true;
  if (rhs.update_url < lhs.update_url)
    return false;
  if (lhs.trusted_bidding_signals_keys < rhs.trusted_bidding_signals_keys)
    return true;
  if (rhs.trusted_bidding_signals_keys < lhs.trusted_bidding_signals_keys)
    return false;
  if (lhs.user_bidding_signals < rhs.user_bidding_signals)
    return true;
  if (rhs.user_bidding_signals < lhs.user_bidding_signals)
    return false;
  if (lhs.ads < rhs.ads)
    return true;
  if (rhs.ads < lhs.ads)
    return false;
  if (lhs.ad_components < rhs.ad_components)
    return true;
  if (rhs.ad_components < lhs.ad_components)
    return false;
  if (lhs.kanon_keys < rhs.kanon_keys)
    return true;
  if (rhs.kanon_keys < lhs.kanon_keys)
    return false;
  return false;
}
template <typename StructPtrType>
BiddingBrowserSignalsPtr BiddingBrowserSignals::Clone() const {
  return New(
      mojo::Clone(join_count),
      mojo::Clone(bid_count),
      mojo::Clone(prev_wins)
  );
}

template <typename T, BiddingBrowserSignals::EnableIfSame<T>*>
bool BiddingBrowserSignals::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->join_count, other_struct.join_count))
    return false;
  if (!mojo::Equals(this->bid_count, other_struct.bid_count))
    return false;
  if (!mojo::Equals(this->prev_wins, other_struct.prev_wins))
    return false;
  return true;
}

template <typename T, BiddingBrowserSignals::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.join_count < rhs.join_count)
    return true;
  if (rhs.join_count < lhs.join_count)
    return false;
  if (lhs.bid_count < rhs.bid_count)
    return true;
  if (rhs.bid_count < lhs.bid_count)
    return false;
  if (lhs.prev_wins < rhs.prev_wins)
    return true;
  if (rhs.prev_wins < lhs.prev_wins)
    return false;
  return false;
}
template <typename StructPtrType>
BidderWorkletBidPtr BidderWorkletBid::Clone() const {
  return New(
      mojo::Clone(ad),
      mojo::Clone(bid),
      mojo::Clone(bid_currency),
      mojo::Clone(ad_cost),
      mojo::Clone(ad_descriptor),
      mojo::Clone(ad_component_descriptors),
      mojo::Clone(modeling_signals),
      mojo::Clone(bid_duration)
  );
}

template <typename T, BidderWorkletBid::EnableIfSame<T>*>
bool BidderWorkletBid::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->ad, other_struct.ad))
    return false;
  if (!mojo::Equals(this->bid, other_struct.bid))
    return false;
  if (!mojo::Equals(this->bid_currency, other_struct.bid_currency))
    return false;
  if (!mojo::Equals(this->ad_cost, other_struct.ad_cost))
    return false;
  if (!mojo::Equals(this->ad_descriptor, other_struct.ad_descriptor))
    return false;
  if (!mojo::Equals(this->ad_component_descriptors, other_struct.ad_component_descriptors))
    return false;
  if (!mojo::Equals(this->modeling_signals, other_struct.modeling_signals))
    return false;
  if (!mojo::Equals(this->bid_duration, other_struct.bid_duration))
    return false;
  return true;
}

template <typename T, BidderWorkletBid::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.ad < rhs.ad)
    return true;
  if (rhs.ad < lhs.ad)
    return false;
  if (lhs.bid < rhs.bid)
    return true;
  if (rhs.bid < lhs.bid)
    return false;
  if (lhs.bid_currency < rhs.bid_currency)
    return true;
  if (rhs.bid_currency < lhs.bid_currency)
    return false;
  if (lhs.ad_cost < rhs.ad_cost)
    return true;
  if (rhs.ad_cost < lhs.ad_cost)
    return false;
  if (lhs.ad_descriptor < rhs.ad_descriptor)
    return true;
  if (rhs.ad_descriptor < lhs.ad_descriptor)
    return false;
  if (lhs.ad_component_descriptors < rhs.ad_component_descriptors)
    return true;
  if (rhs.ad_component_descriptors < lhs.ad_component_descriptors)
    return false;
  if (lhs.modeling_signals < rhs.modeling_signals)
    return true;
  if (rhs.modeling_signals < lhs.modeling_signals)
    return false;
  if (lhs.bid_duration < rhs.bid_duration)
    return true;
  if (rhs.bid_duration < lhs.bid_duration)
    return false;
  return false;
}
template <typename StructPtrType>
BidderWorklerKAnonBidSameAsNonEnforcedPtr BidderWorklerKAnonBidSameAsNonEnforced::Clone() const {
  return New(
  );
}

template <typename T, BidderWorklerKAnonBidSameAsNonEnforced::EnableIfSame<T>*>
bool BidderWorklerKAnonBidSameAsNonEnforced::Equals(const T& other_struct) const {
  return true;
}

template <typename T, BidderWorklerKAnonBidSameAsNonEnforced::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  return false;
}
template <typename StructPtrType>
PrioritySignalsDoublePtr PrioritySignalsDouble::Clone() const {
  return New(
      mojo::Clone(value)
  );
}

template <typename T, PrioritySignalsDouble::EnableIfSame<T>*>
bool PrioritySignalsDouble::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->value, other_struct.value))
    return false;
  return true;
}

template <typename T, PrioritySignalsDouble::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.value < rhs.value)
    return true;
  if (rhs.value < lhs.value)
    return false;
  return false;
}
template <typename StructPtrType>
GenerateBidDependencyLatenciesPtr GenerateBidDependencyLatencies::Clone() const {
  return New(
      mojo::Clone(code_ready_latency),
      mojo::Clone(config_promises_latency),
      mojo::Clone(direct_from_seller_signals_latency),
      mojo::Clone(trusted_bidding_signals_latency)
  );
}

template <typename T, GenerateBidDependencyLatencies::EnableIfSame<T>*>
bool GenerateBidDependencyLatencies::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->code_ready_latency, other_struct.code_ready_latency))
    return false;
  if (!mojo::Equals(this->config_promises_latency, other_struct.config_promises_latency))
    return false;
  if (!mojo::Equals(this->direct_from_seller_signals_latency, other_struct.direct_from_seller_signals_latency))
    return false;
  if (!mojo::Equals(this->trusted_bidding_signals_latency, other_struct.trusted_bidding_signals_latency))
    return false;
  return true;
}

template <typename T, GenerateBidDependencyLatencies::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.code_ready_latency < rhs.code_ready_latency)
    return true;
  if (rhs.code_ready_latency < lhs.code_ready_latency)
    return false;
  if (lhs.config_promises_latency < rhs.config_promises_latency)
    return true;
  if (rhs.config_promises_latency < lhs.config_promises_latency)
    return false;
  if (lhs.direct_from_seller_signals_latency < rhs.direct_from_seller_signals_latency)
    return true;
  if (rhs.direct_from_seller_signals_latency < lhs.direct_from_seller_signals_latency)
    return false;
  if (lhs.trusted_bidding_signals_latency < rhs.trusted_bidding_signals_latency)
    return true;
  if (rhs.trusted_bidding_signals_latency < lhs.trusted_bidding_signals_latency)
    return false;
  return false;
}


}  // auction_worklet::mojom

namespace mojo {


template <>
struct CONTENT_EXPORT StructTraits<::auction_worklet::mojom::PreviousWin::DataView,
                                         ::auction_worklet::mojom::PreviousWinPtr> {
  static bool IsNull(const ::auction_worklet::mojom::PreviousWinPtr& input) { return !input; }
  static void SetToNull(::auction_worklet::mojom::PreviousWinPtr* output) { output->reset(); }

  static const decltype(::auction_worklet::mojom::PreviousWin::time)& time(
      const ::auction_worklet::mojom::PreviousWinPtr& input) {
    return input->time;
  }

  static const decltype(::auction_worklet::mojom::PreviousWin::ad_json)& ad_json(
      const ::auction_worklet::mojom::PreviousWinPtr& input) {
    return input->ad_json;
  }

  static bool Read(::auction_worklet::mojom::PreviousWin::DataView input, ::auction_worklet::mojom::PreviousWinPtr* output);
};


template <>
struct CONTENT_EXPORT StructTraits<::auction_worklet::mojom::KAnonKey::DataView,
                                         ::auction_worklet::mojom::KAnonKeyPtr> {
  static bool IsNull(const ::auction_worklet::mojom::KAnonKeyPtr& input) { return !input; }
  static void SetToNull(::auction_worklet::mojom::KAnonKeyPtr* output) { output->reset(); }

  static const decltype(::auction_worklet::mojom::KAnonKey::data)& data(
      const ::auction_worklet::mojom::KAnonKeyPtr& input) {
    return input->data;
  }

  static bool Read(::auction_worklet::mojom::KAnonKey::DataView input, ::auction_worklet::mojom::KAnonKeyPtr* output);
};


template <>
struct CONTENT_EXPORT StructTraits<::auction_worklet::mojom::BidderWorkletNonSharedParams::DataView,
                                         ::auction_worklet::mojom::BidderWorkletNonSharedParamsPtr> {
  static bool IsNull(const ::auction_worklet::mojom::BidderWorkletNonSharedParamsPtr& input) { return !input; }
  static void SetToNull(::auction_worklet::mojom::BidderWorkletNonSharedParamsPtr* output) { output->reset(); }

  static const decltype(::auction_worklet::mojom::BidderWorkletNonSharedParams::name)& name(
      const ::auction_worklet::mojom::BidderWorkletNonSharedParamsPtr& input) {
    return input->name;
  }

  static decltype(::auction_worklet::mojom::BidderWorkletNonSharedParams::enable_bidding_signals_prioritization) enable_bidding_signals_prioritization(
      const ::auction_worklet::mojom::BidderWorkletNonSharedParamsPtr& input) {
    return input->enable_bidding_signals_prioritization;
  }

  static const decltype(::auction_worklet::mojom::BidderWorkletNonSharedParams::priority_vector)& priority_vector(
      const ::auction_worklet::mojom::BidderWorkletNonSharedParamsPtr& input) {
    return input->priority_vector;
  }

  static decltype(::auction_worklet::mojom::BidderWorkletNonSharedParams::execution_mode) execution_mode(
      const ::auction_worklet::mojom::BidderWorkletNonSharedParamsPtr& input) {
    return input->execution_mode;
  }

  static const decltype(::auction_worklet::mojom::BidderWorkletNonSharedParams::update_url)& update_url(
      const ::auction_worklet::mojom::BidderWorkletNonSharedParamsPtr& input) {
    return input->update_url;
  }

  static const decltype(::auction_worklet::mojom::BidderWorkletNonSharedParams::trusted_bidding_signals_keys)& trusted_bidding_signals_keys(
      const ::auction_worklet::mojom::BidderWorkletNonSharedParamsPtr& input) {
    return input->trusted_bidding_signals_keys;
  }

  static const decltype(::auction_worklet::mojom::BidderWorkletNonSharedParams::user_bidding_signals)& user_bidding_signals(
      const ::auction_worklet::mojom::BidderWorkletNonSharedParamsPtr& input) {
    return input->user_bidding_signals;
  }

  static const decltype(::auction_worklet::mojom::BidderWorkletNonSharedParams::ads)& ads(
      const ::auction_worklet::mojom::BidderWorkletNonSharedParamsPtr& input) {
    return input->ads;
  }

  static const decltype(::auction_worklet::mojom::BidderWorkletNonSharedParams::ad_components)& ad_components(
      const ::auction_worklet::mojom::BidderWorkletNonSharedParamsPtr& input) {
    return input->ad_components;
  }

  static const decltype(::auction_worklet::mojom::BidderWorkletNonSharedParams::kanon_keys)& kanon_keys(
      const ::auction_worklet::mojom::BidderWorkletNonSharedParamsPtr& input) {
    return input->kanon_keys;
  }

  static bool Read(::auction_worklet::mojom::BidderWorkletNonSharedParams::DataView input, ::auction_worklet::mojom::BidderWorkletNonSharedParamsPtr* output);
};


template <>
struct CONTENT_EXPORT StructTraits<::auction_worklet::mojom::BiddingBrowserSignals::DataView,
                                         ::auction_worklet::mojom::BiddingBrowserSignalsPtr> {
  static bool IsNull(const ::auction_worklet::mojom::BiddingBrowserSignalsPtr& input) { return !input; }
  static void SetToNull(::auction_worklet::mojom::BiddingBrowserSignalsPtr* output) { output->reset(); }

  static decltype(::auction_worklet::mojom::BiddingBrowserSignals::join_count) join_count(
      const ::auction_worklet::mojom::BiddingBrowserSignalsPtr& input) {
    return input->join_count;
  }

  static decltype(::auction_worklet::mojom::BiddingBrowserSignals::bid_count) bid_count(
      const ::auction_worklet::mojom::BiddingBrowserSignalsPtr& input) {
    return input->bid_count;
  }

  static const decltype(::auction_worklet::mojom::BiddingBrowserSignals::prev_wins)& prev_wins(
      const ::auction_worklet::mojom::BiddingBrowserSignalsPtr& input) {
    return input->prev_wins;
  }

  static bool Read(::auction_worklet::mojom::BiddingBrowserSignals::DataView input, ::auction_worklet::mojom::BiddingBrowserSignalsPtr* output);
};


template <>
struct CONTENT_EXPORT StructTraits<::auction_worklet::mojom::BidderWorkletBid::DataView,
                                         ::auction_worklet::mojom::BidderWorkletBidPtr> {
  static bool IsNull(const ::auction_worklet::mojom::BidderWorkletBidPtr& input) { return !input; }
  static void SetToNull(::auction_worklet::mojom::BidderWorkletBidPtr* output) { output->reset(); }

  static const decltype(::auction_worklet::mojom::BidderWorkletBid::ad)& ad(
      const ::auction_worklet::mojom::BidderWorkletBidPtr& input) {
    return input->ad;
  }

  static decltype(::auction_worklet::mojom::BidderWorkletBid::bid) bid(
      const ::auction_worklet::mojom::BidderWorkletBidPtr& input) {
    return input->bid;
  }

  static const decltype(::auction_worklet::mojom::BidderWorkletBid::bid_currency)& bid_currency(
      const ::auction_worklet::mojom::BidderWorkletBidPtr& input) {
    return input->bid_currency;
  }

  static decltype(::auction_worklet::mojom::BidderWorkletBid::ad_cost) ad_cost(
      const ::auction_worklet::mojom::BidderWorkletBidPtr& input) {
    return input->ad_cost;
  }

  static const decltype(::auction_worklet::mojom::BidderWorkletBid::ad_descriptor)& ad_descriptor(
      const ::auction_worklet::mojom::BidderWorkletBidPtr& input) {
    return input->ad_descriptor;
  }

  static const decltype(::auction_worklet::mojom::BidderWorkletBid::ad_component_descriptors)& ad_component_descriptors(
      const ::auction_worklet::mojom::BidderWorkletBidPtr& input) {
    return input->ad_component_descriptors;
  }

  static decltype(::auction_worklet::mojom::BidderWorkletBid::modeling_signals) modeling_signals(
      const ::auction_worklet::mojom::BidderWorkletBidPtr& input) {
    return input->modeling_signals;
  }

  static const decltype(::auction_worklet::mojom::BidderWorkletBid::bid_duration)& bid_duration(
      const ::auction_worklet::mojom::BidderWorkletBidPtr& input) {
    return input->bid_duration;
  }

  static bool Read(::auction_worklet::mojom::BidderWorkletBid::DataView input, ::auction_worklet::mojom::BidderWorkletBidPtr* output);
};


template <>
struct CONTENT_EXPORT StructTraits<::auction_worklet::mojom::BidderWorklerKAnonBidSameAsNonEnforced::DataView,
                                         ::auction_worklet::mojom::BidderWorklerKAnonBidSameAsNonEnforcedPtr> {
  static bool IsNull(const ::auction_worklet::mojom::BidderWorklerKAnonBidSameAsNonEnforcedPtr& input) { return !input; }
  static void SetToNull(::auction_worklet::mojom::BidderWorklerKAnonBidSameAsNonEnforcedPtr* output) { output->reset(); }

  static bool Read(::auction_worklet::mojom::BidderWorklerKAnonBidSameAsNonEnforced::DataView input, ::auction_worklet::mojom::BidderWorklerKAnonBidSameAsNonEnforcedPtr* output);
};


template <>
struct CONTENT_EXPORT StructTraits<::auction_worklet::mojom::PrioritySignalsDouble::DataView,
                                         ::auction_worklet::mojom::PrioritySignalsDoublePtr> {
  static bool IsNull(const ::auction_worklet::mojom::PrioritySignalsDoublePtr& input) { return !input; }
  static void SetToNull(::auction_worklet::mojom::PrioritySignalsDoublePtr* output) { output->reset(); }

  static decltype(::auction_worklet::mojom::PrioritySignalsDouble::value) value(
      const ::auction_worklet::mojom::PrioritySignalsDoublePtr& input) {
    return input->value;
  }

  static bool Read(::auction_worklet::mojom::PrioritySignalsDouble::DataView input, ::auction_worklet::mojom::PrioritySignalsDoublePtr* output);
};


template <>
struct CONTENT_EXPORT StructTraits<::auction_worklet::mojom::GenerateBidDependencyLatencies::DataView,
                                         ::auction_worklet::mojom::GenerateBidDependencyLatenciesPtr> {
  static bool IsNull(const ::auction_worklet::mojom::GenerateBidDependencyLatenciesPtr& input) { return !input; }
  static void SetToNull(::auction_worklet::mojom::GenerateBidDependencyLatenciesPtr* output) { output->reset(); }

  static const decltype(::auction_worklet::mojom::GenerateBidDependencyLatencies::code_ready_latency)& code_ready_latency(
      const ::auction_worklet::mojom::GenerateBidDependencyLatenciesPtr& input) {
    return input->code_ready_latency;
  }

  static const decltype(::auction_worklet::mojom::GenerateBidDependencyLatencies::config_promises_latency)& config_promises_latency(
      const ::auction_worklet::mojom::GenerateBidDependencyLatenciesPtr& input) {
    return input->config_promises_latency;
  }

  static const decltype(::auction_worklet::mojom::GenerateBidDependencyLatencies::direct_from_seller_signals_latency)& direct_from_seller_signals_latency(
      const ::auction_worklet::mojom::GenerateBidDependencyLatenciesPtr& input) {
    return input->direct_from_seller_signals_latency;
  }

  static const decltype(::auction_worklet::mojom::GenerateBidDependencyLatencies::trusted_bidding_signals_latency)& trusted_bidding_signals_latency(
      const ::auction_worklet::mojom::GenerateBidDependencyLatenciesPtr& input) {
    return input->trusted_bidding_signals_latency;
  }

  static bool Read(::auction_worklet::mojom::GenerateBidDependencyLatencies::DataView input, ::auction_worklet::mojom::GenerateBidDependencyLatenciesPtr* output);
};


template <>
struct CONTENT_EXPORT UnionTraits<::auction_worklet::mojom::BidderWorkletKAnonEnforcedBid::DataView,
                                        ::auction_worklet::mojom::BidderWorkletKAnonEnforcedBidPtr> {
  static bool IsNull(const ::auction_worklet::mojom::BidderWorkletKAnonEnforcedBidPtr& input) { return !input; }
  static void SetToNull(::auction_worklet::mojom::BidderWorkletKAnonEnforcedBidPtr* output) { output->reset(); }

  static ::auction_worklet::mojom::BidderWorkletKAnonEnforcedBid::Tag GetTag(const ::auction_worklet::mojom::BidderWorkletKAnonEnforcedBidPtr& input) {
    return input->which();
  }

  static const ::auction_worklet::mojom::BidderWorklerKAnonBidSameAsNonEnforcedPtr& same_as_non_enforced(const ::auction_worklet::mojom::BidderWorkletKAnonEnforcedBidPtr& input) {
    return input->get_same_as_non_enforced();
  }

  static const ::auction_worklet::mojom::BidderWorkletBidPtr& bid(const ::auction_worklet::mojom::BidderWorkletKAnonEnforcedBidPtr& input) {
    return input->get_bid();
  }

  static bool Read(::auction_worklet::mojom::BidderWorkletKAnonEnforcedBid::DataView input, ::auction_worklet::mojom::BidderWorkletKAnonEnforcedBidPtr* output);
};

}  // namespace mojo

#endif  // CONTENT_SERVICES_AUCTION_WORKLET_PUBLIC_MOJOM_BIDDER_WORKLET_MOJOM_H_