// services/device/public/mojom/geolocation_internals.mojom.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#endif

#include "services/device/public/mojom/geolocation_internals.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/debug/alias.h"
#include "base/hash/md5_constexpr.h"
#include "base/run_loop.h"
#include "base/strings/string_number_conversions.h"
#include "base/task/thread_pool/thread_pool_instance.h"
#include "base/trace_event/trace_event.h"
#include "base/trace_event/typed_macros.h"
#include "mojo/public/cpp/bindings/lib/default_construct_tag_internal.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/send_message_helper.h"
#include "mojo/public/cpp/bindings/lib/proxy_to_responder.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "services/device/public/mojom/geolocation_internals.mojom-params-data.h"
#include "services/device/public/mojom/geolocation_internals.mojom-shared-message-ids.h"

#include "services/device/public/mojom/geolocation_internals.mojom-import-headers.h"
#include "services/device/public/mojom/geolocation_internals.mojom-test-utils.h"


namespace device::mojom {
AccessPointData::AccessPointData()
    : mac_address(),
      radio_signal_strength(kInvalidRadioSignalStrength),
      channel(kInvalidChannel),
      signal_to_noise(kInvalidSignalToNoise),
      timestamp() {}

AccessPointData::AccessPointData(
    const std::string& mac_address_in,
    int32_t radio_signal_strength_in,
    int32_t channel_in,
    int32_t signal_to_noise_in,
    absl::optional<::base::Time> timestamp_in)
    : mac_address(std::move(mac_address_in)),
      radio_signal_strength(std::move(radio_signal_strength_in)),
      channel(std::move(channel_in)),
      signal_to_noise(std::move(signal_to_noise_in)),
      timestamp(std::move(timestamp_in)) {}

AccessPointData::~AccessPointData() = default;

void AccessPointData::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "mac_address"), this->mac_address,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type const std::string&>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "radio_signal_strength"), this->radio_signal_strength,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type int32_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "channel"), this->channel,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type int32_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "signal_to_noise"), this->signal_to_noise,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type int32_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "timestamp"), this->timestamp,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type absl::optional<::base::Time>>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool AccessPointData::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
NetworkLocationDiagnostics::NetworkLocationDiagnostics()
    : access_point_data(),
      wifi_timestamp() {}

NetworkLocationDiagnostics::NetworkLocationDiagnostics(
    std::vector<AccessPointDataPtr> access_point_data_in,
    absl::optional<::base::Time> wifi_timestamp_in)
    : access_point_data(std::move(access_point_data_in)),
      wifi_timestamp(std::move(wifi_timestamp_in)) {}

NetworkLocationDiagnostics::~NetworkLocationDiagnostics() = default;

void NetworkLocationDiagnostics::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "access_point_data"), this->access_point_data,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type std::vector<AccessPointDataPtr>>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "wifi_timestamp"), this->wifi_timestamp,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type absl::optional<::base::Time>>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool NetworkLocationDiagnostics::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
PositionCacheDiagnostics::PositionCacheDiagnostics()
    : cache_size(0U),
      last_hit(),
      last_miss(),
      hit_rate(),
      last_network_result() {}

PositionCacheDiagnostics::PositionCacheDiagnostics(
    uint32_t cache_size_in,
    absl::optional<::base::Time> last_hit_in,
    absl::optional<::base::Time> last_miss_in,
    absl::optional<double> hit_rate_in,
    ::device::mojom::GeopositionResultPtr last_network_result_in)
    : cache_size(std::move(cache_size_in)),
      last_hit(std::move(last_hit_in)),
      last_miss(std::move(last_miss_in)),
      hit_rate(std::move(hit_rate_in)),
      last_network_result(std::move(last_network_result_in)) {}

PositionCacheDiagnostics::~PositionCacheDiagnostics() = default;

void PositionCacheDiagnostics::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "cache_size"), this->cache_size,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint32_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "last_hit"), this->last_hit,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type absl::optional<::base::Time>>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "last_miss"), this->last_miss,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type absl::optional<::base::Time>>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "hit_rate"), this->hit_rate,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type absl::optional<double>>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "last_network_result"), this->last_network_result,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type ::device::mojom::GeopositionResultPtr>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool PositionCacheDiagnostics::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
WifiPollingPolicyDiagnostics::WifiPollingPolicyDiagnostics()
    : interval_start(),
      interval_duration(),
      polling_interval(),
      default_interval(),
      no_change_interval(),
      two_no_change_interval(),
      no_wifi_interval() {}

WifiPollingPolicyDiagnostics::WifiPollingPolicyDiagnostics(
    absl::optional<::base::Time> interval_start_in,
    ::base::TimeDelta interval_duration_in,
    ::base::TimeDelta polling_interval_in,
    ::base::TimeDelta default_interval_in,
    ::base::TimeDelta no_change_interval_in,
    ::base::TimeDelta two_no_change_interval_in,
    ::base::TimeDelta no_wifi_interval_in)
    : interval_start(std::move(interval_start_in)),
      interval_duration(std::move(interval_duration_in)),
      polling_interval(std::move(polling_interval_in)),
      default_interval(std::move(default_interval_in)),
      no_change_interval(std::move(no_change_interval_in)),
      two_no_change_interval(std::move(two_no_change_interval_in)),
      no_wifi_interval(std::move(no_wifi_interval_in)) {}

WifiPollingPolicyDiagnostics::~WifiPollingPolicyDiagnostics() = default;

void WifiPollingPolicyDiagnostics::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "interval_start"), this->interval_start,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type absl::optional<::base::Time>>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "interval_duration"), this->interval_duration,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type ::base::TimeDelta>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "polling_interval"), this->polling_interval,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type ::base::TimeDelta>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "default_interval"), this->default_interval,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type ::base::TimeDelta>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "no_change_interval"), this->no_change_interval,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type ::base::TimeDelta>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "two_no_change_interval"), this->two_no_change_interval,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type ::base::TimeDelta>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "no_wifi_interval"), this->no_wifi_interval,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type ::base::TimeDelta>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool WifiPollingPolicyDiagnostics::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
GeolocationDiagnostics::GeolocationDiagnostics()
    : provider_state(),
      network_location_diagnostics(),
      position_cache_diagnostics(),
      wifi_polling_policy_diagnostics() {}

GeolocationDiagnostics::GeolocationDiagnostics(
    GeolocationDiagnostics::ProviderState provider_state_in,
    NetworkLocationDiagnosticsPtr network_location_diagnostics_in,
    PositionCacheDiagnosticsPtr position_cache_diagnostics_in,
    WifiPollingPolicyDiagnosticsPtr wifi_polling_policy_diagnostics_in)
    : provider_state(std::move(provider_state_in)),
      network_location_diagnostics(std::move(network_location_diagnostics_in)),
      position_cache_diagnostics(std::move(position_cache_diagnostics_in)),
      wifi_polling_policy_diagnostics(std::move(wifi_polling_policy_diagnostics_in)) {}

GeolocationDiagnostics::~GeolocationDiagnostics() = default;

void GeolocationDiagnostics::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "provider_state"), this->provider_state,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type GeolocationDiagnostics::ProviderState>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "network_location_diagnostics"), this->network_location_diagnostics,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type NetworkLocationDiagnosticsPtr>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "position_cache_diagnostics"), this->position_cache_diagnostics,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type PositionCacheDiagnosticsPtr>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "wifi_polling_policy_diagnostics"), this->wifi_polling_policy_diagnostics,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type WifiPollingPolicyDiagnosticsPtr>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool GeolocationDiagnostics::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
const char GeolocationInternalsObserver::Name_[] = "device.mojom.GeolocationInternalsObserver";

GeolocationInternalsObserver::IPCStableHashFunction GeolocationInternalsObserver::MessageToMethodInfo_(mojo::Message& message) {
#if !BUILDFLAG(IS_FUCHSIA)
  switch (message.name()) {
    case internal::kGeolocationInternalsObserver_OnDiagnosticsChanged_Name: {
      return &GeolocationInternalsObserver::OnDiagnosticsChanged_Sym::IPCStableHash;
    }
  }
#endif  // !BUILDFLAG(IS_FUCHSIA)
  return nullptr;
}


const char* GeolocationInternalsObserver::MessageToMethodName_(mojo::Message& message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  bool is_response = message.has_flag(mojo::Message::kFlagIsResponse);
  if (!is_response) {
    switch (message.name()) {
      case internal::kGeolocationInternalsObserver_OnDiagnosticsChanged_Name:
            return "Receive device::mojom::GeolocationInternalsObserver::OnDiagnosticsChanged";
    }
  } else {
    switch (message.name()) {
      case internal::kGeolocationInternalsObserver_OnDiagnosticsChanged_Name:
            return "Receive reply device::mojom::GeolocationInternalsObserver::OnDiagnosticsChanged";
    }
  }
  return "Receive unknown mojo message";
#else
  bool is_response = message.has_flag(mojo::Message::kFlagIsResponse);
  if (is_response) {
    return "Receive mojo reply";
  } else {
    return "Receive mojo message";
  }
#endif // BUILDFLAG(MOJO_TRACE_ENABLED)
}

#if !BUILDFLAG(IS_FUCHSIA)
uint32_t GeolocationInternalsObserver::OnDiagnosticsChanged_Sym::IPCStableHash() {
  // This method's address is used for indetifiying the mojo method name after
  // symbolization. So each IPCStableHash should have a unique address.
  // We cannot use NO_CODE_FOLDING() here - it relies on the uniqueness of
  // __LINE__ value, which is not unique accross different mojo modules.
  // The code below is very similar to NO_CODE_FOLDING, but it uses a unique
  // hash instead of __LINE__.
  constexpr uint32_t kHash = base::MD5Hash32Constexpr(
          "(Impl)device::mojom::GeolocationInternalsObserver::OnDiagnosticsChanged");
  const uint32_t hash = kHash;
  base::debug::Alias(&hash);
  return hash;
}
# endif // !BUILDFLAG(IS_FUCHSIA)

GeolocationInternalsObserverProxy::GeolocationInternalsObserverProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void GeolocationInternalsObserverProxy::OnDiagnosticsChanged(
    GeolocationDiagnosticsPtr in_diagnostics) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "Send device::mojom::GeolocationInternalsObserver::OnDiagnosticsChanged", "input_parameters",
    [&](perfetto::TracedValue context){
      auto dict = std::move(context).WriteDictionary();
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("diagnostics"), in_diagnostics,
                        "<value of type GeolocationDiagnosticsPtr>");
   });
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  const bool kAllowInterrupt = true;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0) |
      ((kAllowInterrupt) ? 0 : mojo::Message::kFlagNoInterrupt);
  
  mojo::Message message(
      internal::kGeolocationInternalsObserver_OnDiagnosticsChanged_Name, kFlags, 0, 0, nullptr);
  mojo::internal::MessageFragment<
      ::device::mojom::internal::GeolocationInternalsObserver_OnDiagnosticsChanged_Params_Data> params(
          message);
  params.Allocate();
  mojo::internal::MessageFragment<
      typename decltype(params->diagnostics)::BaseType> diagnostics_fragment(
          params.message());
  mojo::internal::Serialize<::device::mojom::GeolocationDiagnosticsDataView>(
      in_diagnostics, diagnostics_fragment);
  params->diagnostics.Set(
      diagnostics_fragment.is_null() ? nullptr : diagnostics_fragment.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->diagnostics.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null diagnostics in GeolocationInternalsObserver.OnDiagnosticsChanged request");

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(GeolocationInternalsObserver::Name_);
  message.set_method_name("OnDiagnosticsChanged");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ::mojo::internal::SendMojoMessage(*receiver_, message);
}

// static
bool GeolocationInternalsObserverStubDispatch::Accept(
    GeolocationInternalsObserver* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kGeolocationInternalsObserver_OnDiagnosticsChanged_Name: {

      DCHECK(message->is_serialized());
      internal::GeolocationInternalsObserver_OnDiagnosticsChanged_Params_Data* params =
          reinterpret_cast<internal::GeolocationInternalsObserver_OnDiagnosticsChanged_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      GeolocationDiagnosticsPtr p_diagnostics{};
      GeolocationInternalsObserver_OnDiagnosticsChanged_ParamsDataView input_data_view(params, message);
      
      if (success && !input_data_view.ReadDiagnostics(&p_diagnostics))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            GeolocationInternalsObserver::Name_, 0, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->OnDiagnosticsChanged(
std::move(p_diagnostics));
      return true;
    }
  }
  return false;
}

// static
bool GeolocationInternalsObserverStubDispatch::AcceptWithResponder(
    GeolocationInternalsObserver* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  [[maybe_unused]] const bool message_is_sync =
      message->has_flag(mojo::Message::kFlagIsSync);
  [[maybe_unused]] const uint64_t request_id = message->request_id();
  switch (message->header()->name) {
    case internal::kGeolocationInternalsObserver_OnDiagnosticsChanged_Name: {
      break;
    }
  }
  return false;
}


static const std::pair<uint32_t, mojo::internal::GenericValidationInfo> kGeolocationInternalsObserverValidationInfo[] = {
    {internal::kGeolocationInternalsObserver_OnDiagnosticsChanged_Name,
     {&internal::GeolocationInternalsObserver_OnDiagnosticsChanged_Params_Data::Validate,
      nullptr /* no response */}},
};

bool GeolocationInternalsObserverRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::device::mojom::GeolocationInternalsObserver::Name_;
  return mojo::internal::ValidateRequestGeneric(message, name, kGeolocationInternalsObserverValidationInfo);
}

const char GeolocationInternals::Name_[] = "device.mojom.GeolocationInternals";

GeolocationInternals::IPCStableHashFunction GeolocationInternals::MessageToMethodInfo_(mojo::Message& message) {
#if !BUILDFLAG(IS_FUCHSIA)
  switch (message.name()) {
    case internal::kGeolocationInternals_AddInternalsObserver_Name: {
      return &GeolocationInternals::AddInternalsObserver_Sym::IPCStableHash;
    }
  }
#endif  // !BUILDFLAG(IS_FUCHSIA)
  return nullptr;
}


const char* GeolocationInternals::MessageToMethodName_(mojo::Message& message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  bool is_response = message.has_flag(mojo::Message::kFlagIsResponse);
  if (!is_response) {
    switch (message.name()) {
      case internal::kGeolocationInternals_AddInternalsObserver_Name:
            return "Receive device::mojom::GeolocationInternals::AddInternalsObserver";
    }
  } else {
    switch (message.name()) {
      case internal::kGeolocationInternals_AddInternalsObserver_Name:
            return "Receive reply device::mojom::GeolocationInternals::AddInternalsObserver";
    }
  }
  return "Receive unknown mojo message";
#else
  bool is_response = message.has_flag(mojo::Message::kFlagIsResponse);
  if (is_response) {
    return "Receive mojo reply";
  } else {
    return "Receive mojo message";
  }
#endif // BUILDFLAG(MOJO_TRACE_ENABLED)
}

#if !BUILDFLAG(IS_FUCHSIA)
uint32_t GeolocationInternals::AddInternalsObserver_Sym::IPCStableHash() {
  // This method's address is used for indetifiying the mojo method name after
  // symbolization. So each IPCStableHash should have a unique address.
  // We cannot use NO_CODE_FOLDING() here - it relies on the uniqueness of
  // __LINE__ value, which is not unique accross different mojo modules.
  // The code below is very similar to NO_CODE_FOLDING, but it uses a unique
  // hash instead of __LINE__.
  constexpr uint32_t kHash = base::MD5Hash32Constexpr(
          "(Impl)device::mojom::GeolocationInternals::AddInternalsObserver");
  const uint32_t hash = kHash;
  base::debug::Alias(&hash);
  return hash;
}
# endif // !BUILDFLAG(IS_FUCHSIA)

class GeolocationInternals_AddInternalsObserver_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  GeolocationInternals_AddInternalsObserver_ForwardToCallback(
      GeolocationInternals::AddInternalsObserverCallback callback
      ) : callback_(std::move(callback)) {
  }

  GeolocationInternals_AddInternalsObserver_ForwardToCallback(const GeolocationInternals_AddInternalsObserver_ForwardToCallback&) = delete;
  GeolocationInternals_AddInternalsObserver_ForwardToCallback& operator=(const GeolocationInternals_AddInternalsObserver_ForwardToCallback&) = delete;

  bool Accept(mojo::Message* message) override;
 private:
  GeolocationInternals::AddInternalsObserverCallback callback_;
};

GeolocationInternalsProxy::GeolocationInternalsProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void GeolocationInternalsProxy::AddInternalsObserver(
    ::mojo::PendingRemote<GeolocationInternalsObserver> in_observer, AddInternalsObserverCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "Send device::mojom::GeolocationInternals::AddInternalsObserver", "input_parameters",
    [&](perfetto::TracedValue context){
      auto dict = std::move(context).WriteDictionary();
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("observer"), in_observer,
                        "<value of type ::mojo::PendingRemote<GeolocationInternalsObserver>>");
   });
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  const bool kAllowInterrupt = true;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0) |
      ((kAllowInterrupt) ? 0 : mojo::Message::kFlagNoInterrupt);
  
  mojo::Message message(
      internal::kGeolocationInternals_AddInternalsObserver_Name, kFlags, 0, 0, nullptr);
  mojo::internal::MessageFragment<
      ::device::mojom::internal::GeolocationInternals_AddInternalsObserver_Params_Data> params(
          message);
  params.Allocate();
  mojo::internal::Serialize<mojo::InterfacePtrDataView<::device::mojom::GeolocationInternalsObserverInterfaceBase>>(
      in_observer, &params->observer, &params.message());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->observer),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid observer in GeolocationInternals.AddInternalsObserver request");

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(GeolocationInternals::Name_);
  message.set_method_name("AddInternalsObserver");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new GeolocationInternals_AddInternalsObserver_ForwardToCallback(
          std::move(callback)));
  ::mojo::internal::SendMojoMessage(*receiver_, message, std::move(responder));
}
class GeolocationInternals_AddInternalsObserver_ProxyToResponder : public ::mojo::internal::ProxyToResponder {
 public:
  static GeolocationInternals::AddInternalsObserverCallback CreateCallback(
      ::mojo::Message& message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<GeolocationInternals_AddInternalsObserver_ProxyToResponder> proxy(
        new GeolocationInternals_AddInternalsObserver_ProxyToResponder(
            message, std::move(responder)));
    return base::BindOnce(&GeolocationInternals_AddInternalsObserver_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~GeolocationInternals_AddInternalsObserver_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      // Instantiate a ScopedFizzleBlockShutdownTasks to allow this request to
      // fizzle if this happens after shutdown and the endpoint is bound to a
      // BLOCK_SHUTDOWN sequence.
      base::ThreadPoolInstance::ScopedFizzleBlockShutdownTasks fizzler;
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
  }

 private:
  GeolocationInternals_AddInternalsObserver_ProxyToResponder(
      ::mojo::Message& message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : ::mojo::internal::ProxyToResponder(message, std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
//    DCHECK(!connected)
//        << "GeolocationInternals::AddInternalsObserverCallback was destroyed without "
//        << "first either being run or its corresponding binding being closed. "
//        << "It is an error to drop response callbacks which still correspond "
//        << "to an open interface pipe.";
  }
#endif

  void Run(
      GeolocationDiagnosticsPtr in_diagnostics);
};

bool GeolocationInternals_AddInternalsObserver_ForwardToCallback::Accept(
    mojo::Message* message) {

  DCHECK(message->is_serialized());
  internal::GeolocationInternals_AddInternalsObserver_ResponseParams_Data* params =
      reinterpret_cast<
          internal::GeolocationInternals_AddInternalsObserver_ResponseParams_Data*>(
              message->mutable_payload());
  
  bool success = true;
  GeolocationDiagnosticsPtr p_diagnostics{};
  GeolocationInternals_AddInternalsObserver_ResponseParamsDataView input_data_view(params, message);
  
  if (success && !input_data_view.ReadDiagnostics(&p_diagnostics))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        GeolocationInternals::Name_, 0, true);
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_diagnostics));
  return true;
}

void GeolocationInternals_AddInternalsObserver_ProxyToResponder::Run(
    GeolocationDiagnosticsPtr in_diagnostics) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "Send reply device::mojom::GeolocationInternals::AddInternalsObserver", "async_response_parameters",
    [&](perfetto::TracedValue context){
      auto dict = std::move(context).WriteDictionary();
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("diagnostics"), in_diagnostics,
                        "<value of type GeolocationDiagnosticsPtr>");
   });
#endif
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0) |
      ((true) ? 0 : mojo::Message::kFlagNoInterrupt);
  
  mojo::Message message(
      internal::kGeolocationInternals_AddInternalsObserver_Name, kFlags, 0, 0, nullptr);
  mojo::internal::MessageFragment<
      ::device::mojom::internal::GeolocationInternals_AddInternalsObserver_ResponseParams_Data> params(
          message);
  params.Allocate();
  mojo::internal::MessageFragment<
      typename decltype(params->diagnostics)::BaseType> diagnostics_fragment(
          params.message());
  mojo::internal::Serialize<::device::mojom::GeolocationDiagnosticsDataView>(
      in_diagnostics, diagnostics_fragment);
  params->diagnostics.Set(
      diagnostics_fragment.is_null() ? nullptr : diagnostics_fragment.data());

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(GeolocationInternals::Name_);
  message.set_method_name("AddInternalsObserver");
#endif

  message.set_request_id(request_id_);
  message.set_trace_nonce(trace_nonce_);
  ::mojo::internal::SendMojoMessage(*responder_, message);
  // SendMojoMessage() fails silently if the responder connection is closed,
  // or if the message is malformed.
  //
  // TODO(darin): If Accept() returns false due to a malformed message, that
  // may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}

// static
bool GeolocationInternalsStubDispatch::Accept(
    GeolocationInternals* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kGeolocationInternals_AddInternalsObserver_Name: {
      break;
    }
  }
  return false;
}

// static
bool GeolocationInternalsStubDispatch::AcceptWithResponder(
    GeolocationInternals* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  [[maybe_unused]] const bool message_is_sync =
      message->has_flag(mojo::Message::kFlagIsSync);
  [[maybe_unused]] const uint64_t request_id = message->request_id();
  switch (message->header()->name) {
    case internal::kGeolocationInternals_AddInternalsObserver_Name: {

      internal::GeolocationInternals_AddInternalsObserver_Params_Data* params =
          reinterpret_cast<
              internal::GeolocationInternals_AddInternalsObserver_Params_Data*>(
                  message->mutable_payload());
      
      bool success = true;
      ::mojo::PendingRemote<GeolocationInternalsObserver> p_observer{};
      GeolocationInternals_AddInternalsObserver_ParamsDataView input_data_view(params, message);
      
      if (success) {
        p_observer =
            input_data_view.TakeObserver<decltype(p_observer)>();
      }
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            GeolocationInternals::Name_, 0, false);
        return false;
      }
      GeolocationInternals::AddInternalsObserverCallback callback =
          GeolocationInternals_AddInternalsObserver_ProxyToResponder::CreateCallback(
              *message, std::move(responder));
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->AddInternalsObserver(
std::move(p_observer), std::move(callback));
      return true;
    }
  }
  return false;
}


static const std::pair<uint32_t, mojo::internal::GenericValidationInfo> kGeolocationInternalsValidationInfo[] = {
    {internal::kGeolocationInternals_AddInternalsObserver_Name,
     {&internal::GeolocationInternals_AddInternalsObserver_Params_Data::Validate,
      &internal::GeolocationInternals_AddInternalsObserver_ResponseParams_Data::Validate}},
};

bool GeolocationInternalsRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::device::mojom::GeolocationInternals::Name_;
  return mojo::internal::ValidateRequestGeneric(message, name, kGeolocationInternalsValidationInfo);
}

bool GeolocationInternalsResponseValidator::Accept(mojo::Message* message) {
  const char* name = ::device::mojom::GeolocationInternals::Name_;
  return mojo::internal::ValidateResponseGeneric(message, name, kGeolocationInternalsValidationInfo);

}


}  // device::mojom


namespace mojo {


// static
bool StructTraits<::device::mojom::AccessPointData::DataView, ::device::mojom::AccessPointDataPtr>::Read(
    ::device::mojom::AccessPointData::DataView input,
    ::device::mojom::AccessPointDataPtr* output) {
  bool success = true;
  ::device::mojom::AccessPointDataPtr result(::device::mojom::AccessPointData::New());
  
      if (success && !input.ReadMacAddress(&result->mac_address))
        success = false;
      if (success)
        result->radio_signal_strength = input.radio_signal_strength();
      if (success)
        result->channel = input.channel();
      if (success)
        result->signal_to_noise = input.signal_to_noise();
      if (success && !input.ReadTimestamp(&result->timestamp))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::device::mojom::NetworkLocationDiagnostics::DataView, ::device::mojom::NetworkLocationDiagnosticsPtr>::Read(
    ::device::mojom::NetworkLocationDiagnostics::DataView input,
    ::device::mojom::NetworkLocationDiagnosticsPtr* output) {
  bool success = true;
  ::device::mojom::NetworkLocationDiagnosticsPtr result(::device::mojom::NetworkLocationDiagnostics::New());
  
      if (success && !input.ReadAccessPointData(&result->access_point_data))
        success = false;
      if (success && !input.ReadWifiTimestamp(&result->wifi_timestamp))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::device::mojom::PositionCacheDiagnostics::DataView, ::device::mojom::PositionCacheDiagnosticsPtr>::Read(
    ::device::mojom::PositionCacheDiagnostics::DataView input,
    ::device::mojom::PositionCacheDiagnosticsPtr* output) {
  bool success = true;
  ::device::mojom::PositionCacheDiagnosticsPtr result(::device::mojom::PositionCacheDiagnostics::New());
  
      if (success)
        result->cache_size = input.cache_size();
      if (success && !input.ReadLastHit(&result->last_hit))
        success = false;
      if (success && !input.ReadLastMiss(&result->last_miss))
        success = false;
      if (success) {
        result->hit_rate = input.hit_rate();
      }
      if (success && !input.ReadLastNetworkResult(&result->last_network_result))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::device::mojom::WifiPollingPolicyDiagnostics::DataView, ::device::mojom::WifiPollingPolicyDiagnosticsPtr>::Read(
    ::device::mojom::WifiPollingPolicyDiagnostics::DataView input,
    ::device::mojom::WifiPollingPolicyDiagnosticsPtr* output) {
  bool success = true;
  ::device::mojom::WifiPollingPolicyDiagnosticsPtr result(::device::mojom::WifiPollingPolicyDiagnostics::New());
  
      if (success && !input.ReadIntervalStart(&result->interval_start))
        success = false;
      if (success && !input.ReadIntervalDuration(&result->interval_duration))
        success = false;
      if (success && !input.ReadPollingInterval(&result->polling_interval))
        success = false;
      if (success && !input.ReadDefaultInterval(&result->default_interval))
        success = false;
      if (success && !input.ReadNoChangeInterval(&result->no_change_interval))
        success = false;
      if (success && !input.ReadTwoNoChangeInterval(&result->two_no_change_interval))
        success = false;
      if (success && !input.ReadNoWifiInterval(&result->no_wifi_interval))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::device::mojom::GeolocationDiagnostics::DataView, ::device::mojom::GeolocationDiagnosticsPtr>::Read(
    ::device::mojom::GeolocationDiagnostics::DataView input,
    ::device::mojom::GeolocationDiagnosticsPtr* output) {
  bool success = true;
  ::device::mojom::GeolocationDiagnosticsPtr result(::device::mojom::GeolocationDiagnostics::New());
  
      if (success && !input.ReadProviderState(&result->provider_state))
        success = false;
      if (success && !input.ReadNetworkLocationDiagnostics(&result->network_location_diagnostics))
        success = false;
      if (success && !input.ReadPositionCacheDiagnostics(&result->position_cache_diagnostics))
        success = false;
      if (success && !input.ReadWifiPollingPolicyDiagnostics(&result->wifi_polling_policy_diagnostics))
        success = false;
  *output = std::move(result);
  return success;
}

}  // namespace mojo


// Symbols declared in the -test-utils.h header are defined here instead of a
// separate .cc file to save compile time.


namespace device::mojom {


void GeolocationInternalsObserverInterceptorForTesting::OnDiagnosticsChanged(GeolocationDiagnosticsPtr diagnostics) {
  GetForwardingInterface()->OnDiagnosticsChanged(std::move(diagnostics));
}
GeolocationInternalsObserverAsyncWaiter::GeolocationInternalsObserverAsyncWaiter(
    GeolocationInternalsObserver* proxy) : proxy_(proxy) {}

GeolocationInternalsObserverAsyncWaiter::~GeolocationInternalsObserverAsyncWaiter() = default;




void GeolocationInternalsInterceptorForTesting::AddInternalsObserver(::mojo::PendingRemote<GeolocationInternalsObserver> observer, AddInternalsObserverCallback callback) {
  GetForwardingInterface()->AddInternalsObserver(std::move(observer), std::move(callback));
}
GeolocationInternalsAsyncWaiter::GeolocationInternalsAsyncWaiter(
    GeolocationInternals* proxy) : proxy_(proxy) {}

GeolocationInternalsAsyncWaiter::~GeolocationInternalsAsyncWaiter() = default;

void GeolocationInternalsAsyncWaiter::AddInternalsObserver(
    ::mojo::PendingRemote<GeolocationInternalsObserver> observer, GeolocationDiagnosticsPtr* out_diagnostics) {
  base::RunLoop loop;
  proxy_->AddInternalsObserver(std::move(observer),
      base::BindOnce(
          [](base::RunLoop* loop,
             GeolocationDiagnosticsPtr* out_diagnostics
,
             GeolocationDiagnosticsPtr diagnostics) {*out_diagnostics = std::move(diagnostics);
            loop->Quit();
          },
          &loop,
          out_diagnostics));
  loop.Run();
}

GeolocationDiagnosticsPtr GeolocationInternalsAsyncWaiter::AddInternalsObserver(
    ::mojo::PendingRemote<GeolocationInternalsObserver> observer) {
  GeolocationDiagnosticsPtr async_wait_result;
  AddInternalsObserver(std::move(observer),&async_wait_result);
  return async_wait_result;
}






}  // device::mojom


#if defined(__clang__)
#pragma clang diagnostic pop
#endif