// services/viz/public/mojom/compositing/compositor_frame_transition_directive.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_VIZ_PUBLIC_MOJOM_COMPOSITING_COMPOSITOR_FRAME_TRANSITION_DIRECTIVE_MOJOM_H_
#define SERVICES_VIZ_PUBLIC_MOJOM_COMPOSITING_COMPOSITOR_FRAME_TRANSITION_DIRECTIVE_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "third_party/abseil-cpp/absl/types/optional.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "services/viz/public/mojom/compositing/compositor_frame_transition_directive.mojom-shared.h"
#include "services/viz/public/mojom/compositing/compositor_frame_transition_directive.mojom-forward.h"
#include "mojo/public/mojom/base/unguessable_token.mojom.h"
#include "services/viz/public/mojom/compositing/compositor_render_pass_id.mojom.h"
#include "services/viz/public/mojom/compositing/view_transition_element_resource_id.mojom.h"
#include <string>
#include <vector>




#include "services/viz/public/cpp/compositing/compositor_frame_transition_directive_mojom_traits.h"




namespace viz::mojom {









class  CompositorFrameTransitionDirectiveSharedElement {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<CompositorFrameTransitionDirectiveSharedElement, T>::value>;
  using DataView = CompositorFrameTransitionDirectiveSharedElementDataView;
  using Data_ = internal::CompositorFrameTransitionDirectiveSharedElement_Data;

  template <typename... Args>
  static CompositorFrameTransitionDirectiveSharedElementPtr New(Args&&... args) {
    return CompositorFrameTransitionDirectiveSharedElementPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static CompositorFrameTransitionDirectiveSharedElementPtr From(const U& u) {
    return mojo::TypeConverter<CompositorFrameTransitionDirectiveSharedElementPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, CompositorFrameTransitionDirectiveSharedElement>::Convert(*this);
  }


  CompositorFrameTransitionDirectiveSharedElement();

  CompositorFrameTransitionDirectiveSharedElement(
      const ::viz::CompositorRenderPassId& render_pass_id,
      const ::viz::ViewTransitionElementResourceId& view_transition_element_resource_id);


  ~CompositorFrameTransitionDirectiveSharedElement();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = CompositorFrameTransitionDirectiveSharedElementPtr>
  CompositorFrameTransitionDirectiveSharedElementPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, CompositorFrameTransitionDirectiveSharedElement::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, CompositorFrameTransitionDirectiveSharedElement::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, CompositorFrameTransitionDirectiveSharedElement::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        CompositorFrameTransitionDirectiveSharedElement::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        CompositorFrameTransitionDirectiveSharedElement::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::CompositorFrameTransitionDirectiveSharedElement_UnserializedMessageContext<
            UserType, CompositorFrameTransitionDirectiveSharedElement::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<CompositorFrameTransitionDirectiveSharedElement::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return CompositorFrameTransitionDirectiveSharedElement::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::CompositorFrameTransitionDirectiveSharedElement_UnserializedMessageContext<
            UserType, CompositorFrameTransitionDirectiveSharedElement::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<CompositorFrameTransitionDirectiveSharedElement::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::viz::CompositorRenderPassId render_pass_id;
  
  ::viz::ViewTransitionElementResourceId view_transition_element_resource_id;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, CompositorFrameTransitionDirectiveSharedElement::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, CompositorFrameTransitionDirectiveSharedElement::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, CompositorFrameTransitionDirectiveSharedElement::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, CompositorFrameTransitionDirectiveSharedElement::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  CompositorFrameTransitionDirective {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<CompositorFrameTransitionDirective, T>::value>;
  using DataView = CompositorFrameTransitionDirectiveDataView;
  using Data_ = internal::CompositorFrameTransitionDirective_Data;

  template <typename... Args>
  static CompositorFrameTransitionDirectivePtr New(Args&&... args) {
    return CompositorFrameTransitionDirectivePtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static CompositorFrameTransitionDirectivePtr From(const U& u) {
    return mojo::TypeConverter<CompositorFrameTransitionDirectivePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, CompositorFrameTransitionDirective>::Convert(*this);
  }


  CompositorFrameTransitionDirective();

  CompositorFrameTransitionDirective(
      const absl::optional<::base::UnguessableToken>& navigation_id,
      uint32_t sequence_id,
      CompositorFrameTransitionDirectiveType type,
      std::vector<CompositorFrameTransitionDirectiveSharedElementPtr> shared_elements);

CompositorFrameTransitionDirective(const CompositorFrameTransitionDirective&) = delete;
CompositorFrameTransitionDirective& operator=(const CompositorFrameTransitionDirective&) = delete;

  ~CompositorFrameTransitionDirective();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = CompositorFrameTransitionDirectivePtr>
  CompositorFrameTransitionDirectivePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, CompositorFrameTransitionDirective::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, CompositorFrameTransitionDirective::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, CompositorFrameTransitionDirective::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        CompositorFrameTransitionDirective::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        CompositorFrameTransitionDirective::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::CompositorFrameTransitionDirective_UnserializedMessageContext<
            UserType, CompositorFrameTransitionDirective::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<CompositorFrameTransitionDirective::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return CompositorFrameTransitionDirective::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::CompositorFrameTransitionDirective_UnserializedMessageContext<
            UserType, CompositorFrameTransitionDirective::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<CompositorFrameTransitionDirective::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  absl::optional<::base::UnguessableToken> navigation_id;
  
  uint32_t sequence_id;
  
  CompositorFrameTransitionDirectiveType type;
  
  std::vector<CompositorFrameTransitionDirectiveSharedElementPtr> shared_elements;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, CompositorFrameTransitionDirective::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, CompositorFrameTransitionDirective::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, CompositorFrameTransitionDirective::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, CompositorFrameTransitionDirective::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
CompositorFrameTransitionDirectiveSharedElementPtr CompositorFrameTransitionDirectiveSharedElement::Clone() const {
  return New(
      mojo::Clone(render_pass_id),
      mojo::Clone(view_transition_element_resource_id)
  );
}

template <typename T, CompositorFrameTransitionDirectiveSharedElement::EnableIfSame<T>*>
bool CompositorFrameTransitionDirectiveSharedElement::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->render_pass_id, other_struct.render_pass_id))
    return false;
  if (!mojo::Equals(this->view_transition_element_resource_id, other_struct.view_transition_element_resource_id))
    return false;
  return true;
}

template <typename T, CompositorFrameTransitionDirectiveSharedElement::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.render_pass_id < rhs.render_pass_id)
    return true;
  if (rhs.render_pass_id < lhs.render_pass_id)
    return false;
  if (lhs.view_transition_element_resource_id < rhs.view_transition_element_resource_id)
    return true;
  if (rhs.view_transition_element_resource_id < lhs.view_transition_element_resource_id)
    return false;
  return false;
}
template <typename StructPtrType>
CompositorFrameTransitionDirectivePtr CompositorFrameTransitionDirective::Clone() const {
  return New(
      mojo::Clone(navigation_id),
      mojo::Clone(sequence_id),
      mojo::Clone(type),
      mojo::Clone(shared_elements)
  );
}

template <typename T, CompositorFrameTransitionDirective::EnableIfSame<T>*>
bool CompositorFrameTransitionDirective::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->navigation_id, other_struct.navigation_id))
    return false;
  if (!mojo::Equals(this->sequence_id, other_struct.sequence_id))
    return false;
  if (!mojo::Equals(this->type, other_struct.type))
    return false;
  if (!mojo::Equals(this->shared_elements, other_struct.shared_elements))
    return false;
  return true;
}

template <typename T, CompositorFrameTransitionDirective::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.navigation_id < rhs.navigation_id)
    return true;
  if (rhs.navigation_id < lhs.navigation_id)
    return false;
  if (lhs.sequence_id < rhs.sequence_id)
    return true;
  if (rhs.sequence_id < lhs.sequence_id)
    return false;
  if (lhs.type < rhs.type)
    return true;
  if (rhs.type < lhs.type)
    return false;
  if (lhs.shared_elements < rhs.shared_elements)
    return true;
  if (rhs.shared_elements < lhs.shared_elements)
    return false;
  return false;
}


}  // viz::mojom

namespace mojo {


template <>
struct  StructTraits<::viz::mojom::CompositorFrameTransitionDirectiveSharedElement::DataView,
                                         ::viz::mojom::CompositorFrameTransitionDirectiveSharedElementPtr> {
  static bool IsNull(const ::viz::mojom::CompositorFrameTransitionDirectiveSharedElementPtr& input) { return !input; }
  static void SetToNull(::viz::mojom::CompositorFrameTransitionDirectiveSharedElementPtr* output) { output->reset(); }

  static const decltype(::viz::mojom::CompositorFrameTransitionDirectiveSharedElement::render_pass_id)& render_pass_id(
      const ::viz::mojom::CompositorFrameTransitionDirectiveSharedElementPtr& input) {
    return input->render_pass_id;
  }

  static const decltype(::viz::mojom::CompositorFrameTransitionDirectiveSharedElement::view_transition_element_resource_id)& view_transition_element_resource_id(
      const ::viz::mojom::CompositorFrameTransitionDirectiveSharedElementPtr& input) {
    return input->view_transition_element_resource_id;
  }

  static bool Read(::viz::mojom::CompositorFrameTransitionDirectiveSharedElement::DataView input, ::viz::mojom::CompositorFrameTransitionDirectiveSharedElementPtr* output);
};


template <>
struct  StructTraits<::viz::mojom::CompositorFrameTransitionDirective::DataView,
                                         ::viz::mojom::CompositorFrameTransitionDirectivePtr> {
  static bool IsNull(const ::viz::mojom::CompositorFrameTransitionDirectivePtr& input) { return !input; }
  static void SetToNull(::viz::mojom::CompositorFrameTransitionDirectivePtr* output) { output->reset(); }

  static const decltype(::viz::mojom::CompositorFrameTransitionDirective::navigation_id)& navigation_id(
      const ::viz::mojom::CompositorFrameTransitionDirectivePtr& input) {
    return input->navigation_id;
  }

  static decltype(::viz::mojom::CompositorFrameTransitionDirective::sequence_id) sequence_id(
      const ::viz::mojom::CompositorFrameTransitionDirectivePtr& input) {
    return input->sequence_id;
  }

  static decltype(::viz::mojom::CompositorFrameTransitionDirective::type) type(
      const ::viz::mojom::CompositorFrameTransitionDirectivePtr& input) {
    return input->type;
  }

  static const decltype(::viz::mojom::CompositorFrameTransitionDirective::shared_elements)& shared_elements(
      const ::viz::mojom::CompositorFrameTransitionDirectivePtr& input) {
    return input->shared_elements;
  }

  static bool Read(::viz::mojom::CompositorFrameTransitionDirective::DataView input, ::viz::mojom::CompositorFrameTransitionDirectivePtr* output);
};

}  // namespace mojo

#endif  // SERVICES_VIZ_PUBLIC_MOJOM_COMPOSITING_COMPOSITOR_FRAME_TRANSITION_DIRECTIVE_MOJOM_H_