// services/viz/public/mojom/compositing/layer_context.mojom-blink.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#endif

#include "services/viz/public/mojom/compositing/layer_context.mojom-blink.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/debug/alias.h"
#include "base/hash/md5_constexpr.h"
#include "base/run_loop.h"
#include "base/strings/string_number_conversions.h"
#include "base/task/thread_pool/thread_pool_instance.h"
#include "base/trace_event/trace_event.h"
#include "base/trace_event/typed_macros.h"
#include "mojo/public/cpp/bindings/lib/default_construct_tag_internal.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/send_message_helper.h"
#include "mojo/public/cpp/bindings/lib/proxy_to_responder.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "services/viz/public/mojom/compositing/layer_context.mojom-params-data.h"
#include "services/viz/public/mojom/compositing/layer_context.mojom-shared-message-ids.h"

#include "services/viz/public/mojom/compositing/layer_context.mojom-blink-import-headers.h"
#include "services/viz/public/mojom/compositing/layer_context.mojom-blink-test-utils.h"
#include "mojo/public/cpp/bindings/lib/wtf_serialization.h"
#include "services/viz/public/cpp/compositing/begin_frame_args_mojom_traits.h"


namespace viz::mojom::blink {
LayerTreeUpdate::LayerTreeUpdate()
    : device_viewport(),
      device_scale_factor(),
      local_surface_id_from_parent() {}

LayerTreeUpdate::LayerTreeUpdate(
    const ::gfx::Rect& device_viewport_in,
    float device_scale_factor_in,
    const ::viz::LocalSurfaceId& local_surface_id_from_parent_in)
    : device_viewport(std::move(device_viewport_in)),
      device_scale_factor(std::move(device_scale_factor_in)),
      local_surface_id_from_parent(std::move(local_surface_id_from_parent_in)) {}

LayerTreeUpdate::~LayerTreeUpdate() = default;

void LayerTreeUpdate::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "device_viewport"), this->device_viewport,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type const ::gfx::Rect&>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "device_scale_factor"), this->device_scale_factor,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type float>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "local_surface_id_from_parent"), this->local_surface_id_from_parent,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type const ::viz::LocalSurfaceId&>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool LayerTreeUpdate::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
PendingLayerContext::PendingLayerContext()
    : receiver(),
      client() {}

PendingLayerContext::PendingLayerContext(
    ::mojo::PendingAssociatedReceiver<LayerContext> receiver_in,
    ::mojo::PendingAssociatedRemote<LayerContextClient> client_in)
    : receiver(std::move(receiver_in)),
      client(std::move(client_in)) {}

PendingLayerContext::~PendingLayerContext() = default;

void PendingLayerContext::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "receiver"), this->receiver,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type ::mojo::PendingAssociatedReceiver<LayerContext>>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "client"), this->client,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type ::mojo::PendingAssociatedRemote<LayerContextClient>>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool PendingLayerContext::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
const char LayerContext::Name_[] = "viz.mojom.LayerContext";

LayerContext::IPCStableHashFunction LayerContext::MessageToMethodInfo_(mojo::Message& message) {
#if !BUILDFLAG(IS_FUCHSIA)
  switch (message.name()) {
    case internal::kLayerContext_SetTargetLocalSurfaceId_Name: {
      return &LayerContext::SetTargetLocalSurfaceId_Sym::IPCStableHash;
    }
    case internal::kLayerContext_SetVisible_Name: {
      return &LayerContext::SetVisible_Sym::IPCStableHash;
    }
    case internal::kLayerContext_Commit_Name: {
      return &LayerContext::Commit_Sym::IPCStableHash;
    }
  }
#endif  // !BUILDFLAG(IS_FUCHSIA)
  return nullptr;
}


const char* LayerContext::MessageToMethodName_(mojo::Message& message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  bool is_response = message.has_flag(mojo::Message::kFlagIsResponse);
  if (!is_response) {
    switch (message.name()) {
      case internal::kLayerContext_SetTargetLocalSurfaceId_Name:
            return "Receive viz::mojom::LayerContext::SetTargetLocalSurfaceId";
      case internal::kLayerContext_SetVisible_Name:
            return "Receive viz::mojom::LayerContext::SetVisible";
      case internal::kLayerContext_Commit_Name:
            return "Receive viz::mojom::LayerContext::Commit";
    }
  } else {
    switch (message.name()) {
      case internal::kLayerContext_SetTargetLocalSurfaceId_Name:
            return "Receive reply viz::mojom::LayerContext::SetTargetLocalSurfaceId";
      case internal::kLayerContext_SetVisible_Name:
            return "Receive reply viz::mojom::LayerContext::SetVisible";
      case internal::kLayerContext_Commit_Name:
            return "Receive reply viz::mojom::LayerContext::Commit";
    }
  }
  return "Receive unknown mojo message";
#else
  bool is_response = message.has_flag(mojo::Message::kFlagIsResponse);
  if (is_response) {
    return "Receive mojo reply";
  } else {
    return "Receive mojo message";
  }
#endif // BUILDFLAG(MOJO_TRACE_ENABLED)
}

#if !BUILDFLAG(IS_FUCHSIA)
uint32_t LayerContext::SetTargetLocalSurfaceId_Sym::IPCStableHash() {
  // This method's address is used for indetifiying the mojo method name after
  // symbolization. So each IPCStableHash should have a unique address.
  // We cannot use NO_CODE_FOLDING() here - it relies on the uniqueness of
  // __LINE__ value, which is not unique accross different mojo modules.
  // The code below is very similar to NO_CODE_FOLDING, but it uses a unique
  // hash instead of __LINE__.
  constexpr uint32_t kHash = base::MD5Hash32Constexpr(
          "(Impl)viz::mojom::LayerContext::SetTargetLocalSurfaceId");
  const uint32_t hash = kHash;
  base::debug::Alias(&hash);
  return hash;
}
uint32_t LayerContext::SetVisible_Sym::IPCStableHash() {
  // This method's address is used for indetifiying the mojo method name after
  // symbolization. So each IPCStableHash should have a unique address.
  // We cannot use NO_CODE_FOLDING() here - it relies on the uniqueness of
  // __LINE__ value, which is not unique accross different mojo modules.
  // The code below is very similar to NO_CODE_FOLDING, but it uses a unique
  // hash instead of __LINE__.
  constexpr uint32_t kHash = base::MD5Hash32Constexpr(
          "(Impl)viz::mojom::LayerContext::SetVisible");
  const uint32_t hash = kHash;
  base::debug::Alias(&hash);
  return hash;
}
uint32_t LayerContext::Commit_Sym::IPCStableHash() {
  // This method's address is used for indetifiying the mojo method name after
  // symbolization. So each IPCStableHash should have a unique address.
  // We cannot use NO_CODE_FOLDING() here - it relies on the uniqueness of
  // __LINE__ value, which is not unique accross different mojo modules.
  // The code below is very similar to NO_CODE_FOLDING, but it uses a unique
  // hash instead of __LINE__.
  constexpr uint32_t kHash = base::MD5Hash32Constexpr(
          "(Impl)viz::mojom::LayerContext::Commit");
  const uint32_t hash = kHash;
  base::debug::Alias(&hash);
  return hash;
}
# endif // !BUILDFLAG(IS_FUCHSIA)

LayerContextProxy::LayerContextProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void LayerContextProxy::SetTargetLocalSurfaceId(
    const ::viz::LocalSurfaceId& in_id) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "Send viz::mojom::LayerContext::SetTargetLocalSurfaceId", "input_parameters",
    [&](perfetto::TracedValue context){
      auto dict = std::move(context).WriteDictionary();
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("id"), in_id,
                        "<value of type const ::viz::LocalSurfaceId&>");
   });
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  const bool kAllowInterrupt = true;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0) |
      ((kAllowInterrupt) ? 0 : mojo::Message::kFlagNoInterrupt);
  
  mojo::Message message(
      internal::kLayerContext_SetTargetLocalSurfaceId_Name, kFlags, 0, 0, nullptr);
  mojo::internal::MessageFragment<
      ::viz::mojom::internal::LayerContext_SetTargetLocalSurfaceId_Params_Data> params(
          message);
  params.Allocate();
  mojo::internal::MessageFragment<
      typename decltype(params->id)::BaseType> id_fragment(
          params.message());
  mojo::internal::Serialize<::viz::mojom::LocalSurfaceIdDataView>(
      in_id, id_fragment);
  params->id.Set(
      id_fragment.is_null() ? nullptr : id_fragment.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null id in LayerContext.SetTargetLocalSurfaceId request");

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(LayerContext::Name_);
  message.set_method_name("SetTargetLocalSurfaceId");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ::mojo::internal::SendMojoMessage(*receiver_, message);
}

void LayerContextProxy::SetVisible(
    bool in_visible) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "Send viz::mojom::LayerContext::SetVisible", "input_parameters",
    [&](perfetto::TracedValue context){
      auto dict = std::move(context).WriteDictionary();
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("visible"), in_visible,
                        "<value of type bool>");
   });
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  const bool kAllowInterrupt = true;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0) |
      ((kAllowInterrupt) ? 0 : mojo::Message::kFlagNoInterrupt);
  
  mojo::Message message(
      internal::kLayerContext_SetVisible_Name, kFlags, 0, 0, nullptr);
  mojo::internal::MessageFragment<
      ::viz::mojom::internal::LayerContext_SetVisible_Params_Data> params(
          message);
  params.Allocate();
  params->visible = in_visible;

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(LayerContext::Name_);
  message.set_method_name("SetVisible");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ::mojo::internal::SendMojoMessage(*receiver_, message);
}

void LayerContextProxy::Commit(
    LayerTreeUpdatePtr in_update) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "Send viz::mojom::LayerContext::Commit", "input_parameters",
    [&](perfetto::TracedValue context){
      auto dict = std::move(context).WriteDictionary();
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("update"), in_update,
                        "<value of type LayerTreeUpdatePtr>");
   });
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  const bool kAllowInterrupt = true;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0) |
      ((kAllowInterrupt) ? 0 : mojo::Message::kFlagNoInterrupt);
  
  mojo::Message message(
      internal::kLayerContext_Commit_Name, kFlags, 0, 0, nullptr);
  mojo::internal::MessageFragment<
      ::viz::mojom::internal::LayerContext_Commit_Params_Data> params(
          message);
  params.Allocate();
  mojo::internal::MessageFragment<
      typename decltype(params->update)::BaseType> update_fragment(
          params.message());
  mojo::internal::Serialize<::viz::mojom::LayerTreeUpdateDataView>(
      in_update, update_fragment);
  params->update.Set(
      update_fragment.is_null() ? nullptr : update_fragment.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->update.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null update in LayerContext.Commit request");

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(LayerContext::Name_);
  message.set_method_name("Commit");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ::mojo::internal::SendMojoMessage(*receiver_, message);
}

// static
bool LayerContextStubDispatch::Accept(
    LayerContext* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kLayerContext_SetTargetLocalSurfaceId_Name: {

      DCHECK(message->is_serialized());
      internal::LayerContext_SetTargetLocalSurfaceId_Params_Data* params =
          reinterpret_cast<internal::LayerContext_SetTargetLocalSurfaceId_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      ::viz::LocalSurfaceId p_id{};
      LayerContext_SetTargetLocalSurfaceId_ParamsDataView input_data_view(params, message);
      
      if (success && !input_data_view.ReadId(&p_id))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            LayerContext::Name_, 0, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->SetTargetLocalSurfaceId(
std::move(p_id));
      return true;
    }
    case internal::kLayerContext_SetVisible_Name: {

      DCHECK(message->is_serialized());
      internal::LayerContext_SetVisible_Params_Data* params =
          reinterpret_cast<internal::LayerContext_SetVisible_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      bool p_visible{};
      LayerContext_SetVisible_ParamsDataView input_data_view(params, message);
      
      if (success)
        p_visible = input_data_view.visible();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            LayerContext::Name_, 1, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->SetVisible(
std::move(p_visible));
      return true;
    }
    case internal::kLayerContext_Commit_Name: {

      DCHECK(message->is_serialized());
      internal::LayerContext_Commit_Params_Data* params =
          reinterpret_cast<internal::LayerContext_Commit_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      LayerTreeUpdatePtr p_update{};
      LayerContext_Commit_ParamsDataView input_data_view(params, message);
      
      if (success && !input_data_view.ReadUpdate(&p_update))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            LayerContext::Name_, 2, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->Commit(
std::move(p_update));
      return true;
    }
  }
  return false;
}

// static
bool LayerContextStubDispatch::AcceptWithResponder(
    LayerContext* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  [[maybe_unused]] const bool message_is_sync =
      message->has_flag(mojo::Message::kFlagIsSync);
  [[maybe_unused]] const uint64_t request_id = message->request_id();
  switch (message->header()->name) {
    case internal::kLayerContext_SetTargetLocalSurfaceId_Name: {
      break;
    }
    case internal::kLayerContext_SetVisible_Name: {
      break;
    }
    case internal::kLayerContext_Commit_Name: {
      break;
    }
  }
  return false;
}


static const std::pair<uint32_t, mojo::internal::GenericValidationInfo> kLayerContextValidationInfo[] = {
    {internal::kLayerContext_SetTargetLocalSurfaceId_Name,
     {&internal::LayerContext_SetTargetLocalSurfaceId_Params_Data::Validate,
      nullptr /* no response */}},
    {internal::kLayerContext_SetVisible_Name,
     {&internal::LayerContext_SetVisible_Params_Data::Validate,
      nullptr /* no response */}},
    {internal::kLayerContext_Commit_Name,
     {&internal::LayerContext_Commit_Params_Data::Validate,
      nullptr /* no response */}},
};

bool LayerContextRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::viz::mojom::blink::LayerContext::Name_;
  return mojo::internal::ValidateRequestGeneric(message, name, kLayerContextValidationInfo);
}

const char LayerContextClient::Name_[] = "viz.mojom.LayerContextClient";

LayerContextClient::IPCStableHashFunction LayerContextClient::MessageToMethodInfo_(mojo::Message& message) {
#if !BUILDFLAG(IS_FUCHSIA)
  switch (message.name()) {
    case internal::kLayerContextClient_OnRequestCommitForFrame_Name: {
      return &LayerContextClient::OnRequestCommitForFrame_Sym::IPCStableHash;
    }
  }
#endif  // !BUILDFLAG(IS_FUCHSIA)
  return nullptr;
}


const char* LayerContextClient::MessageToMethodName_(mojo::Message& message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  bool is_response = message.has_flag(mojo::Message::kFlagIsResponse);
  if (!is_response) {
    switch (message.name()) {
      case internal::kLayerContextClient_OnRequestCommitForFrame_Name:
            return "Receive viz::mojom::LayerContextClient::OnRequestCommitForFrame";
    }
  } else {
    switch (message.name()) {
      case internal::kLayerContextClient_OnRequestCommitForFrame_Name:
            return "Receive reply viz::mojom::LayerContextClient::OnRequestCommitForFrame";
    }
  }
  return "Receive unknown mojo message";
#else
  bool is_response = message.has_flag(mojo::Message::kFlagIsResponse);
  if (is_response) {
    return "Receive mojo reply";
  } else {
    return "Receive mojo message";
  }
#endif // BUILDFLAG(MOJO_TRACE_ENABLED)
}

#if !BUILDFLAG(IS_FUCHSIA)
uint32_t LayerContextClient::OnRequestCommitForFrame_Sym::IPCStableHash() {
  // This method's address is used for indetifiying the mojo method name after
  // symbolization. So each IPCStableHash should have a unique address.
  // We cannot use NO_CODE_FOLDING() here - it relies on the uniqueness of
  // __LINE__ value, which is not unique accross different mojo modules.
  // The code below is very similar to NO_CODE_FOLDING, but it uses a unique
  // hash instead of __LINE__.
  constexpr uint32_t kHash = base::MD5Hash32Constexpr(
          "(Impl)viz::mojom::LayerContextClient::OnRequestCommitForFrame");
  const uint32_t hash = kHash;
  base::debug::Alias(&hash);
  return hash;
}
# endif // !BUILDFLAG(IS_FUCHSIA)

LayerContextClientProxy::LayerContextClientProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void LayerContextClientProxy::OnRequestCommitForFrame(
    const ::viz::BeginFrameArgs& in_args) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "Send viz::mojom::LayerContextClient::OnRequestCommitForFrame", "input_parameters",
    [&](perfetto::TracedValue context){
      auto dict = std::move(context).WriteDictionary();
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("args"), in_args,
                        "<value of type const ::viz::BeginFrameArgs&>");
   });
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  const bool kAllowInterrupt = true;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0) |
      ((kAllowInterrupt) ? 0 : mojo::Message::kFlagNoInterrupt);
  
  mojo::Message message(
      internal::kLayerContextClient_OnRequestCommitForFrame_Name, kFlags, 0, 0, nullptr);
  mojo::internal::MessageFragment<
      ::viz::mojom::internal::LayerContextClient_OnRequestCommitForFrame_Params_Data> params(
          message);
  params.Allocate();
  mojo::internal::MessageFragment<
      typename decltype(params->args)::BaseType> args_fragment(
          params.message());
  mojo::internal::Serialize<::viz::mojom::BeginFrameArgsDataView>(
      in_args, args_fragment);
  params->args.Set(
      args_fragment.is_null() ? nullptr : args_fragment.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->args.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null args in LayerContextClient.OnRequestCommitForFrame request");

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(LayerContextClient::Name_);
  message.set_method_name("OnRequestCommitForFrame");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ::mojo::internal::SendMojoMessage(*receiver_, message);
}

// static
bool LayerContextClientStubDispatch::Accept(
    LayerContextClient* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kLayerContextClient_OnRequestCommitForFrame_Name: {

      DCHECK(message->is_serialized());
      internal::LayerContextClient_OnRequestCommitForFrame_Params_Data* params =
          reinterpret_cast<internal::LayerContextClient_OnRequestCommitForFrame_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      ::viz::BeginFrameArgs p_args{};
      LayerContextClient_OnRequestCommitForFrame_ParamsDataView input_data_view(params, message);
      
      if (success && !input_data_view.ReadArgs(&p_args))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            LayerContextClient::Name_, 0, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->OnRequestCommitForFrame(
std::move(p_args));
      return true;
    }
  }
  return false;
}

// static
bool LayerContextClientStubDispatch::AcceptWithResponder(
    LayerContextClient* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  [[maybe_unused]] const bool message_is_sync =
      message->has_flag(mojo::Message::kFlagIsSync);
  [[maybe_unused]] const uint64_t request_id = message->request_id();
  switch (message->header()->name) {
    case internal::kLayerContextClient_OnRequestCommitForFrame_Name: {
      break;
    }
  }
  return false;
}


static const std::pair<uint32_t, mojo::internal::GenericValidationInfo> kLayerContextClientValidationInfo[] = {
    {internal::kLayerContextClient_OnRequestCommitForFrame_Name,
     {&internal::LayerContextClient_OnRequestCommitForFrame_Params_Data::Validate,
      nullptr /* no response */}},
};

bool LayerContextClientRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::viz::mojom::blink::LayerContextClient::Name_;
  return mojo::internal::ValidateRequestGeneric(message, name, kLayerContextClientValidationInfo);
}



}  // viz::mojom::blink


namespace mojo {


// static
bool StructTraits<::viz::mojom::blink::LayerTreeUpdate::DataView, ::viz::mojom::blink::LayerTreeUpdatePtr>::Read(
    ::viz::mojom::blink::LayerTreeUpdate::DataView input,
    ::viz::mojom::blink::LayerTreeUpdatePtr* output) {
  bool success = true;
  ::viz::mojom::blink::LayerTreeUpdatePtr result(::viz::mojom::blink::LayerTreeUpdate::New());
  
      if (success && !input.ReadDeviceViewport(&result->device_viewport))
        success = false;
      if (success)
        result->device_scale_factor = input.device_scale_factor();
      if (success && !input.ReadLocalSurfaceIdFromParent(&result->local_surface_id_from_parent))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::viz::mojom::blink::PendingLayerContext::DataView, ::viz::mojom::blink::PendingLayerContextPtr>::Read(
    ::viz::mojom::blink::PendingLayerContext::DataView input,
    ::viz::mojom::blink::PendingLayerContextPtr* output) {
  bool success = true;
  ::viz::mojom::blink::PendingLayerContextPtr result(::viz::mojom::blink::PendingLayerContext::New());
  
      if (success) {
        result->receiver =
            input.TakeReceiver<decltype(result->receiver)>();
      }
      if (success) {
        result->client =
            input.TakeClient<decltype(result->client)>();
      }
  *output = std::move(result);
  return success;
}

}  // namespace mojo


// Symbols declared in the -test-utils.h header are defined here instead of a
// separate .cc file to save compile time.


namespace viz::mojom::blink {


void LayerContextInterceptorForTesting::SetTargetLocalSurfaceId(const ::viz::LocalSurfaceId& id) {
  GetForwardingInterface()->SetTargetLocalSurfaceId(std::move(id));
}
void LayerContextInterceptorForTesting::SetVisible(bool visible) {
  GetForwardingInterface()->SetVisible(std::move(visible));
}
void LayerContextInterceptorForTesting::Commit(LayerTreeUpdatePtr update) {
  GetForwardingInterface()->Commit(std::move(update));
}
LayerContextAsyncWaiter::LayerContextAsyncWaiter(
    LayerContext* proxy) : proxy_(proxy) {}

LayerContextAsyncWaiter::~LayerContextAsyncWaiter() = default;




void LayerContextClientInterceptorForTesting::OnRequestCommitForFrame(const ::viz::BeginFrameArgs& args) {
  GetForwardingInterface()->OnRequestCommitForFrame(std::move(args));
}
LayerContextClientAsyncWaiter::LayerContextClientAsyncWaiter(
    LayerContextClient* proxy) : proxy_(proxy) {}

LayerContextClientAsyncWaiter::~LayerContextClientAsyncWaiter() = default;






}  // viz::mojom::blink


#if defined(__clang__)
#pragma clang diagnostic pop
#endif