// services/webnn/public/mojom/webnn_graph.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_WEBNN_PUBLIC_MOJOM_WEBNN_GRAPH_MOJOM_SHARED_H_
#define SERVICES_WEBNN_PUBLIC_MOJOM_WEBNN_GRAPH_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "services/webnn/public/mojom/webnn_graph.mojom-shared-internal.h"
#include "mojo/public/mojom/base/big_buffer.mojom-shared.h"
#include "mojo/public/cpp/bindings/lib/interface_serialization.h"
#include "mojo/public/cpp/system/data_pipe.h"






namespace webnn::mojom {
class OperandDataView;

class ClampAttributesDataView;

class Size2dDataView;

class Padding2dDataView;

class Conv2dAttributesDataView;

class Pool2dAttributesDataView;

class GemmAttributesDataView;

class OperatorDataView;

class GraphInfoDataView;

class OperatorAttributesDataView;


}  // webnn::mojom

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::webnn::mojom::OperandDataView> {
  using Data = ::webnn::mojom::internal::Operand_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::webnn::mojom::ClampAttributesDataView> {
  using Data = ::webnn::mojom::internal::ClampAttributes_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::webnn::mojom::Size2dDataView> {
  using Data = ::webnn::mojom::internal::Size2d_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::webnn::mojom::Padding2dDataView> {
  using Data = ::webnn::mojom::internal::Padding2d_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::webnn::mojom::Conv2dAttributesDataView> {
  using Data = ::webnn::mojom::internal::Conv2dAttributes_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::webnn::mojom::Pool2dAttributesDataView> {
  using Data = ::webnn::mojom::internal::Pool2dAttributes_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::webnn::mojom::GemmAttributesDataView> {
  using Data = ::webnn::mojom::internal::GemmAttributes_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::webnn::mojom::OperatorDataView> {
  using Data = ::webnn::mojom::internal::Operator_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::webnn::mojom::GraphInfoDataView> {
  using Data = ::webnn::mojom::internal::GraphInfo_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::webnn::mojom::OperatorAttributesDataView> {
  using Data = ::webnn::mojom::internal::OperatorAttributes_Data;
  using DataAsArrayElement = Data;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kUnion;
};

}  // namespace internal
}  // namespace mojo


namespace webnn::mojom {


enum class InputOperandLayout : int32_t {
  
  kChannelsFirst = 0,
  
  kChannelsLast = 1,
  kMinValue = 0,
  kMaxValue = 1,
};

 std::ostream& operator<<(std::ostream& os, InputOperandLayout value);
inline bool IsKnownEnumValue(InputOperandLayout value) {
  return internal::InputOperandLayout_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


enum class ComputeResult : int32_t {
  
  kOk = 0,
  
  kInvalidInputs = 1,
  
  kUnknownError = 2,
  kMinValue = 0,
  kMaxValue = 2,
};

 std::ostream& operator<<(std::ostream& os, ComputeResult value);
inline bool IsKnownEnumValue(ComputeResult value) {
  return internal::ComputeResult_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


enum class Operand_DataType : int32_t {
  
  kFloat32 = 0,
  
  kFloat16 = 1,
  
  kInt32 = 2,
  
  kUint32 = 3,
  
  kInt8 = 4,
  
  kUint8 = 5,
  kMinValue = 0,
  kMaxValue = 5,
};

 std::ostream& operator<<(std::ostream& os, Operand_DataType value);
inline bool IsKnownEnumValue(Operand_DataType value) {
  return internal::Operand_DataType_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


enum class Operand_Kind : int32_t {
  
  kInput = 0,
  
  kConstant = 1,
  
  kOutput = 2,
  kMinValue = 0,
  kMaxValue = 2,
};

 std::ostream& operator<<(std::ostream& os, Operand_Kind value);
inline bool IsKnownEnumValue(Operand_Kind value) {
  return internal::Operand_Kind_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


enum class Operator_Kind : int32_t {
  
  kClamp = 0,
  
  kConv2d = 1,
  
  kAdd = 2,
  
  kSub = 3,
  
  kMul = 4,
  
  kDiv = 5,
  
  kMax = 6,
  
  kMin = 7,
  
  kGemm = 8,
  
  kAveragePool2d = 9,
  
  kMaxPool2d = 10,
  
  kRelu = 11,
  
  kReshape = 12,
  
  kSoftmax = 13,
  kMinValue = 0,
  kMaxValue = 13,
};

 std::ostream& operator<<(std::ostream& os, Operator_Kind value);
inline bool IsKnownEnumValue(Operator_Kind value) {
  return internal::Operator_Kind_Data::IsKnownValue(
      static_cast<int32_t>(value));
}
// Interface base classes. They are used for type safety check.
class WebNNGraphInterfaceBase {};

using WebNNGraphPtrDataView =
    mojo::InterfacePtrDataView<WebNNGraphInterfaceBase>;
using WebNNGraphRequestDataView =
    mojo::InterfaceRequestDataView<WebNNGraphInterfaceBase>;
using WebNNGraphAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<WebNNGraphInterfaceBase>;
using WebNNGraphAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<WebNNGraphInterfaceBase>;


class OperandDataView {
 public:
  OperandDataView() = default;

  OperandDataView(
      internal::Operand_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  [[nodiscard]] bool ReadKind(UserType* output) const {
    auto data_value = data_->kind;
    return mojo::internal::Deserialize<::webnn::mojom::Operand_Kind>(
        data_value, output);
  }
  Operand_Kind kind() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::webnn::mojom::Operand_Kind>(data_->kind));
  }
  template <typename UserType>
  [[nodiscard]] bool ReadDataType(UserType* output) const {
    auto data_value = data_->data_type;
    return mojo::internal::Deserialize<::webnn::mojom::Operand_DataType>(
        data_value, output);
  }
  Operand_DataType data_type() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::webnn::mojom::Operand_DataType>(data_->data_type));
  }
  inline void GetDimensionsDataView(
      mojo::ArrayDataView<uint32_t>* output);

  template <typename UserType>
  [[nodiscard]] bool ReadDimensions(UserType* output) {
    
    auto* pointer = data_->dimensions.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<uint32_t>>(
        pointer, output, message_);
  }
  inline void GetNameDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadName(UserType* output) {
    
static_assert(
    mojo::internal::IsValidUserTypeForOptionalValue<
        mojo::StringDataView, UserType>(),
    "Attempting to read the optional `name` field into a type which "
    "cannot represent a null value. Either wrap the destination object "
    "with absl::optional, ensure that any corresponding "
    "{Struct/Union/Array/String}Traits define the necessary IsNull and "
    "SetToNull methods, or use `MaybeReadName` instead "
    "of `ReadName if you're fine with null values being "
    "silently ignored in this case.");
    auto* pointer = data_->name.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, message_);
  }
 private:
  internal::Operand_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};


class ClampAttributesDataView {
 public:
  ClampAttributesDataView() = default;

  ClampAttributesDataView(
      internal::ClampAttributes_Data* data,
      mojo::Message* message)
      : data_(data) {}

  bool is_null() const { return !data_; }
  float min_value() const {
    return data_->min_value;
  }
  float max_value() const {
    return data_->max_value;
  }
 private:
  internal::ClampAttributes_Data* data_ = nullptr;
};


class Size2dDataView {
 public:
  Size2dDataView() = default;

  Size2dDataView(
      internal::Size2d_Data* data,
      mojo::Message* message)
      : data_(data) {}

  bool is_null() const { return !data_; }
  uint32_t height() const {
    return data_->height;
  }
  uint32_t width() const {
    return data_->width;
  }
 private:
  internal::Size2d_Data* data_ = nullptr;
};


class Padding2dDataView {
 public:
  Padding2dDataView() = default;

  Padding2dDataView(
      internal::Padding2d_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  inline void GetBeginningDataView(
      Size2dDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadBeginning(UserType* output) {
    
    auto* pointer = data_->beginning.Get();
    return mojo::internal::Deserialize<::webnn::mojom::Size2dDataView>(
        pointer, output, message_);
  }
  inline void GetEndingDataView(
      Size2dDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadEnding(UserType* output) {
    
    auto* pointer = data_->ending.Get();
    return mojo::internal::Deserialize<::webnn::mojom::Size2dDataView>(
        pointer, output, message_);
  }
 private:
  internal::Padding2d_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};


class Conv2dAttributesDataView {
 public:
  Conv2dAttributesDataView() = default;

  Conv2dAttributesDataView(
      internal::Conv2dAttributes_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  inline void GetPaddingDataView(
      Padding2dDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadPadding(UserType* output) {
    
    auto* pointer = data_->padding.Get();
    return mojo::internal::Deserialize<::webnn::mojom::Padding2dDataView>(
        pointer, output, message_);
  }
  inline void GetStridesDataView(
      Size2dDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadStrides(UserType* output) {
    
    auto* pointer = data_->strides.Get();
    return mojo::internal::Deserialize<::webnn::mojom::Size2dDataView>(
        pointer, output, message_);
  }
  inline void GetDilationsDataView(
      Size2dDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadDilations(UserType* output) {
    
    auto* pointer = data_->dilations.Get();
    return mojo::internal::Deserialize<::webnn::mojom::Size2dDataView>(
        pointer, output, message_);
  }
  uint32_t groups() const {
    return data_->groups;
  }
  template <typename UserType>
  [[nodiscard]] bool ReadInputLayout(UserType* output) const {
    auto data_value = data_->input_layout;
    return mojo::internal::Deserialize<::webnn::mojom::InputOperandLayout>(
        data_value, output);
  }
  InputOperandLayout input_layout() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::webnn::mojom::InputOperandLayout>(data_->input_layout));
  }
  absl::optional<uint64_t> bias_operand_id() const {

    return data_->bias_operand_id_$flag
        ? absl::make_optional(data_->bias_operand_id_$value)
        : absl::nullopt;
  }
  inline void GetActivationDataView(
      OperatorDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadActivation(UserType* output) {
    
static_assert(
    mojo::internal::IsValidUserTypeForOptionalValue<
        ::webnn::mojom::OperatorDataView, UserType>(),
    "Attempting to read the optional `activation` field into a type which "
    "cannot represent a null value. Either wrap the destination object "
    "with absl::optional, ensure that any corresponding "
    "{Struct/Union/Array/String}Traits define the necessary IsNull and "
    "SetToNull methods, or use `MaybeReadActivation` instead "
    "of `ReadActivation if you're fine with null values being "
    "silently ignored in this case.");
    auto* pointer = data_->activation.Get();
    return mojo::internal::Deserialize<::webnn::mojom::OperatorDataView>(
        pointer, output, message_);
  }
 private:
  internal::Conv2dAttributes_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};


class Pool2dAttributesDataView {
 public:
  Pool2dAttributesDataView() = default;

  Pool2dAttributesDataView(
      internal::Pool2dAttributes_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  inline void GetWindowDimensionsDataView(
      Size2dDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadWindowDimensions(UserType* output) {
    
    auto* pointer = data_->window_dimensions.Get();
    return mojo::internal::Deserialize<::webnn::mojom::Size2dDataView>(
        pointer, output, message_);
  }
  inline void GetPaddingDataView(
      Padding2dDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadPadding(UserType* output) {
    
    auto* pointer = data_->padding.Get();
    return mojo::internal::Deserialize<::webnn::mojom::Padding2dDataView>(
        pointer, output, message_);
  }
  inline void GetStridesDataView(
      Size2dDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadStrides(UserType* output) {
    
    auto* pointer = data_->strides.Get();
    return mojo::internal::Deserialize<::webnn::mojom::Size2dDataView>(
        pointer, output, message_);
  }
  inline void GetDilationsDataView(
      Size2dDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadDilations(UserType* output) {
    
    auto* pointer = data_->dilations.Get();
    return mojo::internal::Deserialize<::webnn::mojom::Size2dDataView>(
        pointer, output, message_);
  }
  template <typename UserType>
  [[nodiscard]] bool ReadLayout(UserType* output) const {
    auto data_value = data_->layout;
    return mojo::internal::Deserialize<::webnn::mojom::InputOperandLayout>(
        data_value, output);
  }
  InputOperandLayout layout() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::webnn::mojom::InputOperandLayout>(data_->layout));
  }
 private:
  internal::Pool2dAttributes_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};


class GemmAttributesDataView {
 public:
  GemmAttributesDataView() = default;

  GemmAttributesDataView(
      internal::GemmAttributes_Data* data,
      mojo::Message* message)
      : data_(data) {}

  bool is_null() const { return !data_; }
  absl::optional<uint64_t> c_operand_id() const {

    return data_->c_operand_id_$flag
        ? absl::make_optional(data_->c_operand_id_$value)
        : absl::nullopt;
  }
  float alpha() const {
    return data_->alpha;
  }
  float beta() const {
    return data_->beta;
  }
  bool a_transpose() const {
    return data_->a_transpose;
  }
  bool b_transpose() const {
    return data_->b_transpose;
  }
 private:
  internal::GemmAttributes_Data* data_ = nullptr;
};


class OperatorDataView {
 public:
  OperatorDataView() = default;

  OperatorDataView(
      internal::Operator_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  [[nodiscard]] bool ReadKind(UserType* output) const {
    auto data_value = data_->kind;
    return mojo::internal::Deserialize<::webnn::mojom::Operator_Kind>(
        data_value, output);
  }
  Operator_Kind kind() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::webnn::mojom::Operator_Kind>(data_->kind));
  }
  inline void GetInputOperandsDataView(
      mojo::ArrayDataView<uint64_t>* output);

  template <typename UserType>
  [[nodiscard]] bool ReadInputOperands(UserType* output) {
    
    auto* pointer = data_->input_operands.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<uint64_t>>(
        pointer, output, message_);
  }
  inline void GetOutputOperandsDataView(
      mojo::ArrayDataView<uint64_t>* output);

  template <typename UserType>
  [[nodiscard]] bool ReadOutputOperands(UserType* output) {
    
    auto* pointer = data_->output_operands.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<uint64_t>>(
        pointer, output, message_);
  }
  inline void GetAttributesDataView(
      OperatorAttributesDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadAttributes(UserType* output) {
    
static_assert(
    mojo::internal::IsValidUserTypeForOptionalValue<
        ::webnn::mojom::OperatorAttributesDataView, UserType>(),
    "Attempting to read the optional `attributes` field into a type which "
    "cannot represent a null value. Either wrap the destination object "
    "with absl::optional, ensure that any corresponding "
    "{Struct/Union/Array/String}Traits define the necessary IsNull and "
    "SetToNull methods, or use `MaybeReadAttributes` instead "
    "of `ReadAttributes if you're fine with null values being "
    "silently ignored in this case.");
    auto* pointer = !data_->attributes.is_null() ? &data_->attributes : nullptr;
    return mojo::internal::Deserialize<::webnn::mojom::OperatorAttributesDataView>(
        pointer, output, message_);
  }
 private:
  internal::Operator_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};


class GraphInfoDataView {
 public:
  GraphInfoDataView() = default;

  GraphInfoDataView(
      internal::GraphInfo_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  inline void GetIdToOperandMapDataView(
      mojo::MapDataView<uint64_t, OperandDataView>* output);

  template <typename UserType>
  [[nodiscard]] bool ReadIdToOperandMap(UserType* output) {
    
    auto* pointer = data_->id_to_operand_map.Get();
    return mojo::internal::Deserialize<mojo::MapDataView<uint64_t, ::webnn::mojom::OperandDataView>>(
        pointer, output, message_);
  }
  inline void GetInputOperandsDataView(
      mojo::ArrayDataView<uint64_t>* output);

  template <typename UserType>
  [[nodiscard]] bool ReadInputOperands(UserType* output) {
    
    auto* pointer = data_->input_operands.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<uint64_t>>(
        pointer, output, message_);
  }
  inline void GetOutputOperandsDataView(
      mojo::ArrayDataView<uint64_t>* output);

  template <typename UserType>
  [[nodiscard]] bool ReadOutputOperands(UserType* output) {
    
    auto* pointer = data_->output_operands.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<uint64_t>>(
        pointer, output, message_);
  }
  inline void GetOperatorsDataView(
      mojo::ArrayDataView<OperatorDataView>* output);

  template <typename UserType>
  [[nodiscard]] bool ReadOperators(UserType* output) {
    
    auto* pointer = data_->operators.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::webnn::mojom::OperatorDataView>>(
        pointer, output, message_);
  }
  inline void GetConstantIdToBufferMapDataView(
      mojo::MapDataView<uint64_t, ::mojo_base::mojom::BigBufferDataView>* output);

  template <typename UserType>
  [[nodiscard]] bool ReadConstantIdToBufferMap(UserType* output) {
    
    auto* pointer = data_->constant_id_to_buffer_map.Get();
    return mojo::internal::Deserialize<mojo::MapDataView<uint64_t, ::mojo_base::mojom::BigBufferDataView>>(
        pointer, output, message_);
  }
 private:
  internal::GraphInfo_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};


class OperatorAttributesDataView {
 public:
  using Tag = internal::OperatorAttributes_Data::OperatorAttributes_Tag;

  OperatorAttributesDataView() = default;

  OperatorAttributesDataView(
      internal::OperatorAttributes_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const {
    // For inlined unions, |data_| is always non-null. In that case we need to
    // check |data_->is_null()|.
    return !data_ || data_->is_null();
  }

  Tag tag() const { return data_->tag; }
  bool is_clamp() const { return data_->tag == Tag::kClamp; }
  inline void GetClampDataView(
      ClampAttributesDataView* output) const;

  template <typename UserType>
  [[nodiscard]] bool ReadClamp(UserType* output) const {
    
    CHECK(is_clamp());
    return mojo::internal::Deserialize<::webnn::mojom::ClampAttributesDataView>(
        data_->data.f_clamp.Get(), output, message_);
  }
  bool is_conv2d() const { return data_->tag == Tag::kConv2d; }
  inline void GetConv2dDataView(
      Conv2dAttributesDataView* output) const;

  template <typename UserType>
  [[nodiscard]] bool ReadConv2d(UserType* output) const {
    
    CHECK(is_conv2d());
    return mojo::internal::Deserialize<::webnn::mojom::Conv2dAttributesDataView>(
        data_->data.f_conv2d.Get(), output, message_);
  }
  bool is_gemm() const { return data_->tag == Tag::kGemm; }
  inline void GetGemmDataView(
      GemmAttributesDataView* output) const;

  template <typename UserType>
  [[nodiscard]] bool ReadGemm(UserType* output) const {
    
    CHECK(is_gemm());
    return mojo::internal::Deserialize<::webnn::mojom::GemmAttributesDataView>(
        data_->data.f_gemm.Get(), output, message_);
  }
  bool is_pool2d() const { return data_->tag == Tag::kPool2d; }
  inline void GetPool2dDataView(
      Pool2dAttributesDataView* output) const;

  template <typename UserType>
  [[nodiscard]] bool ReadPool2d(UserType* output) const {
    
    CHECK(is_pool2d());
    return mojo::internal::Deserialize<::webnn::mojom::Pool2dAttributesDataView>(
        data_->data.f_pool2d.Get(), output, message_);
  }

 private:
  internal::OperatorAttributes_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};



}  // webnn::mojom

namespace std {

template <>
struct hash<::webnn::mojom::InputOperandLayout>
    : public mojo::internal::EnumHashImpl<::webnn::mojom::InputOperandLayout> {};

template <>
struct hash<::webnn::mojom::ComputeResult>
    : public mojo::internal::EnumHashImpl<::webnn::mojom::ComputeResult> {};

template <>
struct hash<::webnn::mojom::Operand_DataType>
    : public mojo::internal::EnumHashImpl<::webnn::mojom::Operand_DataType> {};

template <>
struct hash<::webnn::mojom::Operand_Kind>
    : public mojo::internal::EnumHashImpl<::webnn::mojom::Operand_Kind> {};

template <>
struct hash<::webnn::mojom::Operator_Kind>
    : public mojo::internal::EnumHashImpl<::webnn::mojom::Operator_Kind> {};

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::webnn::mojom::InputOperandLayout, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::webnn::mojom::InputOperandLayout, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::webnn::mojom::InputOperandLayout>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::webnn::mojom::ComputeResult, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::webnn::mojom::ComputeResult, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::webnn::mojom::ComputeResult>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::webnn::mojom::Operand_DataType, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::webnn::mojom::Operand_DataType, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::webnn::mojom::Operand_DataType>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::webnn::mojom::Operand_Kind, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::webnn::mojom::Operand_Kind, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::webnn::mojom::Operand_Kind>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::webnn::mojom::Operator_Kind, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::webnn::mojom::Operator_Kind, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::webnn::mojom::Operator_Kind>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::webnn::mojom::OperandDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::webnn::mojom::OperandDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::webnn::mojom::internal::Operand_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    mojo::internal::Serialize<::webnn::mojom::Operand_Kind>(
        Traits::kind(input), &fragment->kind);
    mojo::internal::Serialize<::webnn::mojom::Operand_DataType>(
        Traits::data_type(input), &fragment->data_type);
    decltype(Traits::dimensions(input)) in_dimensions = Traits::dimensions(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->dimensions)::BaseType>
        dimensions_fragment(fragment.message());
    constexpr const mojo::internal::ContainerValidateParams& dimensions_validate_params =
        mojo::internal::GetArrayValidator<0, false, nullptr>();
    mojo::internal::Serialize<mojo::ArrayDataView<uint32_t>>(
        in_dimensions, dimensions_fragment, &dimensions_validate_params);
    fragment->dimensions.Set(
        dimensions_fragment.is_null() ? nullptr : dimensions_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->dimensions.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null dimensions in Operand struct");
    decltype(Traits::name(input)) in_name = Traits::name(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->name)::BaseType> name_fragment(
            fragment.message());
    mojo::internal::Serialize<mojo::StringDataView>(
        in_name, name_fragment);
    fragment->name.Set(
        name_fragment.is_null() ? nullptr : name_fragment.data());
  }

  static bool Deserialize(::webnn::mojom::internal::Operand_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::webnn::mojom::OperandDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::webnn::mojom::ClampAttributesDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::webnn::mojom::ClampAttributesDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::webnn::mojom::internal::ClampAttributes_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    fragment->min_value = Traits::min_value(input);
    fragment->max_value = Traits::max_value(input);
  }

  static bool Deserialize(::webnn::mojom::internal::ClampAttributes_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::webnn::mojom::ClampAttributesDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::webnn::mojom::Size2dDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::webnn::mojom::Size2dDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::webnn::mojom::internal::Size2d_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    fragment->height = Traits::height(input);
    fragment->width = Traits::width(input);
  }

  static bool Deserialize(::webnn::mojom::internal::Size2d_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::webnn::mojom::Size2dDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::webnn::mojom::Padding2dDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::webnn::mojom::Padding2dDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::webnn::mojom::internal::Padding2d_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::beginning(input)) in_beginning = Traits::beginning(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->beginning)::BaseType> beginning_fragment(
            fragment.message());
    mojo::internal::Serialize<::webnn::mojom::Size2dDataView>(
        in_beginning, beginning_fragment);
    fragment->beginning.Set(
        beginning_fragment.is_null() ? nullptr : beginning_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->beginning.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null beginning in Padding2d struct");
    decltype(Traits::ending(input)) in_ending = Traits::ending(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->ending)::BaseType> ending_fragment(
            fragment.message());
    mojo::internal::Serialize<::webnn::mojom::Size2dDataView>(
        in_ending, ending_fragment);
    fragment->ending.Set(
        ending_fragment.is_null() ? nullptr : ending_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->ending.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null ending in Padding2d struct");
  }

  static bool Deserialize(::webnn::mojom::internal::Padding2d_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::webnn::mojom::Padding2dDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::webnn::mojom::Conv2dAttributesDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::webnn::mojom::Conv2dAttributesDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::webnn::mojom::internal::Conv2dAttributes_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::padding(input)) in_padding = Traits::padding(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->padding)::BaseType> padding_fragment(
            fragment.message());
    mojo::internal::Serialize<::webnn::mojom::Padding2dDataView>(
        in_padding, padding_fragment);
    fragment->padding.Set(
        padding_fragment.is_null() ? nullptr : padding_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->padding.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null padding in Conv2dAttributes struct");
    decltype(Traits::strides(input)) in_strides = Traits::strides(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->strides)::BaseType> strides_fragment(
            fragment.message());
    mojo::internal::Serialize<::webnn::mojom::Size2dDataView>(
        in_strides, strides_fragment);
    fragment->strides.Set(
        strides_fragment.is_null() ? nullptr : strides_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->strides.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null strides in Conv2dAttributes struct");
    decltype(Traits::dilations(input)) in_dilations = Traits::dilations(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->dilations)::BaseType> dilations_fragment(
            fragment.message());
    mojo::internal::Serialize<::webnn::mojom::Size2dDataView>(
        in_dilations, dilations_fragment);
    fragment->dilations.Set(
        dilations_fragment.is_null() ? nullptr : dilations_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->dilations.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null dilations in Conv2dAttributes struct");
    fragment->groups = Traits::groups(input);
    mojo::internal::Serialize<::webnn::mojom::InputOperandLayout>(
        Traits::input_layout(input), &fragment->input_layout);
    fragment->bias_operand_id_$flag = Traits::bias_operand_id(input).has_value();
    if (Traits::bias_operand_id(input).has_value()) {
      fragment->bias_operand_id_$value = Traits::bias_operand_id(input).value();
    }
    decltype(Traits::activation(input)) in_activation = Traits::activation(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->activation)::BaseType> activation_fragment(
            fragment.message());
    mojo::internal::Serialize<::webnn::mojom::OperatorDataView>(
        in_activation, activation_fragment);
    fragment->activation.Set(
        activation_fragment.is_null() ? nullptr : activation_fragment.data());
  }

  static bool Deserialize(::webnn::mojom::internal::Conv2dAttributes_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::webnn::mojom::Conv2dAttributesDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::webnn::mojom::Pool2dAttributesDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::webnn::mojom::Pool2dAttributesDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::webnn::mojom::internal::Pool2dAttributes_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::window_dimensions(input)) in_window_dimensions = Traits::window_dimensions(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->window_dimensions)::BaseType> window_dimensions_fragment(
            fragment.message());
    mojo::internal::Serialize<::webnn::mojom::Size2dDataView>(
        in_window_dimensions, window_dimensions_fragment);
    fragment->window_dimensions.Set(
        window_dimensions_fragment.is_null() ? nullptr : window_dimensions_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->window_dimensions.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null window_dimensions in Pool2dAttributes struct");
    decltype(Traits::padding(input)) in_padding = Traits::padding(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->padding)::BaseType> padding_fragment(
            fragment.message());
    mojo::internal::Serialize<::webnn::mojom::Padding2dDataView>(
        in_padding, padding_fragment);
    fragment->padding.Set(
        padding_fragment.is_null() ? nullptr : padding_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->padding.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null padding in Pool2dAttributes struct");
    decltype(Traits::strides(input)) in_strides = Traits::strides(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->strides)::BaseType> strides_fragment(
            fragment.message());
    mojo::internal::Serialize<::webnn::mojom::Size2dDataView>(
        in_strides, strides_fragment);
    fragment->strides.Set(
        strides_fragment.is_null() ? nullptr : strides_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->strides.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null strides in Pool2dAttributes struct");
    decltype(Traits::dilations(input)) in_dilations = Traits::dilations(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->dilations)::BaseType> dilations_fragment(
            fragment.message());
    mojo::internal::Serialize<::webnn::mojom::Size2dDataView>(
        in_dilations, dilations_fragment);
    fragment->dilations.Set(
        dilations_fragment.is_null() ? nullptr : dilations_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->dilations.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null dilations in Pool2dAttributes struct");
    mojo::internal::Serialize<::webnn::mojom::InputOperandLayout>(
        Traits::layout(input), &fragment->layout);
  }

  static bool Deserialize(::webnn::mojom::internal::Pool2dAttributes_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::webnn::mojom::Pool2dAttributesDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::webnn::mojom::GemmAttributesDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::webnn::mojom::GemmAttributesDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::webnn::mojom::internal::GemmAttributes_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    fragment->c_operand_id_$flag = Traits::c_operand_id(input).has_value();
    if (Traits::c_operand_id(input).has_value()) {
      fragment->c_operand_id_$value = Traits::c_operand_id(input).value();
    }
    fragment->alpha = Traits::alpha(input);
    fragment->beta = Traits::beta(input);
    fragment->a_transpose = Traits::a_transpose(input);
    fragment->b_transpose = Traits::b_transpose(input);
  }

  static bool Deserialize(::webnn::mojom::internal::GemmAttributes_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::webnn::mojom::GemmAttributesDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::webnn::mojom::OperatorDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::webnn::mojom::OperatorDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::webnn::mojom::internal::Operator_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    mojo::internal::Serialize<::webnn::mojom::Operator_Kind>(
        Traits::kind(input), &fragment->kind);
    decltype(Traits::input_operands(input)) in_input_operands = Traits::input_operands(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->input_operands)::BaseType>
        input_operands_fragment(fragment.message());
    constexpr const mojo::internal::ContainerValidateParams& input_operands_validate_params =
        mojo::internal::GetArrayValidator<0, false, nullptr>();
    mojo::internal::Serialize<mojo::ArrayDataView<uint64_t>>(
        in_input_operands, input_operands_fragment, &input_operands_validate_params);
    fragment->input_operands.Set(
        input_operands_fragment.is_null() ? nullptr : input_operands_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->input_operands.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null input_operands in Operator struct");
    decltype(Traits::output_operands(input)) in_output_operands = Traits::output_operands(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->output_operands)::BaseType>
        output_operands_fragment(fragment.message());
    constexpr const mojo::internal::ContainerValidateParams& output_operands_validate_params =
        mojo::internal::GetArrayValidator<0, false, nullptr>();
    mojo::internal::Serialize<mojo::ArrayDataView<uint64_t>>(
        in_output_operands, output_operands_fragment, &output_operands_validate_params);
    fragment->output_operands.Set(
        output_operands_fragment.is_null() ? nullptr : output_operands_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->output_operands.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null output_operands in Operator struct");
    decltype(Traits::attributes(input)) in_attributes = Traits::attributes(input);
    mojo::internal::MessageFragment<decltype(fragment->attributes)>
        attributes_fragment(fragment.message());
    attributes_fragment.Claim(&fragment->attributes);
    mojo::internal::Serialize<::webnn::mojom::OperatorAttributesDataView>(
        in_attributes, attributes_fragment, true);
  }

  static bool Deserialize(::webnn::mojom::internal::Operator_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::webnn::mojom::OperatorDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::webnn::mojom::GraphInfoDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::webnn::mojom::GraphInfoDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::webnn::mojom::internal::GraphInfo_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::id_to_operand_map(input)) in_id_to_operand_map = Traits::id_to_operand_map(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->id_to_operand_map)::BaseType>
        id_to_operand_map_fragment(fragment.message());
    constexpr const mojo::internal::ContainerValidateParams& id_to_operand_map_validate_params =
        mojo::internal::GetMapValidator<*&mojo::internal::GetArrayValidator<0, false, nullptr>(), *&mojo::internal::GetArrayValidator<0, false, nullptr>()>();
    mojo::internal::Serialize<mojo::MapDataView<uint64_t, ::webnn::mojom::OperandDataView>>(
        in_id_to_operand_map, id_to_operand_map_fragment, &id_to_operand_map_validate_params);
    fragment->id_to_operand_map.Set(
        id_to_operand_map_fragment.is_null() ? nullptr : id_to_operand_map_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->id_to_operand_map.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null id_to_operand_map in GraphInfo struct");
    decltype(Traits::input_operands(input)) in_input_operands = Traits::input_operands(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->input_operands)::BaseType>
        input_operands_fragment(fragment.message());
    constexpr const mojo::internal::ContainerValidateParams& input_operands_validate_params =
        mojo::internal::GetArrayValidator<0, false, nullptr>();
    mojo::internal::Serialize<mojo::ArrayDataView<uint64_t>>(
        in_input_operands, input_operands_fragment, &input_operands_validate_params);
    fragment->input_operands.Set(
        input_operands_fragment.is_null() ? nullptr : input_operands_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->input_operands.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null input_operands in GraphInfo struct");
    decltype(Traits::output_operands(input)) in_output_operands = Traits::output_operands(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->output_operands)::BaseType>
        output_operands_fragment(fragment.message());
    constexpr const mojo::internal::ContainerValidateParams& output_operands_validate_params =
        mojo::internal::GetArrayValidator<0, false, nullptr>();
    mojo::internal::Serialize<mojo::ArrayDataView<uint64_t>>(
        in_output_operands, output_operands_fragment, &output_operands_validate_params);
    fragment->output_operands.Set(
        output_operands_fragment.is_null() ? nullptr : output_operands_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->output_operands.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null output_operands in GraphInfo struct");
    decltype(Traits::operators(input)) in_operators = Traits::operators(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->operators)::BaseType>
        operators_fragment(fragment.message());
    constexpr const mojo::internal::ContainerValidateParams& operators_validate_params =
        mojo::internal::GetArrayValidator<0, false, nullptr>();
    mojo::internal::Serialize<mojo::ArrayDataView<::webnn::mojom::OperatorDataView>>(
        in_operators, operators_fragment, &operators_validate_params);
    fragment->operators.Set(
        operators_fragment.is_null() ? nullptr : operators_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->operators.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null operators in GraphInfo struct");
    decltype(Traits::constant_id_to_buffer_map(input)) in_constant_id_to_buffer_map = Traits::constant_id_to_buffer_map(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->constant_id_to_buffer_map)::BaseType>
        constant_id_to_buffer_map_fragment(fragment.message());
    constexpr const mojo::internal::ContainerValidateParams& constant_id_to_buffer_map_validate_params =
        mojo::internal::GetMapValidator<*&mojo::internal::GetArrayValidator<0, false, nullptr>(), *&mojo::internal::GetArrayValidator<0, false, nullptr>()>();
    mojo::internal::Serialize<mojo::MapDataView<uint64_t, ::mojo_base::mojom::BigBufferDataView>>(
        in_constant_id_to_buffer_map, constant_id_to_buffer_map_fragment, &constant_id_to_buffer_map_validate_params);
    fragment->constant_id_to_buffer_map.Set(
        constant_id_to_buffer_map_fragment.is_null() ? nullptr : constant_id_to_buffer_map_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->constant_id_to_buffer_map.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null constant_id_to_buffer_map in GraphInfo struct");
  }

  static bool Deserialize(::webnn::mojom::internal::GraphInfo_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::webnn::mojom::GraphInfoDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::webnn::mojom::OperatorAttributesDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = UnionTraits<::webnn::mojom::OperatorAttributesDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        MessageFragment<::webnn::mojom::internal::OperatorAttributes_Data>& fragment,
                        bool inlined) {
    if (CallIsNullIfExists<Traits>(input)) {
       if (inlined)
        fragment->set_null();
      return;
    }

    if (!inlined)
      fragment.Allocate();

    // TODO(azani): Handle unknown and objects.
    // Set the not-null flag.
    fragment->size = kUnionDataSize;
    fragment->tag = Traits::GetTag(input);
    switch (fragment->tag) {
      case ::webnn::mojom::OperatorAttributesDataView::Tag::kClamp: {
        decltype(Traits::clamp(input))
            in_clamp = Traits::clamp(input);
        mojo::internal::MessageFragment<
            typename decltype(fragment->data.f_clamp)::BaseType>
            value_fragment(fragment.message());
        mojo::internal::Serialize<::webnn::mojom::ClampAttributesDataView>(
            in_clamp, value_fragment);
        MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
            value_fragment.is_null(),
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
            "null clamp in OperatorAttributes union");
        fragment->data.f_clamp.Set(
            value_fragment.is_null() ? nullptr : value_fragment.data());
        break;
      }
      case ::webnn::mojom::OperatorAttributesDataView::Tag::kConv2d: {
        decltype(Traits::conv2d(input))
            in_conv2d = Traits::conv2d(input);
        mojo::internal::MessageFragment<
            typename decltype(fragment->data.f_conv2d)::BaseType>
            value_fragment(fragment.message());
        mojo::internal::Serialize<::webnn::mojom::Conv2dAttributesDataView>(
            in_conv2d, value_fragment);
        MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
            value_fragment.is_null(),
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
            "null conv2d in OperatorAttributes union");
        fragment->data.f_conv2d.Set(
            value_fragment.is_null() ? nullptr : value_fragment.data());
        break;
      }
      case ::webnn::mojom::OperatorAttributesDataView::Tag::kGemm: {
        decltype(Traits::gemm(input))
            in_gemm = Traits::gemm(input);
        mojo::internal::MessageFragment<
            typename decltype(fragment->data.f_gemm)::BaseType>
            value_fragment(fragment.message());
        mojo::internal::Serialize<::webnn::mojom::GemmAttributesDataView>(
            in_gemm, value_fragment);
        MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
            value_fragment.is_null(),
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
            "null gemm in OperatorAttributes union");
        fragment->data.f_gemm.Set(
            value_fragment.is_null() ? nullptr : value_fragment.data());
        break;
      }
      case ::webnn::mojom::OperatorAttributesDataView::Tag::kPool2d: {
        decltype(Traits::pool2d(input))
            in_pool2d = Traits::pool2d(input);
        mojo::internal::MessageFragment<
            typename decltype(fragment->data.f_pool2d)::BaseType>
            value_fragment(fragment.message());
        mojo::internal::Serialize<::webnn::mojom::Pool2dAttributesDataView>(
            in_pool2d, value_fragment);
        MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
            value_fragment.is_null(),
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
            "null pool2d in OperatorAttributes union");
        fragment->data.f_pool2d.Set(
            value_fragment.is_null() ? nullptr : value_fragment.data());
        break;
      }
    }
  }

  static bool Deserialize(::webnn::mojom::internal::OperatorAttributes_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input || input->is_null())
      return CallSetToNullIfExists<Traits>(output);

    ::webnn::mojom::OperatorAttributesDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace webnn::mojom {

inline void OperandDataView::GetDimensionsDataView(
    mojo::ArrayDataView<uint32_t>* output) {
  auto pointer = data_->dimensions.Get();
  *output = mojo::ArrayDataView<uint32_t>(pointer, message_);
}
inline void OperandDataView::GetNameDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->name.Get();
  *output = mojo::StringDataView(pointer, message_);
}






inline void Padding2dDataView::GetBeginningDataView(
    Size2dDataView* output) {
  auto pointer = data_->beginning.Get();
  *output = Size2dDataView(pointer, message_);
}
inline void Padding2dDataView::GetEndingDataView(
    Size2dDataView* output) {
  auto pointer = data_->ending.Get();
  *output = Size2dDataView(pointer, message_);
}


inline void Conv2dAttributesDataView::GetPaddingDataView(
    Padding2dDataView* output) {
  auto pointer = data_->padding.Get();
  *output = Padding2dDataView(pointer, message_);
}
inline void Conv2dAttributesDataView::GetStridesDataView(
    Size2dDataView* output) {
  auto pointer = data_->strides.Get();
  *output = Size2dDataView(pointer, message_);
}
inline void Conv2dAttributesDataView::GetDilationsDataView(
    Size2dDataView* output) {
  auto pointer = data_->dilations.Get();
  *output = Size2dDataView(pointer, message_);
}
inline void Conv2dAttributesDataView::GetActivationDataView(
    OperatorDataView* output) {
  auto pointer = data_->activation.Get();
  *output = OperatorDataView(pointer, message_);
}


inline void Pool2dAttributesDataView::GetWindowDimensionsDataView(
    Size2dDataView* output) {
  auto pointer = data_->window_dimensions.Get();
  *output = Size2dDataView(pointer, message_);
}
inline void Pool2dAttributesDataView::GetPaddingDataView(
    Padding2dDataView* output) {
  auto pointer = data_->padding.Get();
  *output = Padding2dDataView(pointer, message_);
}
inline void Pool2dAttributesDataView::GetStridesDataView(
    Size2dDataView* output) {
  auto pointer = data_->strides.Get();
  *output = Size2dDataView(pointer, message_);
}
inline void Pool2dAttributesDataView::GetDilationsDataView(
    Size2dDataView* output) {
  auto pointer = data_->dilations.Get();
  *output = Size2dDataView(pointer, message_);
}




inline void OperatorDataView::GetInputOperandsDataView(
    mojo::ArrayDataView<uint64_t>* output) {
  auto pointer = data_->input_operands.Get();
  *output = mojo::ArrayDataView<uint64_t>(pointer, message_);
}
inline void OperatorDataView::GetOutputOperandsDataView(
    mojo::ArrayDataView<uint64_t>* output) {
  auto pointer = data_->output_operands.Get();
  *output = mojo::ArrayDataView<uint64_t>(pointer, message_);
}
inline void OperatorDataView::GetAttributesDataView(
    OperatorAttributesDataView* output) {
  auto pointer = &data_->attributes;
  *output = OperatorAttributesDataView(pointer, message_);
}


inline void GraphInfoDataView::GetIdToOperandMapDataView(
    mojo::MapDataView<uint64_t, OperandDataView>* output) {
  auto pointer = data_->id_to_operand_map.Get();
  *output = mojo::MapDataView<uint64_t, OperandDataView>(pointer, message_);
}
inline void GraphInfoDataView::GetInputOperandsDataView(
    mojo::ArrayDataView<uint64_t>* output) {
  auto pointer = data_->input_operands.Get();
  *output = mojo::ArrayDataView<uint64_t>(pointer, message_);
}
inline void GraphInfoDataView::GetOutputOperandsDataView(
    mojo::ArrayDataView<uint64_t>* output) {
  auto pointer = data_->output_operands.Get();
  *output = mojo::ArrayDataView<uint64_t>(pointer, message_);
}
inline void GraphInfoDataView::GetOperatorsDataView(
    mojo::ArrayDataView<OperatorDataView>* output) {
  auto pointer = data_->operators.Get();
  *output = mojo::ArrayDataView<OperatorDataView>(pointer, message_);
}
inline void GraphInfoDataView::GetConstantIdToBufferMapDataView(
    mojo::MapDataView<uint64_t, ::mojo_base::mojom::BigBufferDataView>* output) {
  auto pointer = data_->constant_id_to_buffer_map.Get();
  *output = mojo::MapDataView<uint64_t, ::mojo_base::mojom::BigBufferDataView>(pointer, message_);
}


inline void OperatorAttributesDataView::GetClampDataView(
    ClampAttributesDataView* output) const {
  CHECK(is_clamp());
  *output = ClampAttributesDataView(data_->data.f_clamp.Get(), message_);
}
inline void OperatorAttributesDataView::GetConv2dDataView(
    Conv2dAttributesDataView* output) const {
  CHECK(is_conv2d());
  *output = Conv2dAttributesDataView(data_->data.f_conv2d.Get(), message_);
}
inline void OperatorAttributesDataView::GetGemmDataView(
    GemmAttributesDataView* output) const {
  CHECK(is_gemm());
  *output = GemmAttributesDataView(data_->data.f_gemm.Get(), message_);
}
inline void OperatorAttributesDataView::GetPool2dDataView(
    Pool2dAttributesDataView* output) const {
  CHECK(is_pool2d());
  *output = Pool2dAttributesDataView(data_->data.f_pool2d.Get(), message_);
}


}  // webnn::mojom

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

namespace perfetto {

template <>
struct  TraceFormatTraits<::webnn::mojom::InputOperandLayout> {
 static void WriteIntoTrace(perfetto::TracedValue context, ::webnn::mojom::InputOperandLayout value);
};

} // namespace perfetto

namespace perfetto {

template <>
struct  TraceFormatTraits<::webnn::mojom::ComputeResult> {
 static void WriteIntoTrace(perfetto::TracedValue context, ::webnn::mojom::ComputeResult value);
};

} // namespace perfetto

namespace perfetto {

template <>
struct  TraceFormatTraits<::webnn::mojom::Operand_DataType> {
 static void WriteIntoTrace(perfetto::TracedValue context, ::webnn::mojom::Operand_DataType value);
};

} // namespace perfetto

namespace perfetto {

template <>
struct  TraceFormatTraits<::webnn::mojom::Operand_Kind> {
 static void WriteIntoTrace(perfetto::TracedValue context, ::webnn::mojom::Operand_Kind value);
};

} // namespace perfetto

namespace perfetto {

template <>
struct  TraceFormatTraits<::webnn::mojom::Operator_Kind> {
 static void WriteIntoTrace(perfetto::TracedValue context, ::webnn::mojom::Operator_Kind value);
};

} // namespace perfetto

#endif  // SERVICES_WEBNN_PUBLIC_MOJOM_WEBNN_GRAPH_MOJOM_SHARED_H_