// services/webnn/public/mojom/webnn_service.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_WEBNN_PUBLIC_MOJOM_WEBNN_SERVICE_MOJOM_SHARED_H_
#define SERVICES_WEBNN_PUBLIC_MOJOM_WEBNN_SERVICE_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "services/webnn/public/mojom/webnn_service.mojom-shared-internal.h"
#include "services/webnn/public/mojom/webnn_graph.mojom-shared.h"
#include "sandbox/policy/mojom/sandbox.mojom-shared.h"
#include "mojo/public/cpp/bindings/lib/interface_serialization.h"
#include "mojo/public/cpp/system/data_pipe.h"






namespace webnn::mojom {
class CreateContextOptionsDataView;



}  // webnn::mojom

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::webnn::mojom::CreateContextOptionsDataView> {
  using Data = ::webnn::mojom::internal::CreateContextOptions_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace webnn::mojom {


enum class PowerPreference : int32_t {
  
  kDefault = 0,
  
  kHighPerformance = 1,
  
  kLowPower = 2,
  kMinValue = 0,
  kMaxValue = 2,
};

 std::ostream& operator<<(std::ostream& os, PowerPreference value);
inline bool IsKnownEnumValue(PowerPreference value) {
  return internal::PowerPreference_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


enum class CreateContextResult : int32_t {
  
  kOk = 0,
  
  kUnknownError = 1,
  
  kNotSupported = 2,
  kMinValue = 0,
  kMaxValue = 2,
};

 std::ostream& operator<<(std::ostream& os, CreateContextResult value);
inline bool IsKnownEnumValue(CreateContextResult value) {
  return internal::CreateContextResult_Data::IsKnownValue(
      static_cast<int32_t>(value));
}
// Interface base classes. They are used for type safety check.
class WebNNContextInterfaceBase {};

using WebNNContextPtrDataView =
    mojo::InterfacePtrDataView<WebNNContextInterfaceBase>;
using WebNNContextRequestDataView =
    mojo::InterfaceRequestDataView<WebNNContextInterfaceBase>;
using WebNNContextAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<WebNNContextInterfaceBase>;
using WebNNContextAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<WebNNContextInterfaceBase>;
class WebNNContextProviderInterfaceBase {};

using WebNNContextProviderPtrDataView =
    mojo::InterfacePtrDataView<WebNNContextProviderInterfaceBase>;
using WebNNContextProviderRequestDataView =
    mojo::InterfaceRequestDataView<WebNNContextProviderInterfaceBase>;
using WebNNContextProviderAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<WebNNContextProviderInterfaceBase>;
using WebNNContextProviderAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<WebNNContextProviderInterfaceBase>;
class WebNNServiceInterfaceBase {};

using WebNNServicePtrDataView =
    mojo::InterfacePtrDataView<WebNNServiceInterfaceBase>;
using WebNNServiceRequestDataView =
    mojo::InterfaceRequestDataView<WebNNServiceInterfaceBase>;
using WebNNServiceAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<WebNNServiceInterfaceBase>;
using WebNNServiceAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<WebNNServiceInterfaceBase>;


class CreateContextOptionsDataView {
 public:
  CreateContextOptionsDataView() = default;

  CreateContextOptionsDataView(
      internal::CreateContextOptions_Data* data,
      mojo::Message* message)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  [[nodiscard]] bool ReadPowerPreference(UserType* output) const {
    auto data_value = data_->power_preference;
    return mojo::internal::Deserialize<::webnn::mojom::PowerPreference>(
        data_value, output);
  }
  PowerPreference power_preference() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::webnn::mojom::PowerPreference>(data_->power_preference));
  }
 private:
  internal::CreateContextOptions_Data* data_ = nullptr;
};


}  // webnn::mojom

namespace std {

template <>
struct hash<::webnn::mojom::PowerPreference>
    : public mojo::internal::EnumHashImpl<::webnn::mojom::PowerPreference> {};

template <>
struct hash<::webnn::mojom::CreateContextResult>
    : public mojo::internal::EnumHashImpl<::webnn::mojom::CreateContextResult> {};

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::webnn::mojom::PowerPreference, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::webnn::mojom::PowerPreference, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::webnn::mojom::PowerPreference>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::webnn::mojom::CreateContextResult, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::webnn::mojom::CreateContextResult, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::webnn::mojom::CreateContextResult>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::webnn::mojom::CreateContextOptionsDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::webnn::mojom::CreateContextOptionsDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::webnn::mojom::internal::CreateContextOptions_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    mojo::internal::Serialize<::webnn::mojom::PowerPreference>(
        Traits::power_preference(input), &fragment->power_preference);
  }

  static bool Deserialize(::webnn::mojom::internal::CreateContextOptions_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::webnn::mojom::CreateContextOptionsDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace webnn::mojom {




}  // webnn::mojom

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

namespace perfetto {

template <>
struct  TraceFormatTraits<::webnn::mojom::PowerPreference> {
 static void WriteIntoTrace(perfetto::TracedValue context, ::webnn::mojom::PowerPreference value);
};

} // namespace perfetto

namespace perfetto {

template <>
struct  TraceFormatTraits<::webnn::mojom::CreateContextResult> {
 static void WriteIntoTrace(perfetto::TracedValue context, ::webnn::mojom::CreateContextResult value);
};

} // namespace perfetto

#endif  // SERVICES_WEBNN_PUBLIC_MOJOM_WEBNN_SERVICE_MOJOM_SHARED_H_