// third_party/blink/public/mojom/file_system_access/file_system_access_capacity_allocation_host.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_FILE_SYSTEM_ACCESS_FILE_SYSTEM_ACCESS_CAPACITY_ALLOCATION_HOST_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_FILE_SYSTEM_ACCESS_FILE_SYSTEM_ACCESS_CAPACITY_ALLOCATION_HOST_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "third_party/abseil-cpp/absl/types/optional.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/file_system_access/file_system_access_capacity_allocation_host.mojom-shared.h"
#include "third_party/blink/public/mojom/file_system_access/file_system_access_capacity_allocation_host.mojom-forward.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/public/common/common_export.h"




namespace blink::mojom {

class FileSystemAccessCapacityAllocationHostProxy;

template <typename ImplRefTraits>
class FileSystemAccessCapacityAllocationHostStub;

class FileSystemAccessCapacityAllocationHostRequestValidator;
class FileSystemAccessCapacityAllocationHostResponseValidator;


class BLINK_COMMON_EXPORT FileSystemAccessCapacityAllocationHost
    : public FileSystemAccessCapacityAllocationHostInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static inline constexpr uint32_t kSyncMethodOrdinals[] = {
    0
  };
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = FileSystemAccessCapacityAllocationHostInterfaceBase;
  using Proxy_ = FileSystemAccessCapacityAllocationHostProxy;

  template <typename ImplRefTraits>
  using Stub_ = FileSystemAccessCapacityAllocationHostStub<ImplRefTraits>;

  using RequestValidator_ = FileSystemAccessCapacityAllocationHostRequestValidator;
  using ResponseValidator_ = FileSystemAccessCapacityAllocationHostResponseValidator;
  enum MethodMinVersions : uint32_t {
    kRequestCapacityChangeMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct RequestCapacityChange_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~FileSystemAccessCapacityAllocationHost() = default;

  // Sync method. This signature is used by the client side; the service side
  // should implement the signature with callback below.
  
  virtual bool RequestCapacityChange(int64_t capacity_delta, int64_t* out_granted_capacity_delta);

  using RequestCapacityChangeCallback = base::OnceCallback<void(int64_t)>;
  
  virtual void RequestCapacityChange(int64_t capacity_delta, RequestCapacityChangeCallback callback) = 0;
};



class BLINK_COMMON_EXPORT FileSystemAccessCapacityAllocationHostProxy
    : public FileSystemAccessCapacityAllocationHost {
 public:
  using InterfaceType = FileSystemAccessCapacityAllocationHost;

  explicit FileSystemAccessCapacityAllocationHostProxy(mojo::MessageReceiverWithResponder* receiver);
  
  bool RequestCapacityChange(int64_t capacity_delta, int64_t* out_granted_capacity_delta) final;
  
  void RequestCapacityChange(int64_t capacity_delta, RequestCapacityChangeCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_COMMON_EXPORT FileSystemAccessCapacityAllocationHostStubDispatch {
 public:
  static bool Accept(FileSystemAccessCapacityAllocationHost* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      FileSystemAccessCapacityAllocationHost* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<FileSystemAccessCapacityAllocationHost>>
class FileSystemAccessCapacityAllocationHostStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  FileSystemAccessCapacityAllocationHostStub() = default;
  ~FileSystemAccessCapacityAllocationHostStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return FileSystemAccessCapacityAllocationHostStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return FileSystemAccessCapacityAllocationHostStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT FileSystemAccessCapacityAllocationHostRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT FileSystemAccessCapacityAllocationHostResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // blink::mojom

namespace mojo {

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_FILE_SYSTEM_ACCESS_FILE_SYSTEM_ACCESS_CAPACITY_ALLOCATION_HOST_MOJOM_H_