// third_party/blink/public/mojom/runtime_feature_state/runtime_feature_state_controller.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_RUNTIME_FEATURE_STATE_RUNTIME_FEATURE_STATE_CONTROLLER_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_RUNTIME_FEATURE_STATE_RUNTIME_FEATURE_STATE_CONTROLLER_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "third_party/abseil-cpp/absl/types/optional.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/runtime_feature_state/runtime_feature_state_controller.mojom-shared.h"
#include "third_party/blink/public/mojom/runtime_feature_state/runtime_feature_state_controller.mojom-forward.h"
#include "third_party/blink/public/mojom/runtime_feature_state/runtime_feature_state.mojom.h"
#include "url/mojom/origin.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/public/common/common_export.h"




namespace blink::mojom {

class RuntimeFeatureStateControllerProxy;

template <typename ImplRefTraits>
class RuntimeFeatureStateControllerStub;

class RuntimeFeatureStateControllerRequestValidator;


class BLINK_COMMON_EXPORT RuntimeFeatureStateController
    : public RuntimeFeatureStateControllerInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = RuntimeFeatureStateControllerInterfaceBase;
  using Proxy_ = RuntimeFeatureStateControllerProxy;

  template <typename ImplRefTraits>
  using Stub_ = RuntimeFeatureStateControllerStub<ImplRefTraits>;

  using RequestValidator_ = RuntimeFeatureStateControllerRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kApplyFeatureDiffForOriginTrialMinVersion = 0,
    kEnablePersistentTrialMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct ApplyFeatureDiffForOriginTrial_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct EnablePersistentTrial_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~RuntimeFeatureStateController() = default;

  
  virtual void ApplyFeatureDiffForOriginTrial(base::flat_map<::blink::mojom::RuntimeFeatureState, FeatureValuePtr> modified_features) = 0;

  
  virtual void EnablePersistentTrial(const std::string& token, const std::vector<::url::Origin>& script_origins) = 0;
};



class BLINK_COMMON_EXPORT RuntimeFeatureStateControllerProxy
    : public RuntimeFeatureStateController {
 public:
  using InterfaceType = RuntimeFeatureStateController;

  explicit RuntimeFeatureStateControllerProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void ApplyFeatureDiffForOriginTrial(base::flat_map<::blink::mojom::RuntimeFeatureState, FeatureValuePtr> modified_features) final;
  
  void EnablePersistentTrial(const std::string& token, const std::vector<::url::Origin>& script_origins) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_COMMON_EXPORT RuntimeFeatureStateControllerStubDispatch {
 public:
  static bool Accept(RuntimeFeatureStateController* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      RuntimeFeatureStateController* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<RuntimeFeatureStateController>>
class RuntimeFeatureStateControllerStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  RuntimeFeatureStateControllerStub() = default;
  ~RuntimeFeatureStateControllerStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return RuntimeFeatureStateControllerStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return RuntimeFeatureStateControllerStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT RuntimeFeatureStateControllerRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};








class BLINK_COMMON_EXPORT FeatureValue {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<FeatureValue, T>::value>;
  using DataView = FeatureValueDataView;
  using Data_ = internal::FeatureValue_Data;

  template <typename... Args>
  static FeatureValuePtr New(Args&&... args) {
    return FeatureValuePtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static FeatureValuePtr From(const U& u) {
    return mojo::TypeConverter<FeatureValuePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, FeatureValue>::Convert(*this);
  }


  FeatureValue();

  FeatureValue(
      bool is_enabled,
      std::vector<std::string> tokens);


  ~FeatureValue();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = FeatureValuePtr>
  FeatureValuePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, FeatureValue::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, FeatureValue::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, FeatureValue::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        FeatureValue::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        FeatureValue::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::FeatureValue_UnserializedMessageContext<
            UserType, FeatureValue::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<FeatureValue::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return FeatureValue::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::FeatureValue_UnserializedMessageContext<
            UserType, FeatureValue::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<FeatureValue::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  bool is_enabled;
  
  std::vector<std::string> tokens;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, FeatureValue::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, FeatureValue::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, FeatureValue::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, FeatureValue::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
FeatureValuePtr FeatureValue::Clone() const {
  return New(
      mojo::Clone(is_enabled),
      mojo::Clone(tokens)
  );
}

template <typename T, FeatureValue::EnableIfSame<T>*>
bool FeatureValue::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->is_enabled, other_struct.is_enabled))
    return false;
  if (!mojo::Equals(this->tokens, other_struct.tokens))
    return false;
  return true;
}

template <typename T, FeatureValue::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.is_enabled < rhs.is_enabled)
    return true;
  if (rhs.is_enabled < lhs.is_enabled)
    return false;
  if (lhs.tokens < rhs.tokens)
    return true;
  if (rhs.tokens < lhs.tokens)
    return false;
  return false;
}


}  // blink::mojom

namespace mojo {


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::FeatureValue::DataView,
                                         ::blink::mojom::FeatureValuePtr> {
  static bool IsNull(const ::blink::mojom::FeatureValuePtr& input) { return !input; }
  static void SetToNull(::blink::mojom::FeatureValuePtr* output) { output->reset(); }

  static decltype(::blink::mojom::FeatureValue::is_enabled) is_enabled(
      const ::blink::mojom::FeatureValuePtr& input) {
    return input->is_enabled;
  }

  static const decltype(::blink::mojom::FeatureValue::tokens)& tokens(
      const ::blink::mojom::FeatureValuePtr& input) {
    return input->tokens;
  }

  static bool Read(::blink::mojom::FeatureValue::DataView input, ::blink::mojom::FeatureValuePtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_RUNTIME_FEATURE_STATE_RUNTIME_FEATURE_STATE_CONTROLLER_MOJOM_H_