// third_party/blink/public/mojom/safe_url_pattern.mojom-shared-internal.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_SAFE_URL_PATTERN_MOJOM_SHARED_INTERNAL_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_SAFE_URL_PATTERN_MOJOM_SHARED_INTERNAL_H_
#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"
#include "base/component_export.h"



namespace mojo {
namespace internal {
class ValidationContext;
}
}


namespace blink::mojom {
namespace internal {
class SafeUrlPattern_Data;
class FixedPattern_Data;
class WildcardPattern_Data;
class SafeUrlPatternPart_Data;
class SafeUrlPatternOptions_Data;
class PatternTemplate_Data;

struct Modifier_Data {
 public:
  static bool constexpr kIsExtensible = false;

  static bool IsKnownValue(int32_t value) {
    switch (value) {
      case 0:
      case 1:
      case 2:
      case 3:
        return true;
    }
    return false;
  }

  static bool Validate(int32_t value,
                       mojo::internal::ValidationContext* validation_context) {
    if (kIsExtensible || IsKnownValue(value))
      return true;

    ReportValidationError(validation_context,
                          mojo::internal::VALIDATION_ERROR_UNKNOWN_ENUM_VALUE);
    return false;
  }
};

#pragma pack(push, 1)


class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) PatternTemplate_Data {
 public:
  // Used to identify Mojom Union Data Classes.
  typedef void MojomUnionDataType;

  PatternTemplate_Data() = default;
  // Do nothing in the destructor since it won't be called when it is a
  // non-inlined union.
  ~PatternTemplate_Data() = default;

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context,
                       bool inlined);

  bool is_null() const { return size == 0; }

  void set_null() {
    size = 0U;
    tag = static_cast<PatternTemplate_Tag>(0);
    data.unknown = 0U;
  }

  // TODO(crbug.com/1148486): SHOUTY_CASE values are being deprecated per C++ code style
  // guidelines (https://google.github.io/styleguide/cppguide.html#Enumerator_Names),
  // please use kCamelCase values instead.  Cleanup NULL_VALUE, BOOL_VALUE, INT_VALUE, etc.
  // generation once codebase is transitioned to kNullValue, kBoolValue, kIntValue, etc.
  enum class PatternTemplate_Tag : uint32_t {

    
    kFixed,
    
    kFullWildcard,
    
    kSegmentWildcard,
  };

  // A note on layout:
  // "Each non-static data member is allocated as if it were the sole member of
  // a struct." - Section 9.5.2 ISO/IEC 14882:2011 (The C++ Spec)
  union MOJO_ALIGNAS(8) Union_ {
    Union_() : unknown(0) {}
    mojo::internal::Pointer<internal::FixedPattern_Data> f_fixed;
    mojo::internal::Pointer<internal::WildcardPattern_Data> f_full_wildcard;
    mojo::internal::Pointer<internal::WildcardPattern_Data> f_segment_wildcard;
    uint64_t unknown;
  };

  uint32_t size;
  PatternTemplate_Tag tag;
  Union_ data;
};
static_assert(sizeof(PatternTemplate_Data) == mojo::internal::kUnionDataSize,
              "Bad sizeof(PatternTemplate_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) SafeUrlPattern_Data {
 public:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::SafeUrlPatternPart_Data>>> protocol;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::SafeUrlPatternPart_Data>>> username;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::SafeUrlPatternPart_Data>>> password;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::SafeUrlPatternPart_Data>>> hostname;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::SafeUrlPatternPart_Data>>> port;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::SafeUrlPatternPart_Data>>> pathname;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::SafeUrlPatternPart_Data>>> search;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::SafeUrlPatternPart_Data>>> hash;
  mojo::internal::Pointer<internal::SafeUrlPatternOptions_Data> options;

 private:
  friend class mojo::internal::MessageFragment<SafeUrlPattern_Data>;

  SafeUrlPattern_Data();
  ~SafeUrlPattern_Data() = delete;
};
static_assert(sizeof(SafeUrlPattern_Data) == 80,
              "Bad sizeof(SafeUrlPattern_Data)");
// Used by SafeUrlPattern::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct SafeUrlPattern_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  SafeUrlPattern_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~SafeUrlPattern_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::Message& message) override {
    mojo::internal::MessageFragment<SafeUrlPattern_Data> fragment(message);
    mojo::internal::Serialize<DataView>(user_data_, fragment);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    SafeUrlPattern_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) FixedPattern_Data {
 public:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> value;

 private:
  friend class mojo::internal::MessageFragment<FixedPattern_Data>;

  FixedPattern_Data();
  ~FixedPattern_Data() = delete;
};
static_assert(sizeof(FixedPattern_Data) == 16,
              "Bad sizeof(FixedPattern_Data)");
// Used by FixedPattern::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct FixedPattern_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  FixedPattern_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~FixedPattern_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::Message& message) override {
    mojo::internal::MessageFragment<FixedPattern_Data> fragment(message);
    mojo::internal::Serialize<DataView>(user_data_, fragment);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    FixedPattern_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) WildcardPattern_Data {
 public:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> name;
  mojo::internal::Pointer<mojo::internal::String_Data> prefix;
  mojo::internal::Pointer<mojo::internal::String_Data> value;
  mojo::internal::Pointer<mojo::internal::String_Data> suffix;

 private:
  friend class mojo::internal::MessageFragment<WildcardPattern_Data>;

  WildcardPattern_Data();
  ~WildcardPattern_Data() = delete;
};
static_assert(sizeof(WildcardPattern_Data) == 40,
              "Bad sizeof(WildcardPattern_Data)");
// Used by WildcardPattern::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct WildcardPattern_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  WildcardPattern_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~WildcardPattern_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::Message& message) override {
    mojo::internal::MessageFragment<WildcardPattern_Data> fragment(message);
    mojo::internal::Serialize<DataView>(user_data_, fragment);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    WildcardPattern_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) SafeUrlPatternPart_Data {
 public:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  internal::PatternTemplate_Data pattern;
  int32_t modifier;
  uint8_t padfinal_[4];

 private:
  friend class mojo::internal::MessageFragment<SafeUrlPatternPart_Data>;

  SafeUrlPatternPart_Data();
  ~SafeUrlPatternPart_Data() = delete;
};
static_assert(sizeof(SafeUrlPatternPart_Data) == 32,
              "Bad sizeof(SafeUrlPatternPart_Data)");
// Used by SafeUrlPatternPart::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct SafeUrlPatternPart_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  SafeUrlPatternPart_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~SafeUrlPatternPart_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::Message& message) override {
    mojo::internal::MessageFragment<SafeUrlPatternPart_Data> fragment(message);
    mojo::internal::Serialize<DataView>(user_data_, fragment);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    SafeUrlPatternPart_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) SafeUrlPatternOptions_Data {
 public:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t ignore_case : 1;
  uint8_t padfinal_[7];

 private:
  friend class mojo::internal::MessageFragment<SafeUrlPatternOptions_Data>;

  SafeUrlPatternOptions_Data();
  ~SafeUrlPatternOptions_Data() = delete;
};
static_assert(sizeof(SafeUrlPatternOptions_Data) == 16,
              "Bad sizeof(SafeUrlPatternOptions_Data)");
// Used by SafeUrlPatternOptions::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct SafeUrlPatternOptions_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  SafeUrlPatternOptions_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~SafeUrlPatternOptions_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::Message& message) override {
    mojo::internal::MessageFragment<SafeUrlPatternOptions_Data> fragment(message);
    mojo::internal::Serialize<DataView>(user_data_, fragment);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    SafeUrlPatternOptions_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};

#pragma pack(pop)

}  // namespace internal

}  // blink::mojom

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_SAFE_URL_PATTERN_MOJOM_SHARED_INTERNAL_H_