// third_party/blink/public/mojom/webid/federated_auth_request.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_WEBID_FEDERATED_AUTH_REQUEST_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_WEBID_FEDERATED_AUTH_REQUEST_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "third_party/abseil-cpp/absl/types/optional.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/webid/federated_auth_request.mojom-shared.h"
#include "third_party/blink/public/mojom/webid/federated_auth_request.mojom-forward.h"
#include "third_party/blink/public/mojom/credentialmanagement/credential_manager.mojom.h"
#include "url/mojom/url.mojom.h"
#include "url/mojom/origin.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/public/common/common_export.h"




namespace blink::mojom {

class FederatedAuthRequestProxy;

template <typename ImplRefTraits>
class FederatedAuthRequestStub;

class FederatedAuthRequestRequestValidator;
class FederatedAuthRequestResponseValidator;


class BLINK_COMMON_EXPORT FederatedAuthRequest
    : public FederatedAuthRequestInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = FederatedAuthRequestInterfaceBase;
  using Proxy_ = FederatedAuthRequestProxy;

  template <typename ImplRefTraits>
  using Stub_ = FederatedAuthRequestStub<ImplRefTraits>;

  using RequestValidator_ = FederatedAuthRequestRequestValidator;
  using ResponseValidator_ = FederatedAuthRequestResponseValidator;
  enum MethodMinVersions : uint32_t {
    kRequestTokenMinVersion = 0,
    kRequestUserInfoMinVersion = 0,
    kCancelTokenRequestMinVersion = 0,
    kResolveTokenRequestMinVersion = 0,
    kLogoutRpsMinVersion = 0,
    kSetIdpSigninStatusMinVersion = 0,
    kRegisterIdPMinVersion = 0,
    kUnregisterIdPMinVersion = 0,
    kCloseModalDialogViewMinVersion = 0,
    kPreventSilentAccessMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct RequestToken_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct RequestUserInfo_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct CancelTokenRequest_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct ResolveTokenRequest_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct LogoutRps_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct SetIdpSigninStatus_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct RegisterIdP_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct UnregisterIdP_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct CloseModalDialogView_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct PreventSilentAccess_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~FederatedAuthRequest() = default;


  using RequestTokenCallback = base::OnceCallback<void(RequestTokenStatus, const absl::optional<::GURL>&, const absl::optional<std::string>&, bool)>;
  
  virtual void RequestToken(std::vector<IdentityProviderGetParametersPtr> idp_get_params, ::password_manager::CredentialMediationRequirement requirement, RequestTokenCallback callback) = 0;


  using RequestUserInfoCallback = base::OnceCallback<void(RequestUserInfoStatus, absl::optional<std::vector<IdentityUserInfoPtr>>)>;
  
  virtual void RequestUserInfo(IdentityProviderConfigPtr provider, RequestUserInfoCallback callback) = 0;

  
  virtual void CancelTokenRequest() = 0;


  using ResolveTokenRequestCallback = base::OnceCallback<void(bool)>;
  
  virtual void ResolveTokenRequest(const std::string& token, ResolveTokenRequestCallback callback) = 0;


  using LogoutRpsCallback = base::OnceCallback<void(LogoutRpsStatus)>;
  
  virtual void LogoutRps(std::vector<LogoutRpsRequestPtr> rp_logout_requests, LogoutRpsCallback callback) = 0;

  
  virtual void SetIdpSigninStatus(const ::url::Origin& origin, IdpSigninStatus status) = 0;


  using RegisterIdPCallback = base::OnceCallback<void(bool)>;
  
  virtual void RegisterIdP(const ::GURL& url, RegisterIdPCallback callback) = 0;


  using UnregisterIdPCallback = base::OnceCallback<void(bool)>;
  
  virtual void UnregisterIdP(const ::GURL& url, UnregisterIdPCallback callback) = 0;

  
  virtual void CloseModalDialogView() = 0;


  using PreventSilentAccessCallback = base::OnceCallback<void()>;
  
  virtual void PreventSilentAccess(PreventSilentAccessCallback callback) = 0;
};



class BLINK_COMMON_EXPORT FederatedAuthRequestProxy
    : public FederatedAuthRequest {
 public:
  using InterfaceType = FederatedAuthRequest;

  explicit FederatedAuthRequestProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void RequestToken(std::vector<IdentityProviderGetParametersPtr> idp_get_params, ::password_manager::CredentialMediationRequirement requirement, RequestTokenCallback callback) final;
  
  void RequestUserInfo(IdentityProviderConfigPtr provider, RequestUserInfoCallback callback) final;
  
  void CancelTokenRequest() final;
  
  void ResolveTokenRequest(const std::string& token, ResolveTokenRequestCallback callback) final;
  
  void LogoutRps(std::vector<LogoutRpsRequestPtr> rp_logout_requests, LogoutRpsCallback callback) final;
  
  void SetIdpSigninStatus(const ::url::Origin& origin, IdpSigninStatus status) final;
  
  void RegisterIdP(const ::GURL& url, RegisterIdPCallback callback) final;
  
  void UnregisterIdP(const ::GURL& url, UnregisterIdPCallback callback) final;
  
  void CloseModalDialogView() final;
  
  void PreventSilentAccess(PreventSilentAccessCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_COMMON_EXPORT FederatedAuthRequestStubDispatch {
 public:
  static bool Accept(FederatedAuthRequest* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      FederatedAuthRequest* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<FederatedAuthRequest>>
class FederatedAuthRequestStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  FederatedAuthRequestStub() = default;
  ~FederatedAuthRequestStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return FederatedAuthRequestStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return FederatedAuthRequestStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT FederatedAuthRequestRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT FederatedAuthRequestResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};







class BLINK_COMMON_EXPORT MDocElement {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<MDocElement, T>::value>;
  using DataView = MDocElementDataView;
  using Data_ = internal::MDocElement_Data;

  template <typename... Args>
  static MDocElementPtr New(Args&&... args) {
    return MDocElementPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static MDocElementPtr From(const U& u) {
    return mojo::TypeConverter<MDocElementPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, MDocElement>::Convert(*this);
  }


  MDocElement();

  MDocElement(
      const std::string& element_namespace,
      const std::string& name);


  ~MDocElement();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = MDocElementPtr>
  MDocElementPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, MDocElement::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, MDocElement::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, MDocElement::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        MDocElement::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        MDocElement::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::MDocElement_UnserializedMessageContext<
            UserType, MDocElement::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<MDocElement::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return MDocElement::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::MDocElement_UnserializedMessageContext<
            UserType, MDocElement::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<MDocElement::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::string element_namespace;
  
  std::string name;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, MDocElement::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, MDocElement::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, MDocElement::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, MDocElement::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class BLINK_COMMON_EXPORT IdentityUserInfo {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<IdentityUserInfo, T>::value>;
  using DataView = IdentityUserInfoDataView;
  using Data_ = internal::IdentityUserInfo_Data;

  template <typename... Args>
  static IdentityUserInfoPtr New(Args&&... args) {
    return IdentityUserInfoPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static IdentityUserInfoPtr From(const U& u) {
    return mojo::TypeConverter<IdentityUserInfoPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, IdentityUserInfo>::Convert(*this);
  }


  IdentityUserInfo();

  IdentityUserInfo(
      const std::string& email,
      const std::string& given_name,
      const std::string& name,
      const std::string& picture);


  ~IdentityUserInfo();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = IdentityUserInfoPtr>
  IdentityUserInfoPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, IdentityUserInfo::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, IdentityUserInfo::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, IdentityUserInfo::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        IdentityUserInfo::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        IdentityUserInfo::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::IdentityUserInfo_UnserializedMessageContext<
            UserType, IdentityUserInfo::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<IdentityUserInfo::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return IdentityUserInfo::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::IdentityUserInfo_UnserializedMessageContext<
            UserType, IdentityUserInfo::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<IdentityUserInfo::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::string email;
  
  std::string given_name;
  
  std::string name;
  
  std::string picture;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, IdentityUserInfo::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, IdentityUserInfo::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, IdentityUserInfo::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, IdentityUserInfo::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class BLINK_COMMON_EXPORT IdentityProvider {
 public:
  using DataView = IdentityProviderDataView;
  using Data_ = internal::IdentityProvider_Data;
  using Tag = Data_::IdentityProvider_Tag;

  template <typename... Args>
  static IdentityProviderPtr New(Args&&... args) {
    static_assert(
        sizeof...(args) < 0,
        "Do not use Union::New(); to create a union of a given subtype, use "
        "New<SubType>(), not New() followed by set_<sub_type>(). To represent "
        "an empty union, mark the field or parameter as nullable in the mojom "
        "definition.");
    return nullptr;
  }
  // Construct an instance holding |federated|.
  static IdentityProviderPtr
  NewFederated(
      IdentityProviderConfigPtr federated) {
    auto result = IdentityProviderPtr(absl::in_place);
    result->set_federated(std::move(federated));
    return result;
  }
  // Construct an instance holding |mdoc|.
  static IdentityProviderPtr
  NewMdoc(
      MDocProviderPtr mdoc) {
    auto result = IdentityProviderPtr(absl::in_place);
    result->set_mdoc(std::move(mdoc));
    return result;
  }

  template <typename U>
  static IdentityProviderPtr From(const U& u) {
    return mojo::TypeConverter<IdentityProviderPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, IdentityProvider>::Convert(*this);
  }

  IdentityProvider();
  ~IdentityProvider();
  // Delete the copy constructor and copy assignment operators because `data_`
  // contains raw pointers that must not be copied.
  IdentityProvider(const IdentityProvider& other) = delete;
  IdentityProvider& operator=(const IdentityProvider& other) = delete;

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename UnionPtrType = IdentityProviderPtr>
  IdentityProviderPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, IdentityProvider>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename T,
            typename std::enable_if<std::is_same<
                T, IdentityProvider>::value>::type* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  Tag which() const {
    return tag_;
  }


  
  bool is_federated() const { return tag_ == Tag::kFederated; }

  
  IdentityProviderConfigPtr& get_federated() const {
    CHECK(tag_ == Tag::kFederated);
    return *(data_.federated);
  }

  
  void set_federated(
      IdentityProviderConfigPtr federated);
  
  bool is_mdoc() const { return tag_ == Tag::kMdoc; }

  
  MDocProviderPtr& get_mdoc() const {
    CHECK(tag_ == Tag::kMdoc);
    return *(data_.mdoc);
  }

  
  void set_mdoc(
      MDocProviderPtr mdoc);

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        IdentityProvider::DataView>(input);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    return mojo::internal::DeserializeImpl<IdentityProvider::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

 private:
  union Union_ {
    Union_() = default;
    ~Union_() = default;
    IdentityProviderConfigPtr* federated;
    MDocProviderPtr* mdoc;
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  void DestroyActive();
  Tag tag_;
  Union_ data_;
};





class BLINK_COMMON_EXPORT LogoutRpsRequest {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<LogoutRpsRequest, T>::value>;
  using DataView = LogoutRpsRequestDataView;
  using Data_ = internal::LogoutRpsRequest_Data;

  template <typename... Args>
  static LogoutRpsRequestPtr New(Args&&... args) {
    return LogoutRpsRequestPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static LogoutRpsRequestPtr From(const U& u) {
    return mojo::TypeConverter<LogoutRpsRequestPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, LogoutRpsRequest>::Convert(*this);
  }


  LogoutRpsRequest();

  LogoutRpsRequest(
      const ::GURL& url,
      const std::string& account_id);


  ~LogoutRpsRequest();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = LogoutRpsRequestPtr>
  LogoutRpsRequestPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, LogoutRpsRequest::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, LogoutRpsRequest::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, LogoutRpsRequest::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        LogoutRpsRequest::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        LogoutRpsRequest::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::LogoutRpsRequest_UnserializedMessageContext<
            UserType, LogoutRpsRequest::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<LogoutRpsRequest::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return LogoutRpsRequest::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::LogoutRpsRequest_UnserializedMessageContext<
            UserType, LogoutRpsRequest::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<LogoutRpsRequest::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::GURL url;
  
  std::string account_id;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, LogoutRpsRequest::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, LogoutRpsRequest::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, LogoutRpsRequest::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, LogoutRpsRequest::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class BLINK_COMMON_EXPORT MDocProvider {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<MDocProvider, T>::value>;
  using DataView = MDocProviderDataView;
  using Data_ = internal::MDocProvider_Data;

  template <typename... Args>
  static MDocProviderPtr New(Args&&... args) {
    return MDocProviderPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static MDocProviderPtr From(const U& u) {
    return mojo::TypeConverter<MDocProviderPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, MDocProvider>::Convert(*this);
  }


  MDocProvider();

  MDocProvider(
      const std::string& reader_public_key,
      const std::string& document_type,
      std::vector<MDocElementPtr> requested_elements);

MDocProvider(const MDocProvider&) = delete;
MDocProvider& operator=(const MDocProvider&) = delete;

  ~MDocProvider();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = MDocProviderPtr>
  MDocProviderPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, MDocProvider::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, MDocProvider::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, MDocProvider::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        MDocProvider::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        MDocProvider::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::MDocProvider_UnserializedMessageContext<
            UserType, MDocProvider::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<MDocProvider::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return MDocProvider::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::MDocProvider_UnserializedMessageContext<
            UserType, MDocProvider::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<MDocProvider::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::string reader_public_key;
  
  std::string document_type;
  
  std::vector<MDocElementPtr> requested_elements;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, MDocProvider::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, MDocProvider::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, MDocProvider::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, MDocProvider::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class BLINK_COMMON_EXPORT IdentityProviderConfig {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<IdentityProviderConfig, T>::value>;
  using DataView = IdentityProviderConfigDataView;
  using Data_ = internal::IdentityProviderConfig_Data;

  template <typename... Args>
  static IdentityProviderConfigPtr New(Args&&... args) {
    return IdentityProviderConfigPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static IdentityProviderConfigPtr From(const U& u) {
    return mojo::TypeConverter<IdentityProviderConfigPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, IdentityProviderConfig>::Convert(*this);
  }


  IdentityProviderConfig();

  IdentityProviderConfig(
      const ::GURL& config_url,
      const std::string& client_id,
      const std::string& nonce,
      const std::string& login_hint,
      const std::string& hosted_domain,
      std::vector<std::string> scope,
      std::vector<std::string> responseType,
      const base::flat_map<std::string, std::string>& params);


  ~IdentityProviderConfig();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = IdentityProviderConfigPtr>
  IdentityProviderConfigPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, IdentityProviderConfig::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, IdentityProviderConfig::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, IdentityProviderConfig::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        IdentityProviderConfig::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        IdentityProviderConfig::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::IdentityProviderConfig_UnserializedMessageContext<
            UserType, IdentityProviderConfig::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<IdentityProviderConfig::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return IdentityProviderConfig::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::IdentityProviderConfig_UnserializedMessageContext<
            UserType, IdentityProviderConfig::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<IdentityProviderConfig::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::GURL config_url;
  
  std::string client_id;
  
  std::string nonce;
  
  std::string login_hint;
  
  std::string hosted_domain;
  
  std::vector<std::string> scope;
  
  std::vector<std::string> responseType;
  
  base::flat_map<std::string, std::string> params;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, IdentityProviderConfig::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, IdentityProviderConfig::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, IdentityProviderConfig::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, IdentityProviderConfig::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class BLINK_COMMON_EXPORT IdentityProviderGetParameters {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<IdentityProviderGetParameters, T>::value>;
  using DataView = IdentityProviderGetParametersDataView;
  using Data_ = internal::IdentityProviderGetParameters_Data;

  template <typename... Args>
  static IdentityProviderGetParametersPtr New(Args&&... args) {
    return IdentityProviderGetParametersPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static IdentityProviderGetParametersPtr From(const U& u) {
    return mojo::TypeConverter<IdentityProviderGetParametersPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, IdentityProviderGetParameters>::Convert(*this);
  }


  IdentityProviderGetParameters();

  IdentityProviderGetParameters(
      std::vector<IdentityProviderPtr> providers,
      RpContext context);

IdentityProviderGetParameters(const IdentityProviderGetParameters&) = delete;
IdentityProviderGetParameters& operator=(const IdentityProviderGetParameters&) = delete;

  ~IdentityProviderGetParameters();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = IdentityProviderGetParametersPtr>
  IdentityProviderGetParametersPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, IdentityProviderGetParameters::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, IdentityProviderGetParameters::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, IdentityProviderGetParameters::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        IdentityProviderGetParameters::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        IdentityProviderGetParameters::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::IdentityProviderGetParameters_UnserializedMessageContext<
            UserType, IdentityProviderGetParameters::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<IdentityProviderGetParameters::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return IdentityProviderGetParameters::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::IdentityProviderGetParameters_UnserializedMessageContext<
            UserType, IdentityProviderGetParameters::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<IdentityProviderGetParameters::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::vector<IdentityProviderPtr> providers;
  
  RpContext context;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, IdentityProviderGetParameters::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, IdentityProviderGetParameters::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, IdentityProviderGetParameters::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, IdentityProviderGetParameters::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename UnionPtrType>
IdentityProviderPtr IdentityProvider::Clone() const {
  switch (tag_) {
    case Tag::kFederated:
      return NewFederated(
          mojo::Clone(*data_.federated));
    case Tag::kMdoc:
      return NewMdoc(
          mojo::Clone(*data_.mdoc));
  }
  return nullptr;
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, IdentityProvider>::value>::type*>
bool IdentityProvider::Equals(const T& other) const {
  if (tag_ != other.which())
    return false;

  switch (tag_) {
    case Tag::kFederated:
      return mojo::Equals(*(data_.federated), *(other.data_.federated));
    case Tag::kMdoc:
      return mojo::Equals(*(data_.mdoc), *(other.data_.mdoc));
  }

  return false;
}
template <typename StructPtrType>
LogoutRpsRequestPtr LogoutRpsRequest::Clone() const {
  return New(
      mojo::Clone(url),
      mojo::Clone(account_id)
  );
}

template <typename T, LogoutRpsRequest::EnableIfSame<T>*>
bool LogoutRpsRequest::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->url, other_struct.url))
    return false;
  if (!mojo::Equals(this->account_id, other_struct.account_id))
    return false;
  return true;
}

template <typename T, LogoutRpsRequest::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.url < rhs.url)
    return true;
  if (rhs.url < lhs.url)
    return false;
  if (lhs.account_id < rhs.account_id)
    return true;
  if (rhs.account_id < lhs.account_id)
    return false;
  return false;
}
template <typename StructPtrType>
MDocProviderPtr MDocProvider::Clone() const {
  return New(
      mojo::Clone(reader_public_key),
      mojo::Clone(document_type),
      mojo::Clone(requested_elements)
  );
}

template <typename T, MDocProvider::EnableIfSame<T>*>
bool MDocProvider::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->reader_public_key, other_struct.reader_public_key))
    return false;
  if (!mojo::Equals(this->document_type, other_struct.document_type))
    return false;
  if (!mojo::Equals(this->requested_elements, other_struct.requested_elements))
    return false;
  return true;
}

template <typename T, MDocProvider::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.reader_public_key < rhs.reader_public_key)
    return true;
  if (rhs.reader_public_key < lhs.reader_public_key)
    return false;
  if (lhs.document_type < rhs.document_type)
    return true;
  if (rhs.document_type < lhs.document_type)
    return false;
  if (lhs.requested_elements < rhs.requested_elements)
    return true;
  if (rhs.requested_elements < lhs.requested_elements)
    return false;
  return false;
}
template <typename StructPtrType>
MDocElementPtr MDocElement::Clone() const {
  return New(
      mojo::Clone(element_namespace),
      mojo::Clone(name)
  );
}

template <typename T, MDocElement::EnableIfSame<T>*>
bool MDocElement::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->element_namespace, other_struct.element_namespace))
    return false;
  if (!mojo::Equals(this->name, other_struct.name))
    return false;
  return true;
}

template <typename T, MDocElement::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.element_namespace < rhs.element_namespace)
    return true;
  if (rhs.element_namespace < lhs.element_namespace)
    return false;
  if (lhs.name < rhs.name)
    return true;
  if (rhs.name < lhs.name)
    return false;
  return false;
}
template <typename StructPtrType>
IdentityProviderConfigPtr IdentityProviderConfig::Clone() const {
  return New(
      mojo::Clone(config_url),
      mojo::Clone(client_id),
      mojo::Clone(nonce),
      mojo::Clone(login_hint),
      mojo::Clone(hosted_domain),
      mojo::Clone(scope),
      mojo::Clone(responseType),
      mojo::Clone(params)
  );
}

template <typename T, IdentityProviderConfig::EnableIfSame<T>*>
bool IdentityProviderConfig::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->config_url, other_struct.config_url))
    return false;
  if (!mojo::Equals(this->client_id, other_struct.client_id))
    return false;
  if (!mojo::Equals(this->nonce, other_struct.nonce))
    return false;
  if (!mojo::Equals(this->login_hint, other_struct.login_hint))
    return false;
  if (!mojo::Equals(this->hosted_domain, other_struct.hosted_domain))
    return false;
  if (!mojo::Equals(this->scope, other_struct.scope))
    return false;
  if (!mojo::Equals(this->responseType, other_struct.responseType))
    return false;
  if (!mojo::Equals(this->params, other_struct.params))
    return false;
  return true;
}

template <typename T, IdentityProviderConfig::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.config_url < rhs.config_url)
    return true;
  if (rhs.config_url < lhs.config_url)
    return false;
  if (lhs.client_id < rhs.client_id)
    return true;
  if (rhs.client_id < lhs.client_id)
    return false;
  if (lhs.nonce < rhs.nonce)
    return true;
  if (rhs.nonce < lhs.nonce)
    return false;
  if (lhs.login_hint < rhs.login_hint)
    return true;
  if (rhs.login_hint < lhs.login_hint)
    return false;
  if (lhs.hosted_domain < rhs.hosted_domain)
    return true;
  if (rhs.hosted_domain < lhs.hosted_domain)
    return false;
  if (lhs.scope < rhs.scope)
    return true;
  if (rhs.scope < lhs.scope)
    return false;
  if (lhs.responseType < rhs.responseType)
    return true;
  if (rhs.responseType < lhs.responseType)
    return false;
  if (lhs.params < rhs.params)
    return true;
  if (rhs.params < lhs.params)
    return false;
  return false;
}
template <typename StructPtrType>
IdentityUserInfoPtr IdentityUserInfo::Clone() const {
  return New(
      mojo::Clone(email),
      mojo::Clone(given_name),
      mojo::Clone(name),
      mojo::Clone(picture)
  );
}

template <typename T, IdentityUserInfo::EnableIfSame<T>*>
bool IdentityUserInfo::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->email, other_struct.email))
    return false;
  if (!mojo::Equals(this->given_name, other_struct.given_name))
    return false;
  if (!mojo::Equals(this->name, other_struct.name))
    return false;
  if (!mojo::Equals(this->picture, other_struct.picture))
    return false;
  return true;
}

template <typename T, IdentityUserInfo::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.email < rhs.email)
    return true;
  if (rhs.email < lhs.email)
    return false;
  if (lhs.given_name < rhs.given_name)
    return true;
  if (rhs.given_name < lhs.given_name)
    return false;
  if (lhs.name < rhs.name)
    return true;
  if (rhs.name < lhs.name)
    return false;
  if (lhs.picture < rhs.picture)
    return true;
  if (rhs.picture < lhs.picture)
    return false;
  return false;
}
template <typename StructPtrType>
IdentityProviderGetParametersPtr IdentityProviderGetParameters::Clone() const {
  return New(
      mojo::Clone(providers),
      mojo::Clone(context)
  );
}

template <typename T, IdentityProviderGetParameters::EnableIfSame<T>*>
bool IdentityProviderGetParameters::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->providers, other_struct.providers))
    return false;
  if (!mojo::Equals(this->context, other_struct.context))
    return false;
  return true;
}

template <typename T, IdentityProviderGetParameters::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.providers < rhs.providers)
    return true;
  if (rhs.providers < lhs.providers)
    return false;
  if (lhs.context < rhs.context)
    return true;
  if (rhs.context < lhs.context)
    return false;
  return false;
}


}  // blink::mojom

namespace mojo {


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::LogoutRpsRequest::DataView,
                                         ::blink::mojom::LogoutRpsRequestPtr> {
  static bool IsNull(const ::blink::mojom::LogoutRpsRequestPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::LogoutRpsRequestPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::LogoutRpsRequest::url)& url(
      const ::blink::mojom::LogoutRpsRequestPtr& input) {
    return input->url;
  }

  static const decltype(::blink::mojom::LogoutRpsRequest::account_id)& account_id(
      const ::blink::mojom::LogoutRpsRequestPtr& input) {
    return input->account_id;
  }

  static bool Read(::blink::mojom::LogoutRpsRequest::DataView input, ::blink::mojom::LogoutRpsRequestPtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::MDocProvider::DataView,
                                         ::blink::mojom::MDocProviderPtr> {
  static bool IsNull(const ::blink::mojom::MDocProviderPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::MDocProviderPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::MDocProvider::reader_public_key)& reader_public_key(
      const ::blink::mojom::MDocProviderPtr& input) {
    return input->reader_public_key;
  }

  static const decltype(::blink::mojom::MDocProvider::document_type)& document_type(
      const ::blink::mojom::MDocProviderPtr& input) {
    return input->document_type;
  }

  static const decltype(::blink::mojom::MDocProvider::requested_elements)& requested_elements(
      const ::blink::mojom::MDocProviderPtr& input) {
    return input->requested_elements;
  }

  static bool Read(::blink::mojom::MDocProvider::DataView input, ::blink::mojom::MDocProviderPtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::MDocElement::DataView,
                                         ::blink::mojom::MDocElementPtr> {
  static bool IsNull(const ::blink::mojom::MDocElementPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::MDocElementPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::MDocElement::element_namespace)& element_namespace(
      const ::blink::mojom::MDocElementPtr& input) {
    return input->element_namespace;
  }

  static const decltype(::blink::mojom::MDocElement::name)& name(
      const ::blink::mojom::MDocElementPtr& input) {
    return input->name;
  }

  static bool Read(::blink::mojom::MDocElement::DataView input, ::blink::mojom::MDocElementPtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::IdentityProviderConfig::DataView,
                                         ::blink::mojom::IdentityProviderConfigPtr> {
  static bool IsNull(const ::blink::mojom::IdentityProviderConfigPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::IdentityProviderConfigPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::IdentityProviderConfig::config_url)& config_url(
      const ::blink::mojom::IdentityProviderConfigPtr& input) {
    return input->config_url;
  }

  static const decltype(::blink::mojom::IdentityProviderConfig::client_id)& client_id(
      const ::blink::mojom::IdentityProviderConfigPtr& input) {
    return input->client_id;
  }

  static const decltype(::blink::mojom::IdentityProviderConfig::nonce)& nonce(
      const ::blink::mojom::IdentityProviderConfigPtr& input) {
    return input->nonce;
  }

  static const decltype(::blink::mojom::IdentityProviderConfig::login_hint)& login_hint(
      const ::blink::mojom::IdentityProviderConfigPtr& input) {
    return input->login_hint;
  }

  static const decltype(::blink::mojom::IdentityProviderConfig::hosted_domain)& hosted_domain(
      const ::blink::mojom::IdentityProviderConfigPtr& input) {
    return input->hosted_domain;
  }

  static const decltype(::blink::mojom::IdentityProviderConfig::scope)& scope(
      const ::blink::mojom::IdentityProviderConfigPtr& input) {
    return input->scope;
  }

  static const decltype(::blink::mojom::IdentityProviderConfig::responseType)& responseType(
      const ::blink::mojom::IdentityProviderConfigPtr& input) {
    return input->responseType;
  }

  static const decltype(::blink::mojom::IdentityProviderConfig::params)& params(
      const ::blink::mojom::IdentityProviderConfigPtr& input) {
    return input->params;
  }

  static bool Read(::blink::mojom::IdentityProviderConfig::DataView input, ::blink::mojom::IdentityProviderConfigPtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::IdentityUserInfo::DataView,
                                         ::blink::mojom::IdentityUserInfoPtr> {
  static bool IsNull(const ::blink::mojom::IdentityUserInfoPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::IdentityUserInfoPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::IdentityUserInfo::email)& email(
      const ::blink::mojom::IdentityUserInfoPtr& input) {
    return input->email;
  }

  static const decltype(::blink::mojom::IdentityUserInfo::given_name)& given_name(
      const ::blink::mojom::IdentityUserInfoPtr& input) {
    return input->given_name;
  }

  static const decltype(::blink::mojom::IdentityUserInfo::name)& name(
      const ::blink::mojom::IdentityUserInfoPtr& input) {
    return input->name;
  }

  static const decltype(::blink::mojom::IdentityUserInfo::picture)& picture(
      const ::blink::mojom::IdentityUserInfoPtr& input) {
    return input->picture;
  }

  static bool Read(::blink::mojom::IdentityUserInfo::DataView input, ::blink::mojom::IdentityUserInfoPtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::IdentityProviderGetParameters::DataView,
                                         ::blink::mojom::IdentityProviderGetParametersPtr> {
  static bool IsNull(const ::blink::mojom::IdentityProviderGetParametersPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::IdentityProviderGetParametersPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::IdentityProviderGetParameters::providers)& providers(
      const ::blink::mojom::IdentityProviderGetParametersPtr& input) {
    return input->providers;
  }

  static decltype(::blink::mojom::IdentityProviderGetParameters::context) context(
      const ::blink::mojom::IdentityProviderGetParametersPtr& input) {
    return input->context;
  }

  static bool Read(::blink::mojom::IdentityProviderGetParameters::DataView input, ::blink::mojom::IdentityProviderGetParametersPtr* output);
};


template <>
struct BLINK_COMMON_EXPORT UnionTraits<::blink::mojom::IdentityProvider::DataView,
                                        ::blink::mojom::IdentityProviderPtr> {
  static bool IsNull(const ::blink::mojom::IdentityProviderPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::IdentityProviderPtr* output) { output->reset(); }

  static ::blink::mojom::IdentityProvider::Tag GetTag(const ::blink::mojom::IdentityProviderPtr& input) {
    return input->which();
  }

  static const ::blink::mojom::IdentityProviderConfigPtr& federated(const ::blink::mojom::IdentityProviderPtr& input) {
    return input->get_federated();
  }

  static const ::blink::mojom::MDocProviderPtr& mdoc(const ::blink::mojom::IdentityProviderPtr& input) {
    return input->get_mdoc();
  }

  static bool Read(::blink::mojom::IdentityProvider::DataView input, ::blink::mojom::IdentityProviderPtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_WEBID_FEDERATED_AUTH_REQUEST_MOJOM_H_