// third_party/blink/public/mojom/worker/worklet_global_scope_creation_params.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_WORKER_WORKLET_GLOBAL_SCOPE_CREATION_PARAMS_MOJOM_SHARED_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_WORKER_WORKLET_GLOBAL_SCOPE_CREATION_PARAMS_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/worker/worklet_global_scope_creation_params.mojom-shared-internal.h"
#include "third_party/blink/public/mojom/devtools/devtools_agent.mojom-shared.h"
#include "mojo/public/mojom/base/unguessable_token.mojom-shared.h"
#include "url/mojom/url.mojom-shared.h"
#include "mojo/public/cpp/bindings/lib/interface_serialization.h"
#include "mojo/public/cpp/system/data_pipe.h"


#include "base/component_export.h"




namespace blink::mojom {
class WorkletGlobalScopeCreationParamsDataView;



}  // blink::mojom

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::blink::mojom::WorkletGlobalScopeCreationParamsDataView> {
  using Data = ::blink::mojom::internal::WorkletGlobalScopeCreationParams_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace blink::mojom {
// Interface base classes. They are used for type safety check.
class WorkletDevToolsHostInterfaceBase {};

using WorkletDevToolsHostPtrDataView =
    mojo::InterfacePtrDataView<WorkletDevToolsHostInterfaceBase>;
using WorkletDevToolsHostRequestDataView =
    mojo::InterfaceRequestDataView<WorkletDevToolsHostInterfaceBase>;
using WorkletDevToolsHostAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<WorkletDevToolsHostInterfaceBase>;
using WorkletDevToolsHostAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<WorkletDevToolsHostInterfaceBase>;


class WorkletGlobalScopeCreationParamsDataView {
 public:
  WorkletGlobalScopeCreationParamsDataView() = default;

  WorkletGlobalScopeCreationParamsDataView(
      internal::WorkletGlobalScopeCreationParams_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  inline void GetScriptUrlDataView(
      ::url::mojom::UrlDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadScriptUrl(UserType* output) {
    
    auto* pointer = data_->script_url.Get();
    return mojo::internal::Deserialize<::url::mojom::UrlDataView>(
        pointer, output, message_);
  }
  inline void GetDevtoolsTokenDataView(
      ::mojo_base::mojom::UnguessableTokenDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadDevtoolsToken(UserType* output) {
    
    auto* pointer = data_->devtools_token.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::UnguessableTokenDataView>(
        pointer, output, message_);
  }
  template <typename UserType>
  UserType TakeDevtoolsHost() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<mojo::InterfacePtrDataView<::blink::mojom::WorkletDevToolsHostInterfaceBase>>(
            &data_->devtools_host, &result, message_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::WorkletGlobalScopeCreationParams_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};


}  // blink::mojom

namespace std {

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::WorkletGlobalScopeCreationParamsDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::WorkletGlobalScopeCreationParamsDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::blink::mojom::internal::WorkletGlobalScopeCreationParams_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::script_url(input)) in_script_url = Traits::script_url(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->script_url)::BaseType> script_url_fragment(
            fragment.message());
    mojo::internal::Serialize<::url::mojom::UrlDataView>(
        in_script_url, script_url_fragment);
    fragment->script_url.Set(
        script_url_fragment.is_null() ? nullptr : script_url_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->script_url.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null script_url in WorkletGlobalScopeCreationParams struct");
    decltype(Traits::devtools_token(input)) in_devtools_token = Traits::devtools_token(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->devtools_token)::BaseType> devtools_token_fragment(
            fragment.message());
    mojo::internal::Serialize<::mojo_base::mojom::UnguessableTokenDataView>(
        in_devtools_token, devtools_token_fragment);
    fragment->devtools_token.Set(
        devtools_token_fragment.is_null() ? nullptr : devtools_token_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->devtools_token.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null devtools_token in WorkletGlobalScopeCreationParams struct");
    decltype(Traits::devtools_host(input)) in_devtools_host = Traits::devtools_host(input);
    mojo::internal::Serialize<mojo::InterfacePtrDataView<::blink::mojom::WorkletDevToolsHostInterfaceBase>>(
        in_devtools_host, &fragment->devtools_host, &fragment.message());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        !mojo::internal::IsHandleOrInterfaceValid(fragment->devtools_host),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
        "invalid devtools_host in WorkletGlobalScopeCreationParams struct");
  }

  static bool Deserialize(::blink::mojom::internal::WorkletGlobalScopeCreationParams_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::WorkletGlobalScopeCreationParamsDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace blink::mojom {

inline void WorkletGlobalScopeCreationParamsDataView::GetScriptUrlDataView(
    ::url::mojom::UrlDataView* output) {
  auto pointer = data_->script_url.Get();
  *output = ::url::mojom::UrlDataView(pointer, message_);
}
inline void WorkletGlobalScopeCreationParamsDataView::GetDevtoolsTokenDataView(
    ::mojo_base::mojom::UnguessableTokenDataView* output) {
  auto pointer = data_->devtools_token.Get();
  *output = ::mojo_base::mojom::UnguessableTokenDataView(pointer, message_);
}



}  // blink::mojom

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_WORKER_WORKLET_GLOBAL_SCOPE_CREATION_PARAMS_MOJOM_SHARED_H_